#include "RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h"

#ifdef __CINT__
#ifndef LUMIRAWDATA_ROOTSCHEMA_LINKDEF
#define LUMIRAWDATA_ROOTSCHEMA_LINKDEF

#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;

#pragma link C++ nestedclasses;
#pragma link C++ nestedtypedefs;

#pragma link C++ namespace HCAL_HLX;

#pragma link C++ struct HCAL_HLX::DAQ_HEART_BEAT+;
#pragma link C++ struct HCAL_HLX::RUN_QUALITY+;

#pragma link C++ struct HCAL_HLX::LUMI_SECTION+;
#pragma link C++ struct HCAL_HLX::LUMI_SECTION_HEADER+;
#pragma link C++ struct HCAL_HLX::LUMI_SECTION_SUB_HEADER+;
#pragma link C++ struct HCAL_HLX::LUMI_NIBBLE_HEADER+;
#pragma link C++ struct HCAL_HLX::LUMI_RAW_HEADER+;

#pragma link C++ struct HCAL_HLX::ET_SUM_SECTION+;
#pragma link C++ struct HCAL_HLX::ET_SUM_NIBBLE+;
#pragma link C++ struct HCAL_HLX::OCCUPANCY_SECTION+;
#pragma link C++ struct HCAL_HLX::OCCUPANCY_NIBBLE+;

#pragma link C++ struct HCAL_HLX::LHC_SECTION+;
#pragma link C++ struct HCAL_HLX::LHC_BEAM_MODE_DATA+;
#pragma link C++ struct HCAL_HLX::LHC_BEAM_ENERGY_DATA+;
#pragma link C++ struct HCAL_HLX::LHC_NIBBLE+;

#pragma link C++ struct HCAL_HLX::LUMI_SUMMARY+;
#pragma link C++ struct HCAL_HLX::LUMI_DETAIL+;
#pragma link C++ struct HCAL_HLX::CMS_LUMI_DIP_DATA+;
#pragma link C++ struct HCAL_HLX::TRIGGER_LUMI_SEGMENT+;

#pragma link C++ struct HCAL_HLX::RCMS_CONFIG+;
#pragma link C++ struct HCAL_HLX::RUN_SUMMARY+;

#pragma link C++ struct HCAL_HLX::HLTRIGGER+;
#pragma link C++ struct HCAL_HLX::HLT_PATH+;
#pragma link C++ struct HCAL_HLX::LEVEL1_PATH+;
#pragma link C++ struct HCAL_HLX::LEVEL1_TRIGGER+;

#pragma link C++ struct HCAL_HLX::VDM_SCAN_DATA+;
#pragma link C++ struct HCAL_HLX::BRAN_DATA+;
#pragma link C++ struct HCAL_HLX::BRAN_BX_DATA+;
#pragma link C++ struct HCAL_HLX::LHC_BEAM_CONFIG+;
#pragma link C++ struct HCAL_HLX::LHC_FILL_DATA+;

#pragma link C++ struct HCAL_HLX::DIP_STRUCT_BASE+;

#pragma link C++ struct HCAL_HLX::LHC_BEAM_MODE_DATA+;
#pragma link C++ struct HCAL_HLX::LHC_BEAM_ENERGY_DATA+;
#pragma link C++ struct HCAL_HLX::LHC_BEAM_INTENSITY_DATA+;
#pragma link C++ struct HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA+;
#pragma link C++ struct HCAL_HLX::BEAM_INFO+;
#pragma link C++ struct HCAL_HLX::BRAN_INFO+;
#pragma link C++ struct HCAL_HLX::BRANA_INFO+;
#pragma link C++ struct HCAL_HLX::BRANP_INFO+;
#pragma link C++ struct HCAL_HLX::DIP_COMBINED_DATA+;

#endif
#endif


//
// File generated by /afs/cern.ch/cms/sw/ReleaseCandidates/vol1/slc6_amd64_gcc490/lcg/root/5.34.18-cms2/bin/rootcint at Thu Jun 19 09:52:07 2014

// Do NOT change. Changes will be lost next time file is generated
//

#define R__DICTIONARY_FILENAME tmpdIslc6_amd64_gcc490dIsrcdIRecoLuminositydILumiProducerdIsrcdIRecoLuminosityLumiProducerdILumiRawDataStructuresLinkDef
#include "RConfig.h" //rootcint 4834
#if !defined(R__ACCESS_IN_SYMBOL)
//Break the privacy of classes -- Disabled for the moment
#define private public
#define protected public
#endif

// Since CINT ignores the std namespace, we need to do so in this file.
namespace std {} using namespace std;
#include "LumiRawDataStructuresLinkDef.h"

#include "TClass.h"
#include "TBuffer.h"
#include "TMemberInspector.h"
#include "TInterpreter.h"
#include "TVirtualMutex.h"
#include "TError.h"

#ifndef G__ROOT
#define G__ROOT
#endif

#include "RtypesImp.h"
#include "TIsAProxy.h"
#include "TFileMergeInfo.h"

// Direct notice to TROOT of the dictionary's loading.
namespace {
   static struct DictInit {
      DictInit() {
         ROOT::RegisterModule();
      }
   } __TheDictionaryInitializer;
}

// START OF SHADOWS

namespace ROOT {
   namespace Shadow {
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::DAQ_HEART_BEAT DAQ_HEART_BEAT;
      #else
      class DAQ_HEART_BEAT  {
         public:
         //friend XX;
         unsigned int runNumber; //
         unsigned int sectionNumber; //
         unsigned int bCMSLive; //
         unsigned int timestamp; //
         unsigned int timestamp_micros; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::RUN_SUMMARY RUN_SUMMARY;
      #else
      class RUN_SUMMARY  {
         public:
         //friend XX;
         char runSequenceName[128]; //
         unsigned int HLTConfigId; //
         unsigned int timestamp; //
         unsigned int timestamp_micros; //
         unsigned int startOrbitNumber; //
         unsigned int endOrbitnumber; //
         unsigned int runNumber; //
         unsigned int fillNumber; //
         unsigned int numberCMSLumiSections; //number of lumi sections from the trigger
         unsigned int numberLumiDAQLumiSections; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::RUN_QUALITY RUN_QUALITY;
      #else
      class RUN_QUALITY  {
         public:
         //friend XX;
         unsigned int runNumber; //
         unsigned int sectionNumber; //
         int HLX; //
         int HFLumi; //
         int ECAL; //
         int HCAL; //
         int Tracker; //
         int RPC; //
         int DT; //
         int CSC; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::RCMS_CONFIG RCMS_CONFIG;
      #else
      class RCMS_CONFIG  {
         public:
         //friend XX;
         unsigned int runNumber; //
         char CMSSW_Tag[32]; //
         char TriDAS_Tag[32]; //
         unsigned int FirmwareVersion; //
         unsigned int ExpectedFirmwareVersion; //
         char AddressTablePath[256]; //
         char CfgDBTag[64]; //
         char CfgDBAccessor[64]; //
         bool UseConfigDB; //
         unsigned int DestIPHigh; //
         unsigned int DestIPLow; //
         unsigned int SrcIPBaseHigh; //
         unsigned int SrcIPBaseLow; //
         unsigned int DestMacAddrHigh; //
         unsigned int DestMacAddrMed; //
         unsigned int DestMacAddrLow; //
         unsigned int SrcMacAddrHigh; //
         unsigned int SrcMacAddrMed; //
         unsigned int SrcMacAddrLow; //
         unsigned int SrcPort; //
         unsigned int DestPort; //
         unsigned int DebugData; //
         unsigned int DebugReadout; //
         unsigned int DebugSingleCycle; //
         unsigned int NumOrbits; //
         unsigned int OrbitPeriod; //
         unsigned int Id; //
         unsigned int TTCBC0Pattern; //
         unsigned int TTCSTARTPattern; //
         unsigned int TTCSTOPPattern; //
         unsigned int BC0Delay; //
         unsigned int OccThresholdLowBottom; //
         unsigned int OccThresholdLowTop; //
         unsigned int OccThresholdHighBottom; //
         unsigned int OccThresholdHighTop; //
         unsigned int LHCThresholdBottom; //
         unsigned int LHCThresholdTop; //
         unsigned int ETSumCutoffBottom; //
         unsigned int ETSumCutoffTop; //
         unsigned int OCCMaskBottom; //
         unsigned int OCCMaskTop; //
         unsigned int LHCMaskLowBottom; //
         unsigned int LHCMaskLowTop; //
         unsigned int LHCMaskHighBottom; //
         unsigned int LHCMaskHighTop; //
         unsigned int SumETMaskLowBottom; //
         unsigned int SumETMaskLowTop; //
         unsigned int SumETMaskHighBottom; //
         unsigned int SumETMaskHighTop; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LUMI_SUMMARY LUMI_SUMMARY;
      #else
      class LUMI_SUMMARY  {
         public:
         //friend XX;
         float DeadTimeNormalization; //
         float LHCNormalization; //recieved from LHC 
         float InstantLumi; //
         float InstantLumiErr; //
         short InstantLumiQlty; //
         float InstantETLumi; //
         float InstantETLumiErr; //
         short InstantETLumiQlty; //
         float ETNormalization; //Calculated
         float InstantOccLumi[2]; //
         float InstantOccLumiErr[2]; //
         short InstantOccLumiQlty[2]; //
         float OccNormalization[2]; //
         float lumiNoise[2]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LUMI_DETAIL LUMI_DETAIL;
      #else
      class LUMI_DETAIL  {
         public:
         //friend XX;
         float LHCLumi[4096]; //Sum of LHC.data over all HLX's
         float ETLumi[4096]; //
         float ETLumiErr[4096]; //
         short ETLumiQlty[4096]; //
         float ETBXNormalization[4096]; //
         float OccLumi[2][4096]; //
         float OccLumiErr[2][4096]; //
         short OccLumiQlty[2][4096]; //
         float OccBXNormalization[2][4096]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LEVEL1_PATH LEVEL1_PATH;
      #else
      class LEVEL1_PATH  {
         public:
         //friend XX;
         char pathName[128]; //
         unsigned long counts; //
         unsigned long prescale; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LEVEL1_TRIGGER LEVEL1_TRIGGER;
      #else
      class LEVEL1_TRIGGER  {
         public:
         //friend XX;
         unsigned int runNumber; //
         unsigned int sectionNumber; //Lumi section number recorded by the daq.
         unsigned int timestamp; //
         unsigned int timestamp_micros; //
         unsigned long deadtimecount; //
         char GTLumiInfoFormat[32]; //
         ::HCAL_HLX::LEVEL1_PATH GTAlgo[128]; //
         ::HCAL_HLX::LEVEL1_PATH GTTech[64]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::HLT_PATH HLT_PATH;
      #else
      class HLT_PATH  {
         public:
         //friend XX;
         char PathName[128]; //This is the name of trigger path
         unsigned int L1Pass; //Number of times the path was entered
         unsigned int PSPass; //Number after prescaling
         unsigned int PAccept; //Number of accepts by the trigger path
         unsigned int PExcept; //Number of exceptional event encountered
         unsigned int PReject; //
         char PrescalerModule[64]; //Name of the prescale module in the path
         unsigned int PSIndex; //Index into the set of pre defined prescales
         unsigned int Prescale; //
         unsigned int HLTConfigId; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::HLTRIGGER HLTRIGGER;
      #else
      class HLTRIGGER  {
         public:
         //friend XX;
         unsigned int runNumber; //
         unsigned int sectionNumber; //
         unsigned int numPaths; //
         ::HCAL_HLX::HLT_PATH HLTPaths[256]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LUMI_RAW_HEADER LUMI_RAW_HEADER;
      #else
      class LUMI_RAW_HEADER  {
         public:
         //friend XX;
         unsigned short marker; //
         unsigned char hlxID; //
         unsigned char packetID; //
         unsigned int startOrbit; //
         unsigned short numOrbits; //
         unsigned short startBunch; //Starting bunch in this packet
         unsigned short numBunches; //Total number of bunches in histogram
         unsigned char histogramSet; //
         unsigned char histogramSequence; //
         unsigned short allA; //
         unsigned short allF; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LUMI_NIBBLE_HEADER LUMI_NIBBLE_HEADER;
      #else
      class LUMI_NIBBLE_HEADER  {
         public:
         //friend XX;
         unsigned int startOrbit; //
         unsigned short numOrbits; //
         unsigned short numBunches; //Number of bunches histogrammed
         bool bCMSLive; //
         bool bOC0; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::ET_SUM_NIBBLE ET_SUM_NIBBLE;
      #else
      class ET_SUM_NIBBLE  {
         public:
         //friend XX;
         ::HCAL_HLX::LUMI_NIBBLE_HEADER hdr; //
         unsigned int data[4096]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::OCCUPANCY_NIBBLE OCCUPANCY_NIBBLE;
      #else
      class OCCUPANCY_NIBBLE  {
         public:
         //friend XX;
         ::HCAL_HLX::LUMI_NIBBLE_HEADER hdr; //
         unsigned short data[6][4096]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LHC_NIBBLE LHC_NIBBLE;
      #else
      class LHC_NIBBLE  {
         public:
         //friend XX;
         ::HCAL_HLX::LUMI_NIBBLE_HEADER hdr; //
         unsigned short data[4096]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LUMI_SECTION_HEADER LUMI_SECTION_HEADER;
      #else
      class LUMI_SECTION_HEADER  {
         public:
         //friend XX;
         unsigned int timestamp; //
         unsigned int timestamp_micros; //
         unsigned int runNumber; //Run number
         unsigned int sectionNumber; //Section number
         unsigned int startOrbit; //Start orbit of lumi section
         unsigned int numOrbits; //Total number of orbits recorded in lumi section
         unsigned short numBunches; //Total number of bunches (from start of orbit)
         unsigned short numHLXs; //Number of HLXs in lumi section
         bool bCMSLive; //Is CMS taking data?
         bool bOC0; //Was section initialised by an OC0?
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LUMI_SECTION_SUB_HEADER LUMI_SECTION_SUB_HEADER;
      #else
      class LUMI_SECTION_SUB_HEADER  {
         public:
         //friend XX;
         unsigned int numNibbles; //Number of nibbles in this histogram
         bool bIsComplete; //Is this histogram complete (i.e. no missing nibbles)
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::ET_SUM_SECTION ET_SUM_SECTION;
      #else
      class ET_SUM_SECTION  {
         public:
         //friend XX;
         ::HCAL_HLX::LUMI_SECTION_SUB_HEADER hdr; //
         float data[4096]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::OCCUPANCY_SECTION OCCUPANCY_SECTION;
      #else
      class OCCUPANCY_SECTION  {
         public:
         //friend XX;
         ::HCAL_HLX::LUMI_SECTION_SUB_HEADER hdr; //
         unsigned int data[6][4096]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LHC_SECTION LHC_SECTION;
      #else
      class LHC_SECTION  {
         public:
         //friend XX;
         ::HCAL_HLX::LUMI_SECTION_SUB_HEADER hdr; //
         unsigned int data[4096]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LUMI_SECTION LUMI_SECTION;
      #else
      class LUMI_SECTION  {
         public:
         //friend XX;
         ::HCAL_HLX::LUMI_SECTION_HEADER hdr; //
         ::HCAL_HLX::LUMI_SUMMARY lumiSummary; //
         ::HCAL_HLX::LUMI_DETAIL lumiDetail; //
         ::HCAL_HLX::ET_SUM_SECTION etSum[36]; //
         ::HCAL_HLX::OCCUPANCY_SECTION occupancy[36]; //
         ::HCAL_HLX::LHC_SECTION lhc[36]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::DIP_STRUCT_BASE DIP_STRUCT_BASE;
      #else
      class DIP_STRUCT_BASE  {
         public:
         //friend XX;
         int MessageQuality; //
         unsigned int timestamp; //
         unsigned int timestamp_micros; //
         unsigned int runNumber; //
         unsigned int sectionNumber; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::VDM_SCAN_DATA VDM_SCAN_DATA;
      #else
      class VDM_SCAN_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         bool VdmMode; //True when a scan at one of the IPs is imminent, false otherwise
         int IP; //
         bool RecordDataFlag; //True while data for one of the scan points at one of the IPs is being taken, false otherwise   
         double BeamSeparation; //separation in sigma for the scan point  
         bool isXaxis; //true if scanning xaxis, otherwise yaxis is being scanned 
         int Beam; //
         double StepProgress; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::BRAN_DATA BRAN_DATA;
      #else
      class BRAN_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         double MeanCrossingAngle; //
         int AcqMode; //
         double MeanLuminosity; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::BRAN_BX_DATA BRAN_BX_DATA;
      #else
      class BRAN_BX_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         double bunchByBunchLuminosity[3564]; //
         int AcqMode; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LHC_BEAM_CONFIG LHC_BEAM_CONFIG;
      #else
      class LHC_BEAM_CONFIG  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         int beamConfig[3564]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LHC_FILL_DATA LHC_FILL_DATA;
      #else
      class LHC_FILL_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         unsigned int FillNumber; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::CMS_LUMI_DIP_DATA CMS_LUMI_DIP_DATA;
      #else
      class CMS_LUMI_DIP_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         unsigned int numHLXs; //
         unsigned int startOrbit; //
         unsigned int numOrbits; //
         unsigned int numBunches; //
         float instantLumi; //
         float instantLumiErr; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::TRIGGER_LUMI_SEGMENT TRIGGER_LUMI_SEGMENT;
      #else
      class TRIGGER_LUMI_SEGMENT  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         char state[64]; //
         unsigned int deadtime; //
         unsigned int deadtimeBeamActive; //
         unsigned int lumiSegmentNumber; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LHC_BEAM_MODE_DATA LHC_BEAM_MODE_DATA;
      #else
      class LHC_BEAM_MODE_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         char beamMode[64]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LHC_BEAM_ENERGY_DATA LHC_BEAM_ENERGY_DATA;
      #else
      class LHC_BEAM_ENERGY_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         float singleBeamEnergy; //GeV
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA LHC_BEAM_INTENSITY_DATA;
      #else
      class LHC_BEAM_INTENSITY_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         double beamIntensity; //total num protons in beam summed over all bxs
         double primitiveLifetime; //
         unsigned long acqTimeStamp; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA LHC_BEAM_FBCT_INTENSITY_DATA;
      #else
      class LHC_BEAM_FBCT_INTENSITY_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         double bestLifetime; //
         double averageBeamIntensity; //
         float averageBunchIntensities[3564]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::BEAM_INFO BEAM_INFO;
      #else
      class BEAM_INFO  {
         public:
         //friend XX;
         double totalIntensity; //
         double primitiveLifetime; //
         double bestLifeTime; //
         double averageBeamIntensity; //
         float orbitFrequency; //
         float averageBunchIntensities[3564]; //
         int beamConfig[3564]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::BRANA_INFO BRANA_INFO;
      #else
      class BRANA_INFO  {
         public:
         //friend XX;
         double meanCrossingAngle; //
         int acqMode; //
         double meanLuminosity; //
         double bunchByBunchLuminosity[3564]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::BRANP_INFO BRANP_INFO;
      #else
      class BRANP_INFO  {
         public:
         //friend XX;
         double meanCrossingAngle; //
         int acqMode; //
         int counterAcquisition; //
         double meanLuminosity; //
         double meanCrossingAngleError; //
         double meanLuminosityError; //
         double bunchByBunchLuminosity[3564]; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::BRAN_INFO BRAN_INFO;
      #else
      class BRAN_INFO  {
         public:
         //friend XX;
         ::HCAL_HLX::BRANA_INFO branA; //
         ::HCAL_HLX::BRANP_INFO branP; //
      };
      #endif
      } 
      namespace HCAL_HLX {

      #if !(defined(R__ACCESS_IN_SYMBOL) || defined(R__USE_SHADOW_CLASS))
      typedef ::HCAL_HLX::DIP_COMBINED_DATA DIP_COMBINED_DATA;
      #else
      class DIP_COMBINED_DATA  :  public ::HCAL_HLX::DIP_STRUCT_BASE {
         public:
         //friend XX;
         char beamMode[128]; //
         float Energy; //
         unsigned int FillNumber; //
         ::HCAL_HLX::BEAM_INFO Beam[2]; //
         ::HCAL_HLX::BRAN_INFO BRAN4L1; //
         ::HCAL_HLX::BRAN_INFO BRAN4R1; //
         ::HCAL_HLX::BRAN_INFO BRAN4L5; //
         ::HCAL_HLX::BRAN_INFO BRAN4R5; //
         ::HCAL_HLX::VDM_SCAN_DATA VdMScan; //
      };
      #endif
      } 
   } // of namespace Shadow
} // of namespace ROOT
// END OF SHADOWS

namespace HCAL_HLX {
   namespace ROOT {
      inline ::ROOT::TGenericClassInfo *GenerateInitInstance();
      static void HCAL_HLX_Dictionary();

      // Function generating the singleton type initializer
      inline ::ROOT::TGenericClassInfo *GenerateInitInstance()
      {
         static ::ROOT::TGenericClassInfo 
            instance("HCAL_HLX", 0 /*version*/, "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 18,
                     ::ROOT::DefineBehavior((void*)0,(void*)0),
                     &HCAL_HLX_Dictionary, 0);
         return &instance;
      }
      // Insure that the inline function is _not_ optimized away by the compiler
      ::ROOT::TGenericClassInfo *(*_R__UNIQUE_(InitFunctionKeeper))() = &GenerateInitInstance;  
      // Static variable to force the class initialization
      static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstance(); R__UseDummy(_R__UNIQUE_(Init));

      // Dictionary for non-ClassDef classes
      static void HCAL_HLX_Dictionary() {
         GenerateInitInstance()->GetClass();
      }

   }
}

namespace ROOT {
   void HCAL_HLXcLcLDAQ_HEART_BEAT_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLDAQ_HEART_BEAT_Dictionary();
   static void *new_HCAL_HLXcLcLDAQ_HEART_BEAT(void *p = 0);
   static void *newArray_HCAL_HLXcLcLDAQ_HEART_BEAT(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLDAQ_HEART_BEAT(void *p);
   static void deleteArray_HCAL_HLXcLcLDAQ_HEART_BEAT(void *p);
   static void destruct_HCAL_HLXcLcLDAQ_HEART_BEAT(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::DAQ_HEART_BEAT*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::DAQ_HEART_BEAT) == sizeof(::ROOT::Shadow::HCAL_HLX::DAQ_HEART_BEAT));
      ::HCAL_HLX::DAQ_HEART_BEAT *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::DAQ_HEART_BEAT),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::DAQ_HEART_BEAT", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 20,
                  typeid(::HCAL_HLX::DAQ_HEART_BEAT), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLDAQ_HEART_BEAT_ShowMembers, &HCAL_HLXcLcLDAQ_HEART_BEAT_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::DAQ_HEART_BEAT) );
      instance.SetNew(&new_HCAL_HLXcLcLDAQ_HEART_BEAT);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLDAQ_HEART_BEAT);
      instance.SetDelete(&delete_HCAL_HLXcLcLDAQ_HEART_BEAT);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLDAQ_HEART_BEAT);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLDAQ_HEART_BEAT);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::DAQ_HEART_BEAT*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::DAQ_HEART_BEAT*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::DAQ_HEART_BEAT*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLDAQ_HEART_BEAT_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::DAQ_HEART_BEAT*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLRUN_SUMMARY_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLRUN_SUMMARY_Dictionary();
   static void *new_HCAL_HLXcLcLRUN_SUMMARY(void *p = 0);
   static void *newArray_HCAL_HLXcLcLRUN_SUMMARY(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLRUN_SUMMARY(void *p);
   static void deleteArray_HCAL_HLXcLcLRUN_SUMMARY(void *p);
   static void destruct_HCAL_HLXcLcLRUN_SUMMARY(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::RUN_SUMMARY*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::RUN_SUMMARY) == sizeof(::ROOT::Shadow::HCAL_HLX::RUN_SUMMARY));
      ::HCAL_HLX::RUN_SUMMARY *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::RUN_SUMMARY),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::RUN_SUMMARY", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 30,
                  typeid(::HCAL_HLX::RUN_SUMMARY), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLRUN_SUMMARY_ShowMembers, &HCAL_HLXcLcLRUN_SUMMARY_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::RUN_SUMMARY) );
      instance.SetNew(&new_HCAL_HLXcLcLRUN_SUMMARY);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLRUN_SUMMARY);
      instance.SetDelete(&delete_HCAL_HLXcLcLRUN_SUMMARY);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLRUN_SUMMARY);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLRUN_SUMMARY);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::RUN_SUMMARY*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::RUN_SUMMARY*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::RUN_SUMMARY*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLRUN_SUMMARY_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::RUN_SUMMARY*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLRUN_QUALITY_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLRUN_QUALITY_Dictionary();
   static void *new_HCAL_HLXcLcLRUN_QUALITY(void *p = 0);
   static void *newArray_HCAL_HLXcLcLRUN_QUALITY(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLRUN_QUALITY(void *p);
   static void deleteArray_HCAL_HLXcLcLRUN_QUALITY(void *p);
   static void destruct_HCAL_HLXcLcLRUN_QUALITY(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::RUN_QUALITY*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::RUN_QUALITY) == sizeof(::ROOT::Shadow::HCAL_HLX::RUN_QUALITY));
      ::HCAL_HLX::RUN_QUALITY *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::RUN_QUALITY),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::RUN_QUALITY", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 46,
                  typeid(::HCAL_HLX::RUN_QUALITY), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLRUN_QUALITY_ShowMembers, &HCAL_HLXcLcLRUN_QUALITY_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::RUN_QUALITY) );
      instance.SetNew(&new_HCAL_HLXcLcLRUN_QUALITY);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLRUN_QUALITY);
      instance.SetDelete(&delete_HCAL_HLXcLcLRUN_QUALITY);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLRUN_QUALITY);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLRUN_QUALITY);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::RUN_QUALITY*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::RUN_QUALITY*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::RUN_QUALITY*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLRUN_QUALITY_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::RUN_QUALITY*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLRCMS_CONFIG_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLRCMS_CONFIG_Dictionary();
   static void *new_HCAL_HLXcLcLRCMS_CONFIG(void *p = 0);
   static void *newArray_HCAL_HLXcLcLRCMS_CONFIG(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLRCMS_CONFIG(void *p);
   static void deleteArray_HCAL_HLXcLcLRCMS_CONFIG(void *p);
   static void destruct_HCAL_HLXcLcLRCMS_CONFIG(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::RCMS_CONFIG*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::RCMS_CONFIG) == sizeof(::ROOT::Shadow::HCAL_HLX::RCMS_CONFIG));
      ::HCAL_HLX::RCMS_CONFIG *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::RCMS_CONFIG),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::RCMS_CONFIG", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 60,
                  typeid(::HCAL_HLX::RCMS_CONFIG), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLRCMS_CONFIG_ShowMembers, &HCAL_HLXcLcLRCMS_CONFIG_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::RCMS_CONFIG) );
      instance.SetNew(&new_HCAL_HLXcLcLRCMS_CONFIG);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLRCMS_CONFIG);
      instance.SetDelete(&delete_HCAL_HLXcLcLRCMS_CONFIG);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLRCMS_CONFIG);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLRCMS_CONFIG);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::RCMS_CONFIG*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::RCMS_CONFIG*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::RCMS_CONFIG*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLRCMS_CONFIG_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::RCMS_CONFIG*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLUMI_SUMMARY_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLUMI_SUMMARY_Dictionary();
   static void *new_HCAL_HLXcLcLLUMI_SUMMARY(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLUMI_SUMMARY(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLUMI_SUMMARY(void *p);
   static void deleteArray_HCAL_HLXcLcLLUMI_SUMMARY(void *p);
   static void destruct_HCAL_HLXcLcLLUMI_SUMMARY(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LUMI_SUMMARY*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LUMI_SUMMARY) == sizeof(::ROOT::Shadow::HCAL_HLX::LUMI_SUMMARY));
      ::HCAL_HLX::LUMI_SUMMARY *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LUMI_SUMMARY),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LUMI_SUMMARY", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 132,
                  typeid(::HCAL_HLX::LUMI_SUMMARY), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLUMI_SUMMARY_ShowMembers, &HCAL_HLXcLcLLUMI_SUMMARY_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LUMI_SUMMARY) );
      instance.SetNew(&new_HCAL_HLXcLcLLUMI_SUMMARY);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLUMI_SUMMARY);
      instance.SetDelete(&delete_HCAL_HLXcLcLLUMI_SUMMARY);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLUMI_SUMMARY);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLUMI_SUMMARY);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LUMI_SUMMARY*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LUMI_SUMMARY*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SUMMARY*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLUMI_SUMMARY_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SUMMARY*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLUMI_DETAIL_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLUMI_DETAIL_Dictionary();
   static void *new_HCAL_HLXcLcLLUMI_DETAIL(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLUMI_DETAIL(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLUMI_DETAIL(void *p);
   static void deleteArray_HCAL_HLXcLcLLUMI_DETAIL(void *p);
   static void destruct_HCAL_HLXcLcLLUMI_DETAIL(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LUMI_DETAIL*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LUMI_DETAIL) == sizeof(::ROOT::Shadow::HCAL_HLX::LUMI_DETAIL));
      ::HCAL_HLX::LUMI_DETAIL *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LUMI_DETAIL),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LUMI_DETAIL", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 154,
                  typeid(::HCAL_HLX::LUMI_DETAIL), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLUMI_DETAIL_ShowMembers, &HCAL_HLXcLcLLUMI_DETAIL_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LUMI_DETAIL) );
      instance.SetNew(&new_HCAL_HLXcLcLLUMI_DETAIL);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLUMI_DETAIL);
      instance.SetDelete(&delete_HCAL_HLXcLcLLUMI_DETAIL);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLUMI_DETAIL);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLUMI_DETAIL);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LUMI_DETAIL*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LUMI_DETAIL*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_DETAIL*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLUMI_DETAIL_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_DETAIL*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLEVEL1_PATH_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLEVEL1_PATH_Dictionary();
   static void *new_HCAL_HLXcLcLLEVEL1_PATH(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLEVEL1_PATH(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLEVEL1_PATH(void *p);
   static void deleteArray_HCAL_HLXcLcLLEVEL1_PATH(void *p);
   static void destruct_HCAL_HLXcLcLLEVEL1_PATH(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LEVEL1_PATH*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LEVEL1_PATH) == sizeof(::ROOT::Shadow::HCAL_HLX::LEVEL1_PATH));
      ::HCAL_HLX::LEVEL1_PATH *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LEVEL1_PATH),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LEVEL1_PATH", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 171,
                  typeid(::HCAL_HLX::LEVEL1_PATH), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLEVEL1_PATH_ShowMembers, &HCAL_HLXcLcLLEVEL1_PATH_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LEVEL1_PATH) );
      instance.SetNew(&new_HCAL_HLXcLcLLEVEL1_PATH);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLEVEL1_PATH);
      instance.SetDelete(&delete_HCAL_HLXcLcLLEVEL1_PATH);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLEVEL1_PATH);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLEVEL1_PATH);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LEVEL1_PATH*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LEVEL1_PATH*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LEVEL1_PATH*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLEVEL1_PATH_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LEVEL1_PATH*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLEVEL1_TRIGGER_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLEVEL1_TRIGGER_Dictionary();
   static void *new_HCAL_HLXcLcLLEVEL1_TRIGGER(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLEVEL1_TRIGGER(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLEVEL1_TRIGGER(void *p);
   static void deleteArray_HCAL_HLXcLcLLEVEL1_TRIGGER(void *p);
   static void destruct_HCAL_HLXcLcLLEVEL1_TRIGGER(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LEVEL1_TRIGGER*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LEVEL1_TRIGGER) == sizeof(::ROOT::Shadow::HCAL_HLX::LEVEL1_TRIGGER));
      ::HCAL_HLX::LEVEL1_TRIGGER *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LEVEL1_TRIGGER),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LEVEL1_TRIGGER", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 178,
                  typeid(::HCAL_HLX::LEVEL1_TRIGGER), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLEVEL1_TRIGGER_ShowMembers, &HCAL_HLXcLcLLEVEL1_TRIGGER_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LEVEL1_TRIGGER) );
      instance.SetNew(&new_HCAL_HLXcLcLLEVEL1_TRIGGER);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLEVEL1_TRIGGER);
      instance.SetDelete(&delete_HCAL_HLXcLcLLEVEL1_TRIGGER);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLEVEL1_TRIGGER);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLEVEL1_TRIGGER);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LEVEL1_TRIGGER*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LEVEL1_TRIGGER*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LEVEL1_TRIGGER*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLEVEL1_TRIGGER_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LEVEL1_TRIGGER*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLHLT_PATH_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLHLT_PATH_Dictionary();
   static void *new_HCAL_HLXcLcLHLT_PATH(void *p = 0);
   static void *newArray_HCAL_HLXcLcLHLT_PATH(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLHLT_PATH(void *p);
   static void deleteArray_HCAL_HLXcLcLHLT_PATH(void *p);
   static void destruct_HCAL_HLXcLcLHLT_PATH(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::HLT_PATH*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::HLT_PATH) == sizeof(::ROOT::Shadow::HCAL_HLX::HLT_PATH));
      ::HCAL_HLX::HLT_PATH *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::HLT_PATH),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::HLT_PATH", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 193,
                  typeid(::HCAL_HLX::HLT_PATH), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLHLT_PATH_ShowMembers, &HCAL_HLXcLcLHLT_PATH_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::HLT_PATH) );
      instance.SetNew(&new_HCAL_HLXcLcLHLT_PATH);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLHLT_PATH);
      instance.SetDelete(&delete_HCAL_HLXcLcLHLT_PATH);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLHLT_PATH);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLHLT_PATH);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::HLT_PATH*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::HLT_PATH*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::HLT_PATH*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLHLT_PATH_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::HLT_PATH*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLHLTRIGGER_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLHLTRIGGER_Dictionary();
   static void *new_HCAL_HLXcLcLHLTRIGGER(void *p = 0);
   static void *newArray_HCAL_HLXcLcLHLTRIGGER(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLHLTRIGGER(void *p);
   static void deleteArray_HCAL_HLXcLcLHLTRIGGER(void *p);
   static void destruct_HCAL_HLXcLcLHLTRIGGER(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::HLTRIGGER*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::HLTRIGGER) == sizeof(::ROOT::Shadow::HCAL_HLX::HLTRIGGER));
      ::HCAL_HLX::HLTRIGGER *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::HLTRIGGER),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::HLTRIGGER", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 207,
                  typeid(::HCAL_HLX::HLTRIGGER), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLHLTRIGGER_ShowMembers, &HCAL_HLXcLcLHLTRIGGER_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::HLTRIGGER) );
      instance.SetNew(&new_HCAL_HLXcLcLHLTRIGGER);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLHLTRIGGER);
      instance.SetDelete(&delete_HCAL_HLXcLcLHLTRIGGER);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLHLTRIGGER);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLHLTRIGGER);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::HLTRIGGER*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::HLTRIGGER*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::HLTRIGGER*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLHLTRIGGER_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::HLTRIGGER*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLUMI_RAW_HEADER_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLUMI_RAW_HEADER_Dictionary();
   static void *new_HCAL_HLXcLcLLUMI_RAW_HEADER(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLUMI_RAW_HEADER(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLUMI_RAW_HEADER(void *p);
   static void deleteArray_HCAL_HLXcLcLLUMI_RAW_HEADER(void *p);
   static void destruct_HCAL_HLXcLcLLUMI_RAW_HEADER(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LUMI_RAW_HEADER*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LUMI_RAW_HEADER) == sizeof(::ROOT::Shadow::HCAL_HLX::LUMI_RAW_HEADER));
      ::HCAL_HLX::LUMI_RAW_HEADER *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LUMI_RAW_HEADER),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LUMI_RAW_HEADER", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 216,
                  typeid(::HCAL_HLX::LUMI_RAW_HEADER), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLUMI_RAW_HEADER_ShowMembers, &HCAL_HLXcLcLLUMI_RAW_HEADER_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LUMI_RAW_HEADER) );
      instance.SetNew(&new_HCAL_HLXcLcLLUMI_RAW_HEADER);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLUMI_RAW_HEADER);
      instance.SetDelete(&delete_HCAL_HLXcLcLLUMI_RAW_HEADER);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLUMI_RAW_HEADER);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLUMI_RAW_HEADER);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LUMI_RAW_HEADER*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LUMI_RAW_HEADER*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_RAW_HEADER*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLUMI_RAW_HEADER_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_RAW_HEADER*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLUMI_NIBBLE_HEADER_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLUMI_NIBBLE_HEADER_Dictionary();
   static void *new_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(void *p);
   static void deleteArray_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(void *p);
   static void destruct_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LUMI_NIBBLE_HEADER*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LUMI_NIBBLE_HEADER) == sizeof(::ROOT::Shadow::HCAL_HLX::LUMI_NIBBLE_HEADER));
      ::HCAL_HLX::LUMI_NIBBLE_HEADER *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LUMI_NIBBLE_HEADER),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LUMI_NIBBLE_HEADER", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 230,
                  typeid(::HCAL_HLX::LUMI_NIBBLE_HEADER), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLUMI_NIBBLE_HEADER_ShowMembers, &HCAL_HLXcLcLLUMI_NIBBLE_HEADER_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LUMI_NIBBLE_HEADER) );
      instance.SetNew(&new_HCAL_HLXcLcLLUMI_NIBBLE_HEADER);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLUMI_NIBBLE_HEADER);
      instance.SetDelete(&delete_HCAL_HLXcLcLLUMI_NIBBLE_HEADER);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLUMI_NIBBLE_HEADER);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLUMI_NIBBLE_HEADER);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LUMI_NIBBLE_HEADER*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LUMI_NIBBLE_HEADER*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_NIBBLE_HEADER*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLUMI_NIBBLE_HEADER_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_NIBBLE_HEADER*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLET_SUM_NIBBLE_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLET_SUM_NIBBLE_Dictionary();
   static void *new_HCAL_HLXcLcLET_SUM_NIBBLE(void *p = 0);
   static void *newArray_HCAL_HLXcLcLET_SUM_NIBBLE(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLET_SUM_NIBBLE(void *p);
   static void deleteArray_HCAL_HLXcLcLET_SUM_NIBBLE(void *p);
   static void destruct_HCAL_HLXcLcLET_SUM_NIBBLE(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::ET_SUM_NIBBLE*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::ET_SUM_NIBBLE) == sizeof(::ROOT::Shadow::HCAL_HLX::ET_SUM_NIBBLE));
      ::HCAL_HLX::ET_SUM_NIBBLE *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::ET_SUM_NIBBLE),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::ET_SUM_NIBBLE", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 238,
                  typeid(::HCAL_HLX::ET_SUM_NIBBLE), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLET_SUM_NIBBLE_ShowMembers, &HCAL_HLXcLcLET_SUM_NIBBLE_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::ET_SUM_NIBBLE) );
      instance.SetNew(&new_HCAL_HLXcLcLET_SUM_NIBBLE);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLET_SUM_NIBBLE);
      instance.SetDelete(&delete_HCAL_HLXcLcLET_SUM_NIBBLE);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLET_SUM_NIBBLE);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLET_SUM_NIBBLE);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::ET_SUM_NIBBLE*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::ET_SUM_NIBBLE*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::ET_SUM_NIBBLE*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLET_SUM_NIBBLE_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::ET_SUM_NIBBLE*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLOCCUPANCY_NIBBLE_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLOCCUPANCY_NIBBLE_Dictionary();
   static void *new_HCAL_HLXcLcLOCCUPANCY_NIBBLE(void *p = 0);
   static void *newArray_HCAL_HLXcLcLOCCUPANCY_NIBBLE(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLOCCUPANCY_NIBBLE(void *p);
   static void deleteArray_HCAL_HLXcLcLOCCUPANCY_NIBBLE(void *p);
   static void destruct_HCAL_HLXcLcLOCCUPANCY_NIBBLE(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::OCCUPANCY_NIBBLE*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::OCCUPANCY_NIBBLE) == sizeof(::ROOT::Shadow::HCAL_HLX::OCCUPANCY_NIBBLE));
      ::HCAL_HLX::OCCUPANCY_NIBBLE *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::OCCUPANCY_NIBBLE),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::OCCUPANCY_NIBBLE", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 243,
                  typeid(::HCAL_HLX::OCCUPANCY_NIBBLE), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLOCCUPANCY_NIBBLE_ShowMembers, &HCAL_HLXcLcLOCCUPANCY_NIBBLE_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::OCCUPANCY_NIBBLE) );
      instance.SetNew(&new_HCAL_HLXcLcLOCCUPANCY_NIBBLE);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLOCCUPANCY_NIBBLE);
      instance.SetDelete(&delete_HCAL_HLXcLcLOCCUPANCY_NIBBLE);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLOCCUPANCY_NIBBLE);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLOCCUPANCY_NIBBLE);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::OCCUPANCY_NIBBLE*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::OCCUPANCY_NIBBLE*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::OCCUPANCY_NIBBLE*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLOCCUPANCY_NIBBLE_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::OCCUPANCY_NIBBLE*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLHC_NIBBLE_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLHC_NIBBLE_Dictionary();
   static void *new_HCAL_HLXcLcLLHC_NIBBLE(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLHC_NIBBLE(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLHC_NIBBLE(void *p);
   static void deleteArray_HCAL_HLXcLcLLHC_NIBBLE(void *p);
   static void destruct_HCAL_HLXcLcLLHC_NIBBLE(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LHC_NIBBLE*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LHC_NIBBLE) == sizeof(::ROOT::Shadow::HCAL_HLX::LHC_NIBBLE));
      ::HCAL_HLX::LHC_NIBBLE *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LHC_NIBBLE),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LHC_NIBBLE", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 248,
                  typeid(::HCAL_HLX::LHC_NIBBLE), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLHC_NIBBLE_ShowMembers, &HCAL_HLXcLcLLHC_NIBBLE_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LHC_NIBBLE) );
      instance.SetNew(&new_HCAL_HLXcLcLLHC_NIBBLE);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLHC_NIBBLE);
      instance.SetDelete(&delete_HCAL_HLXcLcLLHC_NIBBLE);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLHC_NIBBLE);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLHC_NIBBLE);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LHC_NIBBLE*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LHC_NIBBLE*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_NIBBLE*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLHC_NIBBLE_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_NIBBLE*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLUMI_SECTION_HEADER_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLUMI_SECTION_HEADER_Dictionary();
   static void *new_HCAL_HLXcLcLLUMI_SECTION_HEADER(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLUMI_SECTION_HEADER(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLUMI_SECTION_HEADER(void *p);
   static void deleteArray_HCAL_HLXcLcLLUMI_SECTION_HEADER(void *p);
   static void destruct_HCAL_HLXcLcLLUMI_SECTION_HEADER(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LUMI_SECTION_HEADER*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LUMI_SECTION_HEADER) == sizeof(::ROOT::Shadow::HCAL_HLX::LUMI_SECTION_HEADER));
      ::HCAL_HLX::LUMI_SECTION_HEADER *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LUMI_SECTION_HEADER),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LUMI_SECTION_HEADER", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 255,
                  typeid(::HCAL_HLX::LUMI_SECTION_HEADER), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLUMI_SECTION_HEADER_ShowMembers, &HCAL_HLXcLcLLUMI_SECTION_HEADER_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LUMI_SECTION_HEADER) );
      instance.SetNew(&new_HCAL_HLXcLcLLUMI_SECTION_HEADER);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLUMI_SECTION_HEADER);
      instance.SetDelete(&delete_HCAL_HLXcLcLLUMI_SECTION_HEADER);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLUMI_SECTION_HEADER);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLUMI_SECTION_HEADER);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LUMI_SECTION_HEADER*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LUMI_SECTION_HEADER*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION_HEADER*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLUMI_SECTION_HEADER_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION_HEADER*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER_Dictionary();
   static void *new_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void *p);
   static void deleteArray_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void *p);
   static void destruct_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LUMI_SECTION_SUB_HEADER*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LUMI_SECTION_SUB_HEADER) == sizeof(::ROOT::Shadow::HCAL_HLX::LUMI_SECTION_SUB_HEADER));
      ::HCAL_HLX::LUMI_SECTION_SUB_HEADER *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LUMI_SECTION_SUB_HEADER),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LUMI_SECTION_SUB_HEADER", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 271,
                  typeid(::HCAL_HLX::LUMI_SECTION_SUB_HEADER), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER_ShowMembers, &HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LUMI_SECTION_SUB_HEADER) );
      instance.SetNew(&new_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER);
      instance.SetDelete(&delete_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LUMI_SECTION_SUB_HEADER*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LUMI_SECTION_SUB_HEADER*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION_SUB_HEADER*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION_SUB_HEADER*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLET_SUM_SECTION_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLET_SUM_SECTION_Dictionary();
   static void *new_HCAL_HLXcLcLET_SUM_SECTION(void *p = 0);
   static void *newArray_HCAL_HLXcLcLET_SUM_SECTION(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLET_SUM_SECTION(void *p);
   static void deleteArray_HCAL_HLXcLcLET_SUM_SECTION(void *p);
   static void destruct_HCAL_HLXcLcLET_SUM_SECTION(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::ET_SUM_SECTION*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::ET_SUM_SECTION) == sizeof(::ROOT::Shadow::HCAL_HLX::ET_SUM_SECTION));
      ::HCAL_HLX::ET_SUM_SECTION *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::ET_SUM_SECTION),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::ET_SUM_SECTION", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 276,
                  typeid(::HCAL_HLX::ET_SUM_SECTION), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLET_SUM_SECTION_ShowMembers, &HCAL_HLXcLcLET_SUM_SECTION_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::ET_SUM_SECTION) );
      instance.SetNew(&new_HCAL_HLXcLcLET_SUM_SECTION);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLET_SUM_SECTION);
      instance.SetDelete(&delete_HCAL_HLXcLcLET_SUM_SECTION);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLET_SUM_SECTION);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLET_SUM_SECTION);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::ET_SUM_SECTION*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::ET_SUM_SECTION*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::ET_SUM_SECTION*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLET_SUM_SECTION_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::ET_SUM_SECTION*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLOCCUPANCY_SECTION_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLOCCUPANCY_SECTION_Dictionary();
   static void *new_HCAL_HLXcLcLOCCUPANCY_SECTION(void *p = 0);
   static void *newArray_HCAL_HLXcLcLOCCUPANCY_SECTION(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLOCCUPANCY_SECTION(void *p);
   static void deleteArray_HCAL_HLXcLcLOCCUPANCY_SECTION(void *p);
   static void destruct_HCAL_HLXcLcLOCCUPANCY_SECTION(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::OCCUPANCY_SECTION*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::OCCUPANCY_SECTION) == sizeof(::ROOT::Shadow::HCAL_HLX::OCCUPANCY_SECTION));
      ::HCAL_HLX::OCCUPANCY_SECTION *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::OCCUPANCY_SECTION),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::OCCUPANCY_SECTION", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 281,
                  typeid(::HCAL_HLX::OCCUPANCY_SECTION), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLOCCUPANCY_SECTION_ShowMembers, &HCAL_HLXcLcLOCCUPANCY_SECTION_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::OCCUPANCY_SECTION) );
      instance.SetNew(&new_HCAL_HLXcLcLOCCUPANCY_SECTION);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLOCCUPANCY_SECTION);
      instance.SetDelete(&delete_HCAL_HLXcLcLOCCUPANCY_SECTION);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLOCCUPANCY_SECTION);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLOCCUPANCY_SECTION);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::OCCUPANCY_SECTION*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::OCCUPANCY_SECTION*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::OCCUPANCY_SECTION*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLOCCUPANCY_SECTION_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::OCCUPANCY_SECTION*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLHC_SECTION_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLHC_SECTION_Dictionary();
   static void *new_HCAL_HLXcLcLLHC_SECTION(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLHC_SECTION(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLHC_SECTION(void *p);
   static void deleteArray_HCAL_HLXcLcLLHC_SECTION(void *p);
   static void destruct_HCAL_HLXcLcLLHC_SECTION(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LHC_SECTION*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LHC_SECTION) == sizeof(::ROOT::Shadow::HCAL_HLX::LHC_SECTION));
      ::HCAL_HLX::LHC_SECTION *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LHC_SECTION),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LHC_SECTION", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 286,
                  typeid(::HCAL_HLX::LHC_SECTION), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLHC_SECTION_ShowMembers, &HCAL_HLXcLcLLHC_SECTION_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LHC_SECTION) );
      instance.SetNew(&new_HCAL_HLXcLcLLHC_SECTION);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLHC_SECTION);
      instance.SetDelete(&delete_HCAL_HLXcLcLLHC_SECTION);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLHC_SECTION);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLHC_SECTION);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LHC_SECTION*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LHC_SECTION*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_SECTION*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLHC_SECTION_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_SECTION*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLUMI_SECTION_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLUMI_SECTION_Dictionary();
   static void *new_HCAL_HLXcLcLLUMI_SECTION(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLUMI_SECTION(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLUMI_SECTION(void *p);
   static void deleteArray_HCAL_HLXcLcLLUMI_SECTION(void *p);
   static void destruct_HCAL_HLXcLcLLUMI_SECTION(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LUMI_SECTION*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LUMI_SECTION) == sizeof(::ROOT::Shadow::HCAL_HLX::LUMI_SECTION));
      ::HCAL_HLX::LUMI_SECTION *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LUMI_SECTION),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LUMI_SECTION", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 291,
                  typeid(::HCAL_HLX::LUMI_SECTION), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLUMI_SECTION_ShowMembers, &HCAL_HLXcLcLLUMI_SECTION_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LUMI_SECTION) );
      instance.SetNew(&new_HCAL_HLXcLcLLUMI_SECTION);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLUMI_SECTION);
      instance.SetDelete(&delete_HCAL_HLXcLcLLUMI_SECTION);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLUMI_SECTION);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLUMI_SECTION);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LUMI_SECTION*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LUMI_SECTION*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLUMI_SECTION_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLDIP_STRUCT_BASE_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLDIP_STRUCT_BASE_Dictionary();
   static void *new_HCAL_HLXcLcLDIP_STRUCT_BASE(void *p = 0);
   static void *newArray_HCAL_HLXcLcLDIP_STRUCT_BASE(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLDIP_STRUCT_BASE(void *p);
   static void deleteArray_HCAL_HLXcLcLDIP_STRUCT_BASE(void *p);
   static void destruct_HCAL_HLXcLcLDIP_STRUCT_BASE(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::DIP_STRUCT_BASE*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::DIP_STRUCT_BASE) == sizeof(::ROOT::Shadow::HCAL_HLX::DIP_STRUCT_BASE));
      ::HCAL_HLX::DIP_STRUCT_BASE *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::DIP_STRUCT_BASE),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::DIP_STRUCT_BASE", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 301,
                  typeid(::HCAL_HLX::DIP_STRUCT_BASE), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLDIP_STRUCT_BASE_ShowMembers, &HCAL_HLXcLcLDIP_STRUCT_BASE_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::DIP_STRUCT_BASE) );
      instance.SetNew(&new_HCAL_HLXcLcLDIP_STRUCT_BASE);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLDIP_STRUCT_BASE);
      instance.SetDelete(&delete_HCAL_HLXcLcLDIP_STRUCT_BASE);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLDIP_STRUCT_BASE);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLDIP_STRUCT_BASE);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::DIP_STRUCT_BASE*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::DIP_STRUCT_BASE*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::DIP_STRUCT_BASE*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLDIP_STRUCT_BASE_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::DIP_STRUCT_BASE*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLVDM_SCAN_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLVDM_SCAN_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLVDM_SCAN_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLVDM_SCAN_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLVDM_SCAN_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLVDM_SCAN_DATA(void *p);
   static void destruct_HCAL_HLXcLcLVDM_SCAN_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::VDM_SCAN_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::VDM_SCAN_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::VDM_SCAN_DATA));
      ::HCAL_HLX::VDM_SCAN_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::VDM_SCAN_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::VDM_SCAN_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 309,
                  typeid(::HCAL_HLX::VDM_SCAN_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLVDM_SCAN_DATA_ShowMembers, &HCAL_HLXcLcLVDM_SCAN_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::VDM_SCAN_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLVDM_SCAN_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLVDM_SCAN_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLVDM_SCAN_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLVDM_SCAN_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLVDM_SCAN_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::VDM_SCAN_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::VDM_SCAN_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::VDM_SCAN_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLVDM_SCAN_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::VDM_SCAN_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLBRAN_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLBRAN_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLBRAN_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLBRAN_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLBRAN_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLBRAN_DATA(void *p);
   static void destruct_HCAL_HLXcLcLBRAN_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::BRAN_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::BRAN_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::BRAN_DATA));
      ::HCAL_HLX::BRAN_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::BRAN_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::BRAN_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 319,
                  typeid(::HCAL_HLX::BRAN_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLBRAN_DATA_ShowMembers, &HCAL_HLXcLcLBRAN_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::BRAN_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLBRAN_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLBRAN_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLBRAN_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLBRAN_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLBRAN_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::BRAN_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::BRAN_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLBRAN_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLBRAN_BX_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLBRAN_BX_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLBRAN_BX_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLBRAN_BX_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLBRAN_BX_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLBRAN_BX_DATA(void *p);
   static void destruct_HCAL_HLXcLcLBRAN_BX_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::BRAN_BX_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::BRAN_BX_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::BRAN_BX_DATA));
      ::HCAL_HLX::BRAN_BX_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::BRAN_BX_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::BRAN_BX_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 325,
                  typeid(::HCAL_HLX::BRAN_BX_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLBRAN_BX_DATA_ShowMembers, &HCAL_HLXcLcLBRAN_BX_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::BRAN_BX_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLBRAN_BX_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLBRAN_BX_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLBRAN_BX_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLBRAN_BX_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLBRAN_BX_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::BRAN_BX_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::BRAN_BX_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_BX_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLBRAN_BX_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_BX_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_CONFIG_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLHC_BEAM_CONFIG_Dictionary();
   static void *new_HCAL_HLXcLcLLHC_BEAM_CONFIG(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_CONFIG(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLHC_BEAM_CONFIG(void *p);
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_CONFIG(void *p);
   static void destruct_HCAL_HLXcLcLLHC_BEAM_CONFIG(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LHC_BEAM_CONFIG*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LHC_BEAM_CONFIG) == sizeof(::ROOT::Shadow::HCAL_HLX::LHC_BEAM_CONFIG));
      ::HCAL_HLX::LHC_BEAM_CONFIG *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LHC_BEAM_CONFIG),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LHC_BEAM_CONFIG", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 330,
                  typeid(::HCAL_HLX::LHC_BEAM_CONFIG), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLHC_BEAM_CONFIG_ShowMembers, &HCAL_HLXcLcLLHC_BEAM_CONFIG_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LHC_BEAM_CONFIG) );
      instance.SetNew(&new_HCAL_HLXcLcLLHC_BEAM_CONFIG);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLHC_BEAM_CONFIG);
      instance.SetDelete(&delete_HCAL_HLXcLcLLHC_BEAM_CONFIG);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLHC_BEAM_CONFIG);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLHC_BEAM_CONFIG);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LHC_BEAM_CONFIG*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LHC_BEAM_CONFIG*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_CONFIG*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLHC_BEAM_CONFIG_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_CONFIG*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLHC_FILL_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLHC_FILL_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLLHC_FILL_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLHC_FILL_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLHC_FILL_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLLHC_FILL_DATA(void *p);
   static void destruct_HCAL_HLXcLcLLHC_FILL_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LHC_FILL_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LHC_FILL_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::LHC_FILL_DATA));
      ::HCAL_HLX::LHC_FILL_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LHC_FILL_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LHC_FILL_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 334,
                  typeid(::HCAL_HLX::LHC_FILL_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLHC_FILL_DATA_ShowMembers, &HCAL_HLXcLcLLHC_FILL_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LHC_FILL_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLLHC_FILL_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLHC_FILL_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLLHC_FILL_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLHC_FILL_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLHC_FILL_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LHC_FILL_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LHC_FILL_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_FILL_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLHC_FILL_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_FILL_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLCMS_LUMI_DIP_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLCMS_LUMI_DIP_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(void *p);
   static void destruct_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::CMS_LUMI_DIP_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::CMS_LUMI_DIP_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::CMS_LUMI_DIP_DATA));
      ::HCAL_HLX::CMS_LUMI_DIP_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::CMS_LUMI_DIP_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::CMS_LUMI_DIP_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 339,
                  typeid(::HCAL_HLX::CMS_LUMI_DIP_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLCMS_LUMI_DIP_DATA_ShowMembers, &HCAL_HLXcLcLCMS_LUMI_DIP_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::CMS_LUMI_DIP_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLCMS_LUMI_DIP_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLCMS_LUMI_DIP_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLCMS_LUMI_DIP_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLCMS_LUMI_DIP_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLCMS_LUMI_DIP_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::CMS_LUMI_DIP_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::CMS_LUMI_DIP_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::CMS_LUMI_DIP_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLCMS_LUMI_DIP_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::CMS_LUMI_DIP_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT_Dictionary();
   static void *new_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void *p = 0);
   static void *newArray_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void *p);
   static void deleteArray_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void *p);
   static void destruct_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::TRIGGER_LUMI_SEGMENT*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::TRIGGER_LUMI_SEGMENT) == sizeof(::ROOT::Shadow::HCAL_HLX::TRIGGER_LUMI_SEGMENT));
      ::HCAL_HLX::TRIGGER_LUMI_SEGMENT *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::TRIGGER_LUMI_SEGMENT),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::TRIGGER_LUMI_SEGMENT", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 357,
                  typeid(::HCAL_HLX::TRIGGER_LUMI_SEGMENT), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT_ShowMembers, &HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::TRIGGER_LUMI_SEGMENT) );
      instance.SetNew(&new_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT);
      instance.SetDelete(&delete_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::TRIGGER_LUMI_SEGMENT*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::TRIGGER_LUMI_SEGMENT*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::TRIGGER_LUMI_SEGMENT*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::TRIGGER_LUMI_SEGMENT*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_MODE_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLHC_BEAM_MODE_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(void *p);
   static void destruct_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LHC_BEAM_MODE_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LHC_BEAM_MODE_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::LHC_BEAM_MODE_DATA));
      ::HCAL_HLX::LHC_BEAM_MODE_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LHC_BEAM_MODE_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LHC_BEAM_MODE_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 365,
                  typeid(::HCAL_HLX::LHC_BEAM_MODE_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLHC_BEAM_MODE_DATA_ShowMembers, &HCAL_HLXcLcLLHC_BEAM_MODE_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LHC_BEAM_MODE_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLLHC_BEAM_MODE_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLHC_BEAM_MODE_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLLHC_BEAM_MODE_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLHC_BEAM_MODE_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLHC_BEAM_MODE_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LHC_BEAM_MODE_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LHC_BEAM_MODE_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_MODE_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLHC_BEAM_MODE_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_MODE_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void *p);
   static void destruct_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LHC_BEAM_ENERGY_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LHC_BEAM_ENERGY_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::LHC_BEAM_ENERGY_DATA));
      ::HCAL_HLX::LHC_BEAM_ENERGY_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LHC_BEAM_ENERGY_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LHC_BEAM_ENERGY_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 369,
                  typeid(::HCAL_HLX::LHC_BEAM_ENERGY_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA_ShowMembers, &HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LHC_BEAM_ENERGY_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LHC_BEAM_ENERGY_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LHC_BEAM_ENERGY_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_ENERGY_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_ENERGY_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void *p);
   static void destruct_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LHC_BEAM_INTENSITY_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::LHC_BEAM_INTENSITY_DATA));
      ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LHC_BEAM_INTENSITY_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LHC_BEAM_INTENSITY_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 373,
                  typeid(::HCAL_HLX::LHC_BEAM_INTENSITY_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA_ShowMembers, &HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LHC_BEAM_INTENSITY_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void *p);
   static void destruct_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA));
      ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 379,
                  typeid(::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA_ShowMembers, &HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLBEAM_INFO_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLBEAM_INFO_Dictionary();
   static void *new_HCAL_HLXcLcLBEAM_INFO(void *p = 0);
   static void *newArray_HCAL_HLXcLcLBEAM_INFO(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLBEAM_INFO(void *p);
   static void deleteArray_HCAL_HLXcLcLBEAM_INFO(void *p);
   static void destruct_HCAL_HLXcLcLBEAM_INFO(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::BEAM_INFO*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::BEAM_INFO) == sizeof(::ROOT::Shadow::HCAL_HLX::BEAM_INFO));
      ::HCAL_HLX::BEAM_INFO *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::BEAM_INFO),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::BEAM_INFO", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 397,
                  typeid(::HCAL_HLX::BEAM_INFO), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLBEAM_INFO_ShowMembers, &HCAL_HLXcLcLBEAM_INFO_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::BEAM_INFO) );
      instance.SetNew(&new_HCAL_HLXcLcLBEAM_INFO);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLBEAM_INFO);
      instance.SetDelete(&delete_HCAL_HLXcLcLBEAM_INFO);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLBEAM_INFO);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLBEAM_INFO);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::BEAM_INFO*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::BEAM_INFO*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::BEAM_INFO*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLBEAM_INFO_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BEAM_INFO*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLBRANA_INFO_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLBRANA_INFO_Dictionary();
   static void *new_HCAL_HLXcLcLBRANA_INFO(void *p = 0);
   static void *newArray_HCAL_HLXcLcLBRANA_INFO(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLBRANA_INFO(void *p);
   static void deleteArray_HCAL_HLXcLcLBRANA_INFO(void *p);
   static void destruct_HCAL_HLXcLcLBRANA_INFO(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::BRANA_INFO*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::BRANA_INFO) == sizeof(::ROOT::Shadow::HCAL_HLX::BRANA_INFO));
      ::HCAL_HLX::BRANA_INFO *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::BRANA_INFO),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::BRANA_INFO", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 408,
                  typeid(::HCAL_HLX::BRANA_INFO), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLBRANA_INFO_ShowMembers, &HCAL_HLXcLcLBRANA_INFO_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::BRANA_INFO) );
      instance.SetNew(&new_HCAL_HLXcLcLBRANA_INFO);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLBRANA_INFO);
      instance.SetDelete(&delete_HCAL_HLXcLcLBRANA_INFO);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLBRANA_INFO);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLBRANA_INFO);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::BRANA_INFO*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::BRANA_INFO*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::BRANA_INFO*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLBRANA_INFO_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRANA_INFO*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLBRANP_INFO_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLBRANP_INFO_Dictionary();
   static void *new_HCAL_HLXcLcLBRANP_INFO(void *p = 0);
   static void *newArray_HCAL_HLXcLcLBRANP_INFO(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLBRANP_INFO(void *p);
   static void deleteArray_HCAL_HLXcLcLBRANP_INFO(void *p);
   static void destruct_HCAL_HLXcLcLBRANP_INFO(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::BRANP_INFO*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::BRANP_INFO) == sizeof(::ROOT::Shadow::HCAL_HLX::BRANP_INFO));
      ::HCAL_HLX::BRANP_INFO *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::BRANP_INFO),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::BRANP_INFO", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 415,
                  typeid(::HCAL_HLX::BRANP_INFO), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLBRANP_INFO_ShowMembers, &HCAL_HLXcLcLBRANP_INFO_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::BRANP_INFO) );
      instance.SetNew(&new_HCAL_HLXcLcLBRANP_INFO);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLBRANP_INFO);
      instance.SetDelete(&delete_HCAL_HLXcLcLBRANP_INFO);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLBRANP_INFO);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLBRANP_INFO);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::BRANP_INFO*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::BRANP_INFO*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::BRANP_INFO*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLBRANP_INFO_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRANP_INFO*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLBRAN_INFO_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLBRAN_INFO_Dictionary();
   static void *new_HCAL_HLXcLcLBRAN_INFO(void *p = 0);
   static void *newArray_HCAL_HLXcLcLBRAN_INFO(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLBRAN_INFO(void *p);
   static void deleteArray_HCAL_HLXcLcLBRAN_INFO(void *p);
   static void destruct_HCAL_HLXcLcLBRAN_INFO(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::BRAN_INFO*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::BRAN_INFO) == sizeof(::ROOT::Shadow::HCAL_HLX::BRAN_INFO));
      ::HCAL_HLX::BRAN_INFO *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::BRAN_INFO),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::BRAN_INFO", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 425,
                  typeid(::HCAL_HLX::BRAN_INFO), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLBRAN_INFO_ShowMembers, &HCAL_HLXcLcLBRAN_INFO_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::BRAN_INFO) );
      instance.SetNew(&new_HCAL_HLXcLcLBRAN_INFO);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLBRAN_INFO);
      instance.SetDelete(&delete_HCAL_HLXcLcLBRAN_INFO);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLBRAN_INFO);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLBRAN_INFO);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::BRAN_INFO*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::BRAN_INFO*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_INFO*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLBRAN_INFO_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_INFO*)0x0)->GetClass();
   }

} // end of namespace ROOT

namespace ROOT {
   void HCAL_HLXcLcLDIP_COMBINED_DATA_ShowMembers(void *obj, TMemberInspector &R__insp);
   static void HCAL_HLXcLcLDIP_COMBINED_DATA_Dictionary();
   static void *new_HCAL_HLXcLcLDIP_COMBINED_DATA(void *p = 0);
   static void *newArray_HCAL_HLXcLcLDIP_COMBINED_DATA(Long_t size, void *p);
   static void delete_HCAL_HLXcLcLDIP_COMBINED_DATA(void *p);
   static void deleteArray_HCAL_HLXcLcLDIP_COMBINED_DATA(void *p);
   static void destruct_HCAL_HLXcLcLDIP_COMBINED_DATA(void *p);

   // Function generating the singleton type initializer
   static TGenericClassInfo *GenerateInitInstanceLocal(const ::HCAL_HLX::DIP_COMBINED_DATA*)
   {
      // Make sure the shadow class has the right sizeof
      R__ASSERT(sizeof(::HCAL_HLX::DIP_COMBINED_DATA) == sizeof(::ROOT::Shadow::HCAL_HLX::DIP_COMBINED_DATA));
      ::HCAL_HLX::DIP_COMBINED_DATA *ptr = 0;
      static ::TVirtualIsAProxy* isa_proxy = new ::TIsAProxy(typeid(::HCAL_HLX::DIP_COMBINED_DATA),0);
      static ::ROOT::TGenericClassInfo 
         instance("HCAL_HLX::DIP_COMBINED_DATA", "/build/davidlt/CMSSW_7_2_X_2014-06-18-1400/src/RecoLuminosity/LumiProducer/interface/LumiRawDataStructures.h", 431,
                  typeid(::HCAL_HLX::DIP_COMBINED_DATA), DefineBehavior(ptr, ptr),
                  &HCAL_HLXcLcLDIP_COMBINED_DATA_ShowMembers, &HCAL_HLXcLcLDIP_COMBINED_DATA_Dictionary, isa_proxy, 4,
                  sizeof(::HCAL_HLX::DIP_COMBINED_DATA) );
      instance.SetNew(&new_HCAL_HLXcLcLDIP_COMBINED_DATA);
      instance.SetNewArray(&newArray_HCAL_HLXcLcLDIP_COMBINED_DATA);
      instance.SetDelete(&delete_HCAL_HLXcLcLDIP_COMBINED_DATA);
      instance.SetDeleteArray(&deleteArray_HCAL_HLXcLcLDIP_COMBINED_DATA);
      instance.SetDestructor(&destruct_HCAL_HLXcLcLDIP_COMBINED_DATA);
      return &instance;
   }
   TGenericClassInfo *GenerateInitInstance(const ::HCAL_HLX::DIP_COMBINED_DATA*)
   {
      return GenerateInitInstanceLocal((::HCAL_HLX::DIP_COMBINED_DATA*)0);
   }
   // Static variable to force the class initialization
   static ::ROOT::TGenericClassInfo *_R__UNIQUE_(Init) = GenerateInitInstanceLocal((const ::HCAL_HLX::DIP_COMBINED_DATA*)0x0); R__UseDummy(_R__UNIQUE_(Init));

   // Dictionary for non-ClassDef classes
   static void HCAL_HLXcLcLDIP_COMBINED_DATA_Dictionary() {
      ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::DIP_COMBINED_DATA*)0x0)->GetClass();
   }

} // end of namespace ROOT

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLDAQ_HEART_BEAT_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::DAQ_HEART_BEAT.
      typedef ::ROOT::Shadow::HCAL_HLX::DAQ_HEART_BEAT ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::DAQ_HEART_BEAT*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runNumber", &sobj->runNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "sectionNumber", &sobj->sectionNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bCMSLive", &sobj->bCMSLive);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp", &sobj->timestamp);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp_micros", &sobj->timestamp_micros);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLDAQ_HEART_BEAT(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::DAQ_HEART_BEAT : new ::HCAL_HLX::DAQ_HEART_BEAT;
   }
   static void *newArray_HCAL_HLXcLcLDAQ_HEART_BEAT(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::DAQ_HEART_BEAT[nElements] : new ::HCAL_HLX::DAQ_HEART_BEAT[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLDAQ_HEART_BEAT(void *p) {
      delete ((::HCAL_HLX::DAQ_HEART_BEAT*)p);
   }
   static void deleteArray_HCAL_HLXcLcLDAQ_HEART_BEAT(void *p) {
      delete [] ((::HCAL_HLX::DAQ_HEART_BEAT*)p);
   }
   static void destruct_HCAL_HLXcLcLDAQ_HEART_BEAT(void *p) {
      typedef ::HCAL_HLX::DAQ_HEART_BEAT current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::DAQ_HEART_BEAT

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLRUN_SUMMARY_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::RUN_SUMMARY.
      typedef ::ROOT::Shadow::HCAL_HLX::RUN_SUMMARY ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::RUN_SUMMARY*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runSequenceName[128]", sobj->runSequenceName);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "HLTConfigId", &sobj->HLTConfigId);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp", &sobj->timestamp);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp_micros", &sobj->timestamp_micros);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "startOrbitNumber", &sobj->startOrbitNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "endOrbitnumber", &sobj->endOrbitnumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runNumber", &sobj->runNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "fillNumber", &sobj->fillNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numberCMSLumiSections", &sobj->numberCMSLumiSections);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numberLumiDAQLumiSections", &sobj->numberLumiDAQLumiSections);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLRUN_SUMMARY(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::RUN_SUMMARY : new ::HCAL_HLX::RUN_SUMMARY;
   }
   static void *newArray_HCAL_HLXcLcLRUN_SUMMARY(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::RUN_SUMMARY[nElements] : new ::HCAL_HLX::RUN_SUMMARY[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLRUN_SUMMARY(void *p) {
      delete ((::HCAL_HLX::RUN_SUMMARY*)p);
   }
   static void deleteArray_HCAL_HLXcLcLRUN_SUMMARY(void *p) {
      delete [] ((::HCAL_HLX::RUN_SUMMARY*)p);
   }
   static void destruct_HCAL_HLXcLcLRUN_SUMMARY(void *p) {
      typedef ::HCAL_HLX::RUN_SUMMARY current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::RUN_SUMMARY

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLRUN_QUALITY_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::RUN_QUALITY.
      typedef ::ROOT::Shadow::HCAL_HLX::RUN_QUALITY ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::RUN_QUALITY*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runNumber", &sobj->runNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "sectionNumber", &sobj->sectionNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "HLX", &sobj->HLX);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "HFLumi", &sobj->HFLumi);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ECAL", &sobj->ECAL);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "HCAL", &sobj->HCAL);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "Tracker", &sobj->Tracker);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "RPC", &sobj->RPC);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DT", &sobj->DT);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "CSC", &sobj->CSC);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLRUN_QUALITY(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::RUN_QUALITY : new ::HCAL_HLX::RUN_QUALITY;
   }
   static void *newArray_HCAL_HLXcLcLRUN_QUALITY(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::RUN_QUALITY[nElements] : new ::HCAL_HLX::RUN_QUALITY[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLRUN_QUALITY(void *p) {
      delete ((::HCAL_HLX::RUN_QUALITY*)p);
   }
   static void deleteArray_HCAL_HLXcLcLRUN_QUALITY(void *p) {
      delete [] ((::HCAL_HLX::RUN_QUALITY*)p);
   }
   static void destruct_HCAL_HLXcLcLRUN_QUALITY(void *p) {
      typedef ::HCAL_HLX::RUN_QUALITY current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::RUN_QUALITY

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLRCMS_CONFIG_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::RCMS_CONFIG.
      typedef ::ROOT::Shadow::HCAL_HLX::RCMS_CONFIG ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::RCMS_CONFIG*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runNumber", &sobj->runNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "CMSSW_Tag[32]", sobj->CMSSW_Tag);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "TriDAS_Tag[32]", sobj->TriDAS_Tag);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "FirmwareVersion", &sobj->FirmwareVersion);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ExpectedFirmwareVersion", &sobj->ExpectedFirmwareVersion);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "AddressTablePath[256]", sobj->AddressTablePath);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "CfgDBTag[64]", sobj->CfgDBTag);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "CfgDBAccessor[64]", sobj->CfgDBAccessor);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "UseConfigDB", &sobj->UseConfigDB);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DestIPHigh", &sobj->DestIPHigh);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DestIPLow", &sobj->DestIPLow);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SrcIPBaseHigh", &sobj->SrcIPBaseHigh);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SrcIPBaseLow", &sobj->SrcIPBaseLow);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DestMacAddrHigh", &sobj->DestMacAddrHigh);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DestMacAddrMed", &sobj->DestMacAddrMed);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DestMacAddrLow", &sobj->DestMacAddrLow);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SrcMacAddrHigh", &sobj->SrcMacAddrHigh);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SrcMacAddrMed", &sobj->SrcMacAddrMed);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SrcMacAddrLow", &sobj->SrcMacAddrLow);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SrcPort", &sobj->SrcPort);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DestPort", &sobj->DestPort);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DebugData", &sobj->DebugData);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DebugReadout", &sobj->DebugReadout);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DebugSingleCycle", &sobj->DebugSingleCycle);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "NumOrbits", &sobj->NumOrbits);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OrbitPeriod", &sobj->OrbitPeriod);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "Id", &sobj->Id);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "TTCBC0Pattern", &sobj->TTCBC0Pattern);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "TTCSTARTPattern", &sobj->TTCSTARTPattern);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "TTCSTOPPattern", &sobj->TTCSTOPPattern);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "BC0Delay", &sobj->BC0Delay);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccThresholdLowBottom", &sobj->OccThresholdLowBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccThresholdLowTop", &sobj->OccThresholdLowTop);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccThresholdHighBottom", &sobj->OccThresholdHighBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccThresholdHighTop", &sobj->OccThresholdHighTop);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "LHCThresholdBottom", &sobj->LHCThresholdBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "LHCThresholdTop", &sobj->LHCThresholdTop);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ETSumCutoffBottom", &sobj->ETSumCutoffBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ETSumCutoffTop", &sobj->ETSumCutoffTop);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OCCMaskBottom", &sobj->OCCMaskBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OCCMaskTop", &sobj->OCCMaskTop);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "LHCMaskLowBottom", &sobj->LHCMaskLowBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "LHCMaskLowTop", &sobj->LHCMaskLowTop);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "LHCMaskHighBottom", &sobj->LHCMaskHighBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "LHCMaskHighTop", &sobj->LHCMaskHighTop);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SumETMaskLowBottom", &sobj->SumETMaskLowBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SumETMaskLowTop", &sobj->SumETMaskLowTop);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SumETMaskHighBottom", &sobj->SumETMaskHighBottom);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "SumETMaskHighTop", &sobj->SumETMaskHighTop);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLRCMS_CONFIG(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::RCMS_CONFIG : new ::HCAL_HLX::RCMS_CONFIG;
   }
   static void *newArray_HCAL_HLXcLcLRCMS_CONFIG(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::RCMS_CONFIG[nElements] : new ::HCAL_HLX::RCMS_CONFIG[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLRCMS_CONFIG(void *p) {
      delete ((::HCAL_HLX::RCMS_CONFIG*)p);
   }
   static void deleteArray_HCAL_HLXcLcLRCMS_CONFIG(void *p) {
      delete [] ((::HCAL_HLX::RCMS_CONFIG*)p);
   }
   static void destruct_HCAL_HLXcLcLRCMS_CONFIG(void *p) {
      typedef ::HCAL_HLX::RCMS_CONFIG current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::RCMS_CONFIG

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLUMI_SUMMARY_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LUMI_SUMMARY.
      typedef ::ROOT::Shadow::HCAL_HLX::LUMI_SUMMARY ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SUMMARY*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "DeadTimeNormalization", &sobj->DeadTimeNormalization);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "LHCNormalization", &sobj->LHCNormalization);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantLumi", &sobj->InstantLumi);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantLumiErr", &sobj->InstantLumiErr);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantLumiQlty", &sobj->InstantLumiQlty);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantETLumi", &sobj->InstantETLumi);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantETLumiErr", &sobj->InstantETLumiErr);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantETLumiQlty", &sobj->InstantETLumiQlty);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ETNormalization", &sobj->ETNormalization);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantOccLumi[2]", sobj->InstantOccLumi);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantOccLumiErr[2]", sobj->InstantOccLumiErr);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "InstantOccLumiQlty[2]", sobj->InstantOccLumiQlty);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccNormalization[2]", sobj->OccNormalization);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "lumiNoise[2]", sobj->lumiNoise);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLUMI_SUMMARY(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_SUMMARY : new ::HCAL_HLX::LUMI_SUMMARY;
   }
   static void *newArray_HCAL_HLXcLcLLUMI_SUMMARY(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_SUMMARY[nElements] : new ::HCAL_HLX::LUMI_SUMMARY[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLUMI_SUMMARY(void *p) {
      delete ((::HCAL_HLX::LUMI_SUMMARY*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLUMI_SUMMARY(void *p) {
      delete [] ((::HCAL_HLX::LUMI_SUMMARY*)p);
   }
   static void destruct_HCAL_HLXcLcLLUMI_SUMMARY(void *p) {
      typedef ::HCAL_HLX::LUMI_SUMMARY current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LUMI_SUMMARY

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLUMI_DETAIL_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LUMI_DETAIL.
      typedef ::ROOT::Shadow::HCAL_HLX::LUMI_DETAIL ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_DETAIL*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "LHCLumi[4096]", sobj->LHCLumi);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ETLumi[4096]", sobj->ETLumi);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ETLumiErr[4096]", sobj->ETLumiErr);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ETLumiQlty[4096]", sobj->ETLumiQlty);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "ETBXNormalization[4096]", sobj->ETBXNormalization);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccLumi[2][4096]", sobj->OccLumi);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccLumiErr[2][4096]", sobj->OccLumiErr);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccLumiQlty[2][4096]", sobj->OccLumiQlty);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "OccBXNormalization[2][4096]", sobj->OccBXNormalization);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLUMI_DETAIL(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_DETAIL : new ::HCAL_HLX::LUMI_DETAIL;
   }
   static void *newArray_HCAL_HLXcLcLLUMI_DETAIL(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_DETAIL[nElements] : new ::HCAL_HLX::LUMI_DETAIL[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLUMI_DETAIL(void *p) {
      delete ((::HCAL_HLX::LUMI_DETAIL*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLUMI_DETAIL(void *p) {
      delete [] ((::HCAL_HLX::LUMI_DETAIL*)p);
   }
   static void destruct_HCAL_HLXcLcLLUMI_DETAIL(void *p) {
      typedef ::HCAL_HLX::LUMI_DETAIL current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LUMI_DETAIL

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLEVEL1_PATH_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LEVEL1_PATH.
      typedef ::ROOT::Shadow::HCAL_HLX::LEVEL1_PATH ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LEVEL1_PATH*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "pathName[128]", sobj->pathName);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "counts", &sobj->counts);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "prescale", &sobj->prescale);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLEVEL1_PATH(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LEVEL1_PATH : new ::HCAL_HLX::LEVEL1_PATH;
   }
   static void *newArray_HCAL_HLXcLcLLEVEL1_PATH(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LEVEL1_PATH[nElements] : new ::HCAL_HLX::LEVEL1_PATH[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLEVEL1_PATH(void *p) {
      delete ((::HCAL_HLX::LEVEL1_PATH*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLEVEL1_PATH(void *p) {
      delete [] ((::HCAL_HLX::LEVEL1_PATH*)p);
   }
   static void destruct_HCAL_HLXcLcLLEVEL1_PATH(void *p) {
      typedef ::HCAL_HLX::LEVEL1_PATH current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LEVEL1_PATH

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLEVEL1_TRIGGER_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LEVEL1_TRIGGER.
      typedef ::ROOT::Shadow::HCAL_HLX::LEVEL1_TRIGGER ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LEVEL1_TRIGGER*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runNumber", &sobj->runNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "sectionNumber", &sobj->sectionNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp", &sobj->timestamp);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp_micros", &sobj->timestamp_micros);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "deadtimecount", &sobj->deadtimecount);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "GTLumiInfoFormat[32]", sobj->GTLumiInfoFormat);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "GTAlgo[128]", sobj->GTAlgo);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "GTTech[64]", sobj->GTTech);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLEVEL1_TRIGGER(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LEVEL1_TRIGGER : new ::HCAL_HLX::LEVEL1_TRIGGER;
   }
   static void *newArray_HCAL_HLXcLcLLEVEL1_TRIGGER(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LEVEL1_TRIGGER[nElements] : new ::HCAL_HLX::LEVEL1_TRIGGER[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLEVEL1_TRIGGER(void *p) {
      delete ((::HCAL_HLX::LEVEL1_TRIGGER*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLEVEL1_TRIGGER(void *p) {
      delete [] ((::HCAL_HLX::LEVEL1_TRIGGER*)p);
   }
   static void destruct_HCAL_HLXcLcLLEVEL1_TRIGGER(void *p) {
      typedef ::HCAL_HLX::LEVEL1_TRIGGER current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LEVEL1_TRIGGER

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLHLT_PATH_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::HLT_PATH.
      typedef ::ROOT::Shadow::HCAL_HLX::HLT_PATH ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::HLT_PATH*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "PathName[128]", sobj->PathName);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "L1Pass", &sobj->L1Pass);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "PSPass", &sobj->PSPass);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "PAccept", &sobj->PAccept);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "PExcept", &sobj->PExcept);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "PReject", &sobj->PReject);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "PrescalerModule[64]", sobj->PrescalerModule);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "PSIndex", &sobj->PSIndex);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "Prescale", &sobj->Prescale);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "HLTConfigId", &sobj->HLTConfigId);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLHLT_PATH(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::HLT_PATH : new ::HCAL_HLX::HLT_PATH;
   }
   static void *newArray_HCAL_HLXcLcLHLT_PATH(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::HLT_PATH[nElements] : new ::HCAL_HLX::HLT_PATH[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLHLT_PATH(void *p) {
      delete ((::HCAL_HLX::HLT_PATH*)p);
   }
   static void deleteArray_HCAL_HLXcLcLHLT_PATH(void *p) {
      delete [] ((::HCAL_HLX::HLT_PATH*)p);
   }
   static void destruct_HCAL_HLXcLcLHLT_PATH(void *p) {
      typedef ::HCAL_HLX::HLT_PATH current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::HLT_PATH

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLHLTRIGGER_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::HLTRIGGER.
      typedef ::ROOT::Shadow::HCAL_HLX::HLTRIGGER ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::HLTRIGGER*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runNumber", &sobj->runNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "sectionNumber", &sobj->sectionNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numPaths", &sobj->numPaths);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "HLTPaths[256]", sobj->HLTPaths);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLHLTRIGGER(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::HLTRIGGER : new ::HCAL_HLX::HLTRIGGER;
   }
   static void *newArray_HCAL_HLXcLcLHLTRIGGER(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::HLTRIGGER[nElements] : new ::HCAL_HLX::HLTRIGGER[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLHLTRIGGER(void *p) {
      delete ((::HCAL_HLX::HLTRIGGER*)p);
   }
   static void deleteArray_HCAL_HLXcLcLHLTRIGGER(void *p) {
      delete [] ((::HCAL_HLX::HLTRIGGER*)p);
   }
   static void destruct_HCAL_HLXcLcLHLTRIGGER(void *p) {
      typedef ::HCAL_HLX::HLTRIGGER current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::HLTRIGGER

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLUMI_RAW_HEADER_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LUMI_RAW_HEADER.
      typedef ::ROOT::Shadow::HCAL_HLX::LUMI_RAW_HEADER ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_RAW_HEADER*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "marker", &sobj->marker);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "hlxID", &sobj->hlxID);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "packetID", &sobj->packetID);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "startOrbit", &sobj->startOrbit);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numOrbits", &sobj->numOrbits);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "startBunch", &sobj->startBunch);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numBunches", &sobj->numBunches);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "histogramSet", &sobj->histogramSet);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "histogramSequence", &sobj->histogramSequence);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "allA", &sobj->allA);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "allF", &sobj->allF);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLUMI_RAW_HEADER(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_RAW_HEADER : new ::HCAL_HLX::LUMI_RAW_HEADER;
   }
   static void *newArray_HCAL_HLXcLcLLUMI_RAW_HEADER(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_RAW_HEADER[nElements] : new ::HCAL_HLX::LUMI_RAW_HEADER[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLUMI_RAW_HEADER(void *p) {
      delete ((::HCAL_HLX::LUMI_RAW_HEADER*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLUMI_RAW_HEADER(void *p) {
      delete [] ((::HCAL_HLX::LUMI_RAW_HEADER*)p);
   }
   static void destruct_HCAL_HLXcLcLLUMI_RAW_HEADER(void *p) {
      typedef ::HCAL_HLX::LUMI_RAW_HEADER current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LUMI_RAW_HEADER

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLUMI_NIBBLE_HEADER_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LUMI_NIBBLE_HEADER.
      typedef ::ROOT::Shadow::HCAL_HLX::LUMI_NIBBLE_HEADER ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_NIBBLE_HEADER*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "startOrbit", &sobj->startOrbit);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numOrbits", &sobj->numOrbits);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numBunches", &sobj->numBunches);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bCMSLive", &sobj->bCMSLive);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bOC0", &sobj->bOC0);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_NIBBLE_HEADER : new ::HCAL_HLX::LUMI_NIBBLE_HEADER;
   }
   static void *newArray_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_NIBBLE_HEADER[nElements] : new ::HCAL_HLX::LUMI_NIBBLE_HEADER[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(void *p) {
      delete ((::HCAL_HLX::LUMI_NIBBLE_HEADER*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(void *p) {
      delete [] ((::HCAL_HLX::LUMI_NIBBLE_HEADER*)p);
   }
   static void destruct_HCAL_HLXcLcLLUMI_NIBBLE_HEADER(void *p) {
      typedef ::HCAL_HLX::LUMI_NIBBLE_HEADER current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LUMI_NIBBLE_HEADER

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLET_SUM_NIBBLE_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::ET_SUM_NIBBLE.
      typedef ::ROOT::Shadow::HCAL_HLX::ET_SUM_NIBBLE ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::ET_SUM_NIBBLE*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "hdr", (void*)&sobj->hdr);
      R__insp.InspectMember("HCAL_HLX::LUMI_NIBBLE_HEADER", (void*)&sobj->hdr, "hdr.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "data[4096]", sobj->data);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLET_SUM_NIBBLE(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::ET_SUM_NIBBLE : new ::HCAL_HLX::ET_SUM_NIBBLE;
   }
   static void *newArray_HCAL_HLXcLcLET_SUM_NIBBLE(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::ET_SUM_NIBBLE[nElements] : new ::HCAL_HLX::ET_SUM_NIBBLE[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLET_SUM_NIBBLE(void *p) {
      delete ((::HCAL_HLX::ET_SUM_NIBBLE*)p);
   }
   static void deleteArray_HCAL_HLXcLcLET_SUM_NIBBLE(void *p) {
      delete [] ((::HCAL_HLX::ET_SUM_NIBBLE*)p);
   }
   static void destruct_HCAL_HLXcLcLET_SUM_NIBBLE(void *p) {
      typedef ::HCAL_HLX::ET_SUM_NIBBLE current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::ET_SUM_NIBBLE

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLOCCUPANCY_NIBBLE_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::OCCUPANCY_NIBBLE.
      typedef ::ROOT::Shadow::HCAL_HLX::OCCUPANCY_NIBBLE ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::OCCUPANCY_NIBBLE*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "hdr", (void*)&sobj->hdr);
      R__insp.InspectMember("HCAL_HLX::LUMI_NIBBLE_HEADER", (void*)&sobj->hdr, "hdr.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "data[6][4096]", sobj->data);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLOCCUPANCY_NIBBLE(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::OCCUPANCY_NIBBLE : new ::HCAL_HLX::OCCUPANCY_NIBBLE;
   }
   static void *newArray_HCAL_HLXcLcLOCCUPANCY_NIBBLE(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::OCCUPANCY_NIBBLE[nElements] : new ::HCAL_HLX::OCCUPANCY_NIBBLE[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLOCCUPANCY_NIBBLE(void *p) {
      delete ((::HCAL_HLX::OCCUPANCY_NIBBLE*)p);
   }
   static void deleteArray_HCAL_HLXcLcLOCCUPANCY_NIBBLE(void *p) {
      delete [] ((::HCAL_HLX::OCCUPANCY_NIBBLE*)p);
   }
   static void destruct_HCAL_HLXcLcLOCCUPANCY_NIBBLE(void *p) {
      typedef ::HCAL_HLX::OCCUPANCY_NIBBLE current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::OCCUPANCY_NIBBLE

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLHC_NIBBLE_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LHC_NIBBLE.
      typedef ::ROOT::Shadow::HCAL_HLX::LHC_NIBBLE ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_NIBBLE*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "hdr", (void*)&sobj->hdr);
      R__insp.InspectMember("HCAL_HLX::LUMI_NIBBLE_HEADER", (void*)&sobj->hdr, "hdr.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "data[4096]", sobj->data);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLHC_NIBBLE(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_NIBBLE : new ::HCAL_HLX::LHC_NIBBLE;
   }
   static void *newArray_HCAL_HLXcLcLLHC_NIBBLE(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_NIBBLE[nElements] : new ::HCAL_HLX::LHC_NIBBLE[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLHC_NIBBLE(void *p) {
      delete ((::HCAL_HLX::LHC_NIBBLE*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLHC_NIBBLE(void *p) {
      delete [] ((::HCAL_HLX::LHC_NIBBLE*)p);
   }
   static void destruct_HCAL_HLXcLcLLHC_NIBBLE(void *p) {
      typedef ::HCAL_HLX::LHC_NIBBLE current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LHC_NIBBLE

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLUMI_SECTION_HEADER_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LUMI_SECTION_HEADER.
      typedef ::ROOT::Shadow::HCAL_HLX::LUMI_SECTION_HEADER ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION_HEADER*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp", &sobj->timestamp);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp_micros", &sobj->timestamp_micros);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runNumber", &sobj->runNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "sectionNumber", &sobj->sectionNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "startOrbit", &sobj->startOrbit);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numOrbits", &sobj->numOrbits);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numBunches", &sobj->numBunches);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numHLXs", &sobj->numHLXs);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bCMSLive", &sobj->bCMSLive);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bOC0", &sobj->bOC0);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLUMI_SECTION_HEADER(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_SECTION_HEADER : new ::HCAL_HLX::LUMI_SECTION_HEADER;
   }
   static void *newArray_HCAL_HLXcLcLLUMI_SECTION_HEADER(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_SECTION_HEADER[nElements] : new ::HCAL_HLX::LUMI_SECTION_HEADER[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLUMI_SECTION_HEADER(void *p) {
      delete ((::HCAL_HLX::LUMI_SECTION_HEADER*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLUMI_SECTION_HEADER(void *p) {
      delete [] ((::HCAL_HLX::LUMI_SECTION_HEADER*)p);
   }
   static void destruct_HCAL_HLXcLcLLUMI_SECTION_HEADER(void *p) {
      typedef ::HCAL_HLX::LUMI_SECTION_HEADER current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LUMI_SECTION_HEADER

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LUMI_SECTION_SUB_HEADER.
      typedef ::ROOT::Shadow::HCAL_HLX::LUMI_SECTION_SUB_HEADER ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION_SUB_HEADER*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numNibbles", &sobj->numNibbles);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bIsComplete", &sobj->bIsComplete);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_SECTION_SUB_HEADER : new ::HCAL_HLX::LUMI_SECTION_SUB_HEADER;
   }
   static void *newArray_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_SECTION_SUB_HEADER[nElements] : new ::HCAL_HLX::LUMI_SECTION_SUB_HEADER[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void *p) {
      delete ((::HCAL_HLX::LUMI_SECTION_SUB_HEADER*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void *p) {
      delete [] ((::HCAL_HLX::LUMI_SECTION_SUB_HEADER*)p);
   }
   static void destruct_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void *p) {
      typedef ::HCAL_HLX::LUMI_SECTION_SUB_HEADER current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LUMI_SECTION_SUB_HEADER

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLET_SUM_SECTION_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::ET_SUM_SECTION.
      typedef ::ROOT::Shadow::HCAL_HLX::ET_SUM_SECTION ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::ET_SUM_SECTION*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "hdr", (void*)&sobj->hdr);
      R__insp.InspectMember("HCAL_HLX::LUMI_SECTION_SUB_HEADER", (void*)&sobj->hdr, "hdr.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "data[4096]", sobj->data);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLET_SUM_SECTION(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::ET_SUM_SECTION : new ::HCAL_HLX::ET_SUM_SECTION;
   }
   static void *newArray_HCAL_HLXcLcLET_SUM_SECTION(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::ET_SUM_SECTION[nElements] : new ::HCAL_HLX::ET_SUM_SECTION[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLET_SUM_SECTION(void *p) {
      delete ((::HCAL_HLX::ET_SUM_SECTION*)p);
   }
   static void deleteArray_HCAL_HLXcLcLET_SUM_SECTION(void *p) {
      delete [] ((::HCAL_HLX::ET_SUM_SECTION*)p);
   }
   static void destruct_HCAL_HLXcLcLET_SUM_SECTION(void *p) {
      typedef ::HCAL_HLX::ET_SUM_SECTION current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::ET_SUM_SECTION

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLOCCUPANCY_SECTION_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::OCCUPANCY_SECTION.
      typedef ::ROOT::Shadow::HCAL_HLX::OCCUPANCY_SECTION ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::OCCUPANCY_SECTION*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "hdr", (void*)&sobj->hdr);
      R__insp.InspectMember("HCAL_HLX::LUMI_SECTION_SUB_HEADER", (void*)&sobj->hdr, "hdr.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "data[6][4096]", sobj->data);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLOCCUPANCY_SECTION(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::OCCUPANCY_SECTION : new ::HCAL_HLX::OCCUPANCY_SECTION;
   }
   static void *newArray_HCAL_HLXcLcLOCCUPANCY_SECTION(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::OCCUPANCY_SECTION[nElements] : new ::HCAL_HLX::OCCUPANCY_SECTION[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLOCCUPANCY_SECTION(void *p) {
      delete ((::HCAL_HLX::OCCUPANCY_SECTION*)p);
   }
   static void deleteArray_HCAL_HLXcLcLOCCUPANCY_SECTION(void *p) {
      delete [] ((::HCAL_HLX::OCCUPANCY_SECTION*)p);
   }
   static void destruct_HCAL_HLXcLcLOCCUPANCY_SECTION(void *p) {
      typedef ::HCAL_HLX::OCCUPANCY_SECTION current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::OCCUPANCY_SECTION

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLHC_SECTION_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LHC_SECTION.
      typedef ::ROOT::Shadow::HCAL_HLX::LHC_SECTION ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_SECTION*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "hdr", (void*)&sobj->hdr);
      R__insp.InspectMember("HCAL_HLX::LUMI_SECTION_SUB_HEADER", (void*)&sobj->hdr, "hdr.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "data[4096]", sobj->data);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLHC_SECTION(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_SECTION : new ::HCAL_HLX::LHC_SECTION;
   }
   static void *newArray_HCAL_HLXcLcLLHC_SECTION(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_SECTION[nElements] : new ::HCAL_HLX::LHC_SECTION[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLHC_SECTION(void *p) {
      delete ((::HCAL_HLX::LHC_SECTION*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLHC_SECTION(void *p) {
      delete [] ((::HCAL_HLX::LHC_SECTION*)p);
   }
   static void destruct_HCAL_HLXcLcLLHC_SECTION(void *p) {
      typedef ::HCAL_HLX::LHC_SECTION current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LHC_SECTION

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLUMI_SECTION_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LUMI_SECTION.
      typedef ::ROOT::Shadow::HCAL_HLX::LUMI_SECTION ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LUMI_SECTION*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "hdr", (void*)&sobj->hdr);
      R__insp.InspectMember("HCAL_HLX::LUMI_SECTION_HEADER", (void*)&sobj->hdr, "hdr.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "lumiSummary", (void*)&sobj->lumiSummary);
      R__insp.InspectMember("HCAL_HLX::LUMI_SUMMARY", (void*)&sobj->lumiSummary, "lumiSummary.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "lumiDetail", (void*)&sobj->lumiDetail);
      R__insp.InspectMember("HCAL_HLX::LUMI_DETAIL", (void*)&sobj->lumiDetail, "lumiDetail.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "etSum[36]", sobj->etSum);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "occupancy[36]", sobj->occupancy);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "lhc[36]", sobj->lhc);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLUMI_SECTION(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_SECTION : new ::HCAL_HLX::LUMI_SECTION;
   }
   static void *newArray_HCAL_HLXcLcLLUMI_SECTION(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LUMI_SECTION[nElements] : new ::HCAL_HLX::LUMI_SECTION[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLUMI_SECTION(void *p) {
      delete ((::HCAL_HLX::LUMI_SECTION*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLUMI_SECTION(void *p) {
      delete [] ((::HCAL_HLX::LUMI_SECTION*)p);
   }
   static void destruct_HCAL_HLXcLcLLUMI_SECTION(void *p) {
      typedef ::HCAL_HLX::LUMI_SECTION current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LUMI_SECTION

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLDIP_STRUCT_BASE_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::DIP_STRUCT_BASE.
      typedef ::ROOT::Shadow::HCAL_HLX::DIP_STRUCT_BASE ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::DIP_STRUCT_BASE*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "MessageQuality", &sobj->MessageQuality);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp", &sobj->timestamp);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "timestamp_micros", &sobj->timestamp_micros);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "runNumber", &sobj->runNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "sectionNumber", &sobj->sectionNumber);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLDIP_STRUCT_BASE(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::DIP_STRUCT_BASE : new ::HCAL_HLX::DIP_STRUCT_BASE;
   }
   static void *newArray_HCAL_HLXcLcLDIP_STRUCT_BASE(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::DIP_STRUCT_BASE[nElements] : new ::HCAL_HLX::DIP_STRUCT_BASE[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLDIP_STRUCT_BASE(void *p) {
      delete ((::HCAL_HLX::DIP_STRUCT_BASE*)p);
   }
   static void deleteArray_HCAL_HLXcLcLDIP_STRUCT_BASE(void *p) {
      delete [] ((::HCAL_HLX::DIP_STRUCT_BASE*)p);
   }
   static void destruct_HCAL_HLXcLcLDIP_STRUCT_BASE(void *p) {
      typedef ::HCAL_HLX::DIP_STRUCT_BASE current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::DIP_STRUCT_BASE

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLVDM_SCAN_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::VDM_SCAN_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::VDM_SCAN_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::VDM_SCAN_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "VdmMode", &sobj->VdmMode);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "IP", &sobj->IP);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "RecordDataFlag", &sobj->RecordDataFlag);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "BeamSeparation", &sobj->BeamSeparation);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "isXaxis", &sobj->isXaxis);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "Beam", &sobj->Beam);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "StepProgress", &sobj->StepProgress);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::VDM_SCAN_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLVDM_SCAN_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::VDM_SCAN_DATA : new ::HCAL_HLX::VDM_SCAN_DATA;
   }
   static void *newArray_HCAL_HLXcLcLVDM_SCAN_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::VDM_SCAN_DATA[nElements] : new ::HCAL_HLX::VDM_SCAN_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLVDM_SCAN_DATA(void *p) {
      delete ((::HCAL_HLX::VDM_SCAN_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLVDM_SCAN_DATA(void *p) {
      delete [] ((::HCAL_HLX::VDM_SCAN_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLVDM_SCAN_DATA(void *p) {
      typedef ::HCAL_HLX::VDM_SCAN_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::VDM_SCAN_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLBRAN_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::BRAN_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::BRAN_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "MeanCrossingAngle", &sobj->MeanCrossingAngle);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "AcqMode", &sobj->AcqMode);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "MeanLuminosity", &sobj->MeanLuminosity);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::BRAN_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLBRAN_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRAN_DATA : new ::HCAL_HLX::BRAN_DATA;
   }
   static void *newArray_HCAL_HLXcLcLBRAN_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRAN_DATA[nElements] : new ::HCAL_HLX::BRAN_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLBRAN_DATA(void *p) {
      delete ((::HCAL_HLX::BRAN_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLBRAN_DATA(void *p) {
      delete [] ((::HCAL_HLX::BRAN_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLBRAN_DATA(void *p) {
      typedef ::HCAL_HLX::BRAN_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::BRAN_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLBRAN_BX_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::BRAN_BX_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::BRAN_BX_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_BX_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bunchByBunchLuminosity[3564]", sobj->bunchByBunchLuminosity);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "AcqMode", &sobj->AcqMode);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::BRAN_BX_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLBRAN_BX_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRAN_BX_DATA : new ::HCAL_HLX::BRAN_BX_DATA;
   }
   static void *newArray_HCAL_HLXcLcLBRAN_BX_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRAN_BX_DATA[nElements] : new ::HCAL_HLX::BRAN_BX_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLBRAN_BX_DATA(void *p) {
      delete ((::HCAL_HLX::BRAN_BX_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLBRAN_BX_DATA(void *p) {
      delete [] ((::HCAL_HLX::BRAN_BX_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLBRAN_BX_DATA(void *p) {
      typedef ::HCAL_HLX::BRAN_BX_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::BRAN_BX_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_CONFIG_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LHC_BEAM_CONFIG.
      typedef ::ROOT::Shadow::HCAL_HLX::LHC_BEAM_CONFIG ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_CONFIG*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "beamConfig[3564]", sobj->beamConfig);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::LHC_BEAM_CONFIG*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLHC_BEAM_CONFIG(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_CONFIG : new ::HCAL_HLX::LHC_BEAM_CONFIG;
   }
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_CONFIG(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_CONFIG[nElements] : new ::HCAL_HLX::LHC_BEAM_CONFIG[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLHC_BEAM_CONFIG(void *p) {
      delete ((::HCAL_HLX::LHC_BEAM_CONFIG*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_CONFIG(void *p) {
      delete [] ((::HCAL_HLX::LHC_BEAM_CONFIG*)p);
   }
   static void destruct_HCAL_HLXcLcLLHC_BEAM_CONFIG(void *p) {
      typedef ::HCAL_HLX::LHC_BEAM_CONFIG current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LHC_BEAM_CONFIG

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLHC_FILL_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LHC_FILL_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::LHC_FILL_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_FILL_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "FillNumber", &sobj->FillNumber);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::LHC_FILL_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLHC_FILL_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_FILL_DATA : new ::HCAL_HLX::LHC_FILL_DATA;
   }
   static void *newArray_HCAL_HLXcLcLLHC_FILL_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_FILL_DATA[nElements] : new ::HCAL_HLX::LHC_FILL_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLHC_FILL_DATA(void *p) {
      delete ((::HCAL_HLX::LHC_FILL_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLHC_FILL_DATA(void *p) {
      delete [] ((::HCAL_HLX::LHC_FILL_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLLHC_FILL_DATA(void *p) {
      typedef ::HCAL_HLX::LHC_FILL_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LHC_FILL_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLCMS_LUMI_DIP_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::CMS_LUMI_DIP_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::CMS_LUMI_DIP_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::CMS_LUMI_DIP_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numHLXs", &sobj->numHLXs);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "startOrbit", &sobj->startOrbit);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numOrbits", &sobj->numOrbits);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "numBunches", &sobj->numBunches);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "instantLumi", &sobj->instantLumi);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "instantLumiErr", &sobj->instantLumiErr);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::CMS_LUMI_DIP_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::CMS_LUMI_DIP_DATA : new ::HCAL_HLX::CMS_LUMI_DIP_DATA;
   }
   static void *newArray_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::CMS_LUMI_DIP_DATA[nElements] : new ::HCAL_HLX::CMS_LUMI_DIP_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(void *p) {
      delete ((::HCAL_HLX::CMS_LUMI_DIP_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(void *p) {
      delete [] ((::HCAL_HLX::CMS_LUMI_DIP_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLCMS_LUMI_DIP_DATA(void *p) {
      typedef ::HCAL_HLX::CMS_LUMI_DIP_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::CMS_LUMI_DIP_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::TRIGGER_LUMI_SEGMENT.
      typedef ::ROOT::Shadow::HCAL_HLX::TRIGGER_LUMI_SEGMENT ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::TRIGGER_LUMI_SEGMENT*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "state[64]", sobj->state);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "deadtime", &sobj->deadtime);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "deadtimeBeamActive", &sobj->deadtimeBeamActive);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "lumiSegmentNumber", &sobj->lumiSegmentNumber);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::TRIGGER_LUMI_SEGMENT*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::TRIGGER_LUMI_SEGMENT : new ::HCAL_HLX::TRIGGER_LUMI_SEGMENT;
   }
   static void *newArray_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::TRIGGER_LUMI_SEGMENT[nElements] : new ::HCAL_HLX::TRIGGER_LUMI_SEGMENT[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void *p) {
      delete ((::HCAL_HLX::TRIGGER_LUMI_SEGMENT*)p);
   }
   static void deleteArray_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void *p) {
      delete [] ((::HCAL_HLX::TRIGGER_LUMI_SEGMENT*)p);
   }
   static void destruct_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void *p) {
      typedef ::HCAL_HLX::TRIGGER_LUMI_SEGMENT current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::TRIGGER_LUMI_SEGMENT

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_MODE_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LHC_BEAM_MODE_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::LHC_BEAM_MODE_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_MODE_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "beamMode[64]", sobj->beamMode);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::LHC_BEAM_MODE_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_MODE_DATA : new ::HCAL_HLX::LHC_BEAM_MODE_DATA;
   }
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_MODE_DATA[nElements] : new ::HCAL_HLX::LHC_BEAM_MODE_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(void *p) {
      delete ((::HCAL_HLX::LHC_BEAM_MODE_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(void *p) {
      delete [] ((::HCAL_HLX::LHC_BEAM_MODE_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLLHC_BEAM_MODE_DATA(void *p) {
      typedef ::HCAL_HLX::LHC_BEAM_MODE_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LHC_BEAM_MODE_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LHC_BEAM_ENERGY_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::LHC_BEAM_ENERGY_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_ENERGY_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "singleBeamEnergy", &sobj->singleBeamEnergy);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::LHC_BEAM_ENERGY_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_ENERGY_DATA : new ::HCAL_HLX::LHC_BEAM_ENERGY_DATA;
   }
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_ENERGY_DATA[nElements] : new ::HCAL_HLX::LHC_BEAM_ENERGY_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void *p) {
      delete ((::HCAL_HLX::LHC_BEAM_ENERGY_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void *p) {
      delete [] ((::HCAL_HLX::LHC_BEAM_ENERGY_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void *p) {
      typedef ::HCAL_HLX::LHC_BEAM_ENERGY_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LHC_BEAM_ENERGY_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LHC_BEAM_INTENSITY_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::LHC_BEAM_INTENSITY_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "beamIntensity", &sobj->beamIntensity);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "primitiveLifetime", &sobj->primitiveLifetime);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "acqTimeStamp", &sobj->acqTimeStamp);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA : new ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA;
   }
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA[nElements] : new ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void *p) {
      delete ((::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void *p) {
      delete [] ((::HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void *p) {
      typedef ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LHC_BEAM_INTENSITY_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bestLifetime", &sobj->bestLifetime);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "averageBeamIntensity", &sobj->averageBeamIntensity);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "averageBunchIntensities[3564]", sobj->averageBunchIntensities);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA : new ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA;
   }
   static void *newArray_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA[nElements] : new ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void *p) {
      delete ((::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void *p) {
      delete [] ((::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void *p) {
      typedef ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLBEAM_INFO_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::BEAM_INFO.
      typedef ::ROOT::Shadow::HCAL_HLX::BEAM_INFO ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BEAM_INFO*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "totalIntensity", &sobj->totalIntensity);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "primitiveLifetime", &sobj->primitiveLifetime);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bestLifeTime", &sobj->bestLifeTime);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "averageBeamIntensity", &sobj->averageBeamIntensity);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "orbitFrequency", &sobj->orbitFrequency);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "averageBunchIntensities[3564]", sobj->averageBunchIntensities);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "beamConfig[3564]", sobj->beamConfig);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLBEAM_INFO(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BEAM_INFO : new ::HCAL_HLX::BEAM_INFO;
   }
   static void *newArray_HCAL_HLXcLcLBEAM_INFO(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BEAM_INFO[nElements] : new ::HCAL_HLX::BEAM_INFO[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLBEAM_INFO(void *p) {
      delete ((::HCAL_HLX::BEAM_INFO*)p);
   }
   static void deleteArray_HCAL_HLXcLcLBEAM_INFO(void *p) {
      delete [] ((::HCAL_HLX::BEAM_INFO*)p);
   }
   static void destruct_HCAL_HLXcLcLBEAM_INFO(void *p) {
      typedef ::HCAL_HLX::BEAM_INFO current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::BEAM_INFO

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLBRANA_INFO_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::BRANA_INFO.
      typedef ::ROOT::Shadow::HCAL_HLX::BRANA_INFO ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRANA_INFO*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "meanCrossingAngle", &sobj->meanCrossingAngle);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "acqMode", &sobj->acqMode);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "meanLuminosity", &sobj->meanLuminosity);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bunchByBunchLuminosity[3564]", sobj->bunchByBunchLuminosity);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLBRANA_INFO(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRANA_INFO : new ::HCAL_HLX::BRANA_INFO;
   }
   static void *newArray_HCAL_HLXcLcLBRANA_INFO(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRANA_INFO[nElements] : new ::HCAL_HLX::BRANA_INFO[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLBRANA_INFO(void *p) {
      delete ((::HCAL_HLX::BRANA_INFO*)p);
   }
   static void deleteArray_HCAL_HLXcLcLBRANA_INFO(void *p) {
      delete [] ((::HCAL_HLX::BRANA_INFO*)p);
   }
   static void destruct_HCAL_HLXcLcLBRANA_INFO(void *p) {
      typedef ::HCAL_HLX::BRANA_INFO current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::BRANA_INFO

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLBRANP_INFO_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::BRANP_INFO.
      typedef ::ROOT::Shadow::HCAL_HLX::BRANP_INFO ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRANP_INFO*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "meanCrossingAngle", &sobj->meanCrossingAngle);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "acqMode", &sobj->acqMode);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "counterAcquisition", &sobj->counterAcquisition);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "meanLuminosity", &sobj->meanLuminosity);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "meanCrossingAngleError", &sobj->meanCrossingAngleError);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "meanLuminosityError", &sobj->meanLuminosityError);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "bunchByBunchLuminosity[3564]", sobj->bunchByBunchLuminosity);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLBRANP_INFO(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRANP_INFO : new ::HCAL_HLX::BRANP_INFO;
   }
   static void *newArray_HCAL_HLXcLcLBRANP_INFO(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRANP_INFO[nElements] : new ::HCAL_HLX::BRANP_INFO[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLBRANP_INFO(void *p) {
      delete ((::HCAL_HLX::BRANP_INFO*)p);
   }
   static void deleteArray_HCAL_HLXcLcLBRANP_INFO(void *p) {
      delete [] ((::HCAL_HLX::BRANP_INFO*)p);
   }
   static void destruct_HCAL_HLXcLcLBRANP_INFO(void *p) {
      typedef ::HCAL_HLX::BRANP_INFO current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::BRANP_INFO

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLBRAN_INFO_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::BRAN_INFO.
      typedef ::ROOT::Shadow::HCAL_HLX::BRAN_INFO ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::BRAN_INFO*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "branA", (void*)&sobj->branA);
      R__insp.InspectMember("HCAL_HLX::BRANA_INFO", (void*)&sobj->branA, "branA.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "branP", (void*)&sobj->branP);
      R__insp.InspectMember("HCAL_HLX::BRANP_INFO", (void*)&sobj->branP, "branP.", false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLBRAN_INFO(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRAN_INFO : new ::HCAL_HLX::BRAN_INFO;
   }
   static void *newArray_HCAL_HLXcLcLBRAN_INFO(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::BRAN_INFO[nElements] : new ::HCAL_HLX::BRAN_INFO[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLBRAN_INFO(void *p) {
      delete ((::HCAL_HLX::BRAN_INFO*)p);
   }
   static void deleteArray_HCAL_HLXcLcLBRAN_INFO(void *p) {
      delete [] ((::HCAL_HLX::BRAN_INFO*)p);
   }
   static void destruct_HCAL_HLXcLcLBRAN_INFO(void *p) {
      typedef ::HCAL_HLX::BRAN_INFO current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::BRAN_INFO

//______________________________________________________________________________
namespace ROOT {
   void HCAL_HLXcLcLDIP_COMBINED_DATA_ShowMembers(void *obj, TMemberInspector &R__insp)
   {
      // Inspect the data members of an object of class HCAL_HLX::DIP_COMBINED_DATA.
      typedef ::ROOT::Shadow::HCAL_HLX::DIP_COMBINED_DATA ShadowClass;
      ShadowClass *sobj = (ShadowClass*)obj;
      if (sobj) { } // Dummy usage just in case there is no datamember.

      TClass *R__cl  = ::ROOT::GenerateInitInstanceLocal((const ::HCAL_HLX::DIP_COMBINED_DATA*)0x0)->GetClass();
      if (R__cl || R__insp.IsA()) { }
      R__insp.Inspect(R__cl, R__insp.GetParent(), "beamMode[128]", sobj->beamMode);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "Energy", &sobj->Energy);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "FillNumber", &sobj->FillNumber);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "Beam[2]", sobj->Beam);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "BRAN4L1", (void*)&sobj->BRAN4L1);
      R__insp.InspectMember("HCAL_HLX::BRAN_INFO", (void*)&sobj->BRAN4L1, "BRAN4L1.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "BRAN4R1", (void*)&sobj->BRAN4R1);
      R__insp.InspectMember("HCAL_HLX::BRAN_INFO", (void*)&sobj->BRAN4R1, "BRAN4R1.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "BRAN4L5", (void*)&sobj->BRAN4L5);
      R__insp.InspectMember("HCAL_HLX::BRAN_INFO", (void*)&sobj->BRAN4L5, "BRAN4L5.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "BRAN4R5", (void*)&sobj->BRAN4R5);
      R__insp.InspectMember("HCAL_HLX::BRAN_INFO", (void*)&sobj->BRAN4R5, "BRAN4R5.", false);
      R__insp.Inspect(R__cl, R__insp.GetParent(), "VdMScan", (void*)&sobj->VdMScan);
      R__insp.InspectMember("HCAL_HLX::VDM_SCAN_DATA", (void*)&sobj->VdMScan, "VdMScan.", false);
      R__insp.GenericShowMembers("HCAL_HLX::DIP_STRUCT_BASE", ( ::HCAL_HLX::DIP_STRUCT_BASE * )( (::HCAL_HLX::DIP_COMBINED_DATA*) obj ), false);
   }

}

namespace ROOT {
   // Wrappers around operator new
   static void *new_HCAL_HLXcLcLDIP_COMBINED_DATA(void *p) {
      return  p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::DIP_COMBINED_DATA : new ::HCAL_HLX::DIP_COMBINED_DATA;
   }
   static void *newArray_HCAL_HLXcLcLDIP_COMBINED_DATA(Long_t nElements, void *p) {
      return p ? ::new((::ROOT::TOperatorNewHelper*)p) ::HCAL_HLX::DIP_COMBINED_DATA[nElements] : new ::HCAL_HLX::DIP_COMBINED_DATA[nElements];
   }
   // Wrapper around operator delete
   static void delete_HCAL_HLXcLcLDIP_COMBINED_DATA(void *p) {
      delete ((::HCAL_HLX::DIP_COMBINED_DATA*)p);
   }
   static void deleteArray_HCAL_HLXcLcLDIP_COMBINED_DATA(void *p) {
      delete [] ((::HCAL_HLX::DIP_COMBINED_DATA*)p);
   }
   static void destruct_HCAL_HLXcLcLDIP_COMBINED_DATA(void *p) {
      typedef ::HCAL_HLX::DIP_COMBINED_DATA current_t;
      ((current_t*)p)->~current_t();
   }
} // end of namespace ROOT for class ::HCAL_HLX::DIP_COMBINED_DATA

/********************************************************
* tmp/slc6_amd64_gcc490/src/RecoLuminosity/LumiProducer/src/RecoLuminosityLumiProducer/LumiRawDataStructuresLinkDef.cc
* CAUTION: DON'T CHANGE THIS FILE. THIS FILE IS AUTOMATICALLY GENERATED
*          FROM HEADER FILES LISTED IN G__setup_cpp_environmentXXX().
*          CHANGE THOSE HEADER FILES AND REGENERATE THIS FILE.
********************************************************/

#ifdef G__MEMTEST
#undef malloc
#undef free
#endif

#if defined(__GNUC__) && __GNUC__ >= 4 && ((__GNUC_MINOR__ == 2 && __GNUC_PATCHLEVEL__ >= 1) || (__GNUC_MINOR__ >= 3))
#pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif

extern "C" void G__cpp_reset_tagtableLumiRawDataStructuresLinkDef();

extern "C" void G__set_cpp_environmentLumiRawDataStructuresLinkDef() {
  G__cpp_reset_tagtableLumiRawDataStructuresLinkDef();
}
#include <new>
extern "C" int G__cpp_dllrevLumiRawDataStructuresLinkDef() { return(30051515); }

/*********************************************************
* Member function Interface Method
*********************************************************/

/* HCAL_HLX */

/* HCAL_HLX::DAQ_HEART_BEAT */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_169_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::DAQ_HEART_BEAT *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::DAQ_HEART_BEAT[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::DAQ_HEART_BEAT[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::DAQ_HEART_BEAT;
     } else {
       p = new((void*) gvp) HCAL_HLX::DAQ_HEART_BEAT;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_169_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::DAQ_HEART_BEAT* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::DAQ_HEART_BEAT(*(HCAL_HLX::DAQ_HEART_BEAT*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::DAQ_HEART_BEAT G__THCAL_HLXcLcLDAQ_HEART_BEAT;
static int G__LumiRawDataStructuresLinkDef_169_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::DAQ_HEART_BEAT*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::DAQ_HEART_BEAT*) (soff+(sizeof(HCAL_HLX::DAQ_HEART_BEAT)*i)))->~G__THCAL_HLXcLcLDAQ_HEART_BEAT();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::DAQ_HEART_BEAT*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::DAQ_HEART_BEAT*) (soff))->~G__THCAL_HLXcLcLDAQ_HEART_BEAT();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_169_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::DAQ_HEART_BEAT* dest = (HCAL_HLX::DAQ_HEART_BEAT*) G__getstructoffset();
   *dest = *(HCAL_HLX::DAQ_HEART_BEAT*) libp->para[0].ref;
   const HCAL_HLX::DAQ_HEART_BEAT& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::RUN_SUMMARY */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_170_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::RUN_SUMMARY *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::RUN_SUMMARY[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::RUN_SUMMARY[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::RUN_SUMMARY;
     } else {
       p = new((void*) gvp) HCAL_HLX::RUN_SUMMARY;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_170_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::RUN_SUMMARY* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::RUN_SUMMARY(*(HCAL_HLX::RUN_SUMMARY*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::RUN_SUMMARY G__THCAL_HLXcLcLRUN_SUMMARY;
static int G__LumiRawDataStructuresLinkDef_170_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::RUN_SUMMARY*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::RUN_SUMMARY*) (soff+(sizeof(HCAL_HLX::RUN_SUMMARY)*i)))->~G__THCAL_HLXcLcLRUN_SUMMARY();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::RUN_SUMMARY*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::RUN_SUMMARY*) (soff))->~G__THCAL_HLXcLcLRUN_SUMMARY();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_170_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::RUN_SUMMARY* dest = (HCAL_HLX::RUN_SUMMARY*) G__getstructoffset();
   *dest = *(HCAL_HLX::RUN_SUMMARY*) libp->para[0].ref;
   const HCAL_HLX::RUN_SUMMARY& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::RUN_QUALITY */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_171_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::RUN_QUALITY *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::RUN_QUALITY[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::RUN_QUALITY[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::RUN_QUALITY;
     } else {
       p = new((void*) gvp) HCAL_HLX::RUN_QUALITY;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_171_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::RUN_QUALITY* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::RUN_QUALITY(*(HCAL_HLX::RUN_QUALITY*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::RUN_QUALITY G__THCAL_HLXcLcLRUN_QUALITY;
static int G__LumiRawDataStructuresLinkDef_171_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::RUN_QUALITY*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::RUN_QUALITY*) (soff+(sizeof(HCAL_HLX::RUN_QUALITY)*i)))->~G__THCAL_HLXcLcLRUN_QUALITY();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::RUN_QUALITY*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::RUN_QUALITY*) (soff))->~G__THCAL_HLXcLcLRUN_QUALITY();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_171_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::RUN_QUALITY* dest = (HCAL_HLX::RUN_QUALITY*) G__getstructoffset();
   *dest = *(HCAL_HLX::RUN_QUALITY*) libp->para[0].ref;
   const HCAL_HLX::RUN_QUALITY& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::RCMS_CONFIG */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_172_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::RCMS_CONFIG *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::RCMS_CONFIG[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::RCMS_CONFIG[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::RCMS_CONFIG;
     } else {
       p = new((void*) gvp) HCAL_HLX::RCMS_CONFIG;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_172_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::RCMS_CONFIG* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::RCMS_CONFIG(*(HCAL_HLX::RCMS_CONFIG*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::RCMS_CONFIG G__THCAL_HLXcLcLRCMS_CONFIG;
static int G__LumiRawDataStructuresLinkDef_172_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::RCMS_CONFIG*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::RCMS_CONFIG*) (soff+(sizeof(HCAL_HLX::RCMS_CONFIG)*i)))->~G__THCAL_HLXcLcLRCMS_CONFIG();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::RCMS_CONFIG*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::RCMS_CONFIG*) (soff))->~G__THCAL_HLXcLcLRCMS_CONFIG();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_172_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::RCMS_CONFIG* dest = (HCAL_HLX::RCMS_CONFIG*) G__getstructoffset();
   *dest = *(HCAL_HLX::RCMS_CONFIG*) libp->para[0].ref;
   const HCAL_HLX::RCMS_CONFIG& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LUMI_SUMMARY */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_173_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_SUMMARY *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_SUMMARY[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_SUMMARY[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_SUMMARY;
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_SUMMARY;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_173_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LUMI_SUMMARY* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LUMI_SUMMARY(*(HCAL_HLX::LUMI_SUMMARY*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LUMI_SUMMARY G__THCAL_HLXcLcLLUMI_SUMMARY;
static int G__LumiRawDataStructuresLinkDef_173_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LUMI_SUMMARY*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LUMI_SUMMARY*) (soff+(sizeof(HCAL_HLX::LUMI_SUMMARY)*i)))->~G__THCAL_HLXcLcLLUMI_SUMMARY();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LUMI_SUMMARY*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LUMI_SUMMARY*) (soff))->~G__THCAL_HLXcLcLLUMI_SUMMARY();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_173_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_SUMMARY* dest = (HCAL_HLX::LUMI_SUMMARY*) G__getstructoffset();
   *dest = *(HCAL_HLX::LUMI_SUMMARY*) libp->para[0].ref;
   const HCAL_HLX::LUMI_SUMMARY& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LUMI_DETAIL */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_174_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_DETAIL *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_DETAIL[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_DETAIL[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_DETAIL;
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_DETAIL;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_174_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LUMI_DETAIL* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LUMI_DETAIL(*(HCAL_HLX::LUMI_DETAIL*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LUMI_DETAIL G__THCAL_HLXcLcLLUMI_DETAIL;
static int G__LumiRawDataStructuresLinkDef_174_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LUMI_DETAIL*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LUMI_DETAIL*) (soff+(sizeof(HCAL_HLX::LUMI_DETAIL)*i)))->~G__THCAL_HLXcLcLLUMI_DETAIL();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LUMI_DETAIL*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LUMI_DETAIL*) (soff))->~G__THCAL_HLXcLcLLUMI_DETAIL();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_174_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_DETAIL* dest = (HCAL_HLX::LUMI_DETAIL*) G__getstructoffset();
   *dest = *(HCAL_HLX::LUMI_DETAIL*) libp->para[0].ref;
   const HCAL_HLX::LUMI_DETAIL& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LEVEL1_PATH */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_175_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LEVEL1_PATH *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LEVEL1_PATH[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LEVEL1_PATH[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LEVEL1_PATH;
     } else {
       p = new((void*) gvp) HCAL_HLX::LEVEL1_PATH;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_175_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LEVEL1_PATH* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LEVEL1_PATH(*(HCAL_HLX::LEVEL1_PATH*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LEVEL1_PATH G__THCAL_HLXcLcLLEVEL1_PATH;
static int G__LumiRawDataStructuresLinkDef_175_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LEVEL1_PATH*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LEVEL1_PATH*) (soff+(sizeof(HCAL_HLX::LEVEL1_PATH)*i)))->~G__THCAL_HLXcLcLLEVEL1_PATH();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LEVEL1_PATH*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LEVEL1_PATH*) (soff))->~G__THCAL_HLXcLcLLEVEL1_PATH();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_175_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LEVEL1_PATH* dest = (HCAL_HLX::LEVEL1_PATH*) G__getstructoffset();
   *dest = *(HCAL_HLX::LEVEL1_PATH*) libp->para[0].ref;
   const HCAL_HLX::LEVEL1_PATH& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LEVEL1_TRIGGER */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_176_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LEVEL1_TRIGGER *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LEVEL1_TRIGGER[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LEVEL1_TRIGGER[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LEVEL1_TRIGGER;
     } else {
       p = new((void*) gvp) HCAL_HLX::LEVEL1_TRIGGER;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_176_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LEVEL1_TRIGGER* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LEVEL1_TRIGGER(*(HCAL_HLX::LEVEL1_TRIGGER*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LEVEL1_TRIGGER G__THCAL_HLXcLcLLEVEL1_TRIGGER;
static int G__LumiRawDataStructuresLinkDef_176_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LEVEL1_TRIGGER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LEVEL1_TRIGGER*) (soff+(sizeof(HCAL_HLX::LEVEL1_TRIGGER)*i)))->~G__THCAL_HLXcLcLLEVEL1_TRIGGER();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LEVEL1_TRIGGER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LEVEL1_TRIGGER*) (soff))->~G__THCAL_HLXcLcLLEVEL1_TRIGGER();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_176_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LEVEL1_TRIGGER* dest = (HCAL_HLX::LEVEL1_TRIGGER*) G__getstructoffset();
   *dest = *(HCAL_HLX::LEVEL1_TRIGGER*) libp->para[0].ref;
   const HCAL_HLX::LEVEL1_TRIGGER& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::HLT_PATH */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_177_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::HLT_PATH *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::HLT_PATH[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::HLT_PATH[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::HLT_PATH;
     } else {
       p = new((void*) gvp) HCAL_HLX::HLT_PATH;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_177_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::HLT_PATH* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::HLT_PATH(*(HCAL_HLX::HLT_PATH*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::HLT_PATH G__THCAL_HLXcLcLHLT_PATH;
static int G__LumiRawDataStructuresLinkDef_177_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::HLT_PATH*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::HLT_PATH*) (soff+(sizeof(HCAL_HLX::HLT_PATH)*i)))->~G__THCAL_HLXcLcLHLT_PATH();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::HLT_PATH*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::HLT_PATH*) (soff))->~G__THCAL_HLXcLcLHLT_PATH();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_177_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::HLT_PATH* dest = (HCAL_HLX::HLT_PATH*) G__getstructoffset();
   *dest = *(HCAL_HLX::HLT_PATH*) libp->para[0].ref;
   const HCAL_HLX::HLT_PATH& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::HLTRIGGER */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_178_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::HLTRIGGER *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::HLTRIGGER[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::HLTRIGGER[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::HLTRIGGER;
     } else {
       p = new((void*) gvp) HCAL_HLX::HLTRIGGER;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_178_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::HLTRIGGER* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::HLTRIGGER(*(HCAL_HLX::HLTRIGGER*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::HLTRIGGER G__THCAL_HLXcLcLHLTRIGGER;
static int G__LumiRawDataStructuresLinkDef_178_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::HLTRIGGER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::HLTRIGGER*) (soff+(sizeof(HCAL_HLX::HLTRIGGER)*i)))->~G__THCAL_HLXcLcLHLTRIGGER();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::HLTRIGGER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::HLTRIGGER*) (soff))->~G__THCAL_HLXcLcLHLTRIGGER();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_178_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::HLTRIGGER* dest = (HCAL_HLX::HLTRIGGER*) G__getstructoffset();
   *dest = *(HCAL_HLX::HLTRIGGER*) libp->para[0].ref;
   const HCAL_HLX::HLTRIGGER& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LUMI_RAW_HEADER */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_179_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_RAW_HEADER *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_RAW_HEADER[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_RAW_HEADER[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_RAW_HEADER;
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_RAW_HEADER;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_179_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LUMI_RAW_HEADER* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LUMI_RAW_HEADER(*(HCAL_HLX::LUMI_RAW_HEADER*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LUMI_RAW_HEADER G__THCAL_HLXcLcLLUMI_RAW_HEADER;
static int G__LumiRawDataStructuresLinkDef_179_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LUMI_RAW_HEADER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LUMI_RAW_HEADER*) (soff+(sizeof(HCAL_HLX::LUMI_RAW_HEADER)*i)))->~G__THCAL_HLXcLcLLUMI_RAW_HEADER();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LUMI_RAW_HEADER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LUMI_RAW_HEADER*) (soff))->~G__THCAL_HLXcLcLLUMI_RAW_HEADER();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_179_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_RAW_HEADER* dest = (HCAL_HLX::LUMI_RAW_HEADER*) G__getstructoffset();
   *dest = *(HCAL_HLX::LUMI_RAW_HEADER*) libp->para[0].ref;
   const HCAL_HLX::LUMI_RAW_HEADER& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LUMI_NIBBLE_HEADER */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_180_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_NIBBLE_HEADER *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_NIBBLE_HEADER[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_NIBBLE_HEADER[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_NIBBLE_HEADER;
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_NIBBLE_HEADER;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_180_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LUMI_NIBBLE_HEADER* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LUMI_NIBBLE_HEADER(*(HCAL_HLX::LUMI_NIBBLE_HEADER*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LUMI_NIBBLE_HEADER G__THCAL_HLXcLcLLUMI_NIBBLE_HEADER;
static int G__LumiRawDataStructuresLinkDef_180_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LUMI_NIBBLE_HEADER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LUMI_NIBBLE_HEADER*) (soff+(sizeof(HCAL_HLX::LUMI_NIBBLE_HEADER)*i)))->~G__THCAL_HLXcLcLLUMI_NIBBLE_HEADER();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LUMI_NIBBLE_HEADER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LUMI_NIBBLE_HEADER*) (soff))->~G__THCAL_HLXcLcLLUMI_NIBBLE_HEADER();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_180_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_NIBBLE_HEADER* dest = (HCAL_HLX::LUMI_NIBBLE_HEADER*) G__getstructoffset();
   *dest = *(HCAL_HLX::LUMI_NIBBLE_HEADER*) libp->para[0].ref;
   const HCAL_HLX::LUMI_NIBBLE_HEADER& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::ET_SUM_NIBBLE */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_181_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::ET_SUM_NIBBLE *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::ET_SUM_NIBBLE[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::ET_SUM_NIBBLE[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::ET_SUM_NIBBLE;
     } else {
       p = new((void*) gvp) HCAL_HLX::ET_SUM_NIBBLE;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_181_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::ET_SUM_NIBBLE* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::ET_SUM_NIBBLE(*(HCAL_HLX::ET_SUM_NIBBLE*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::ET_SUM_NIBBLE G__THCAL_HLXcLcLET_SUM_NIBBLE;
static int G__LumiRawDataStructuresLinkDef_181_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::ET_SUM_NIBBLE*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::ET_SUM_NIBBLE*) (soff+(sizeof(HCAL_HLX::ET_SUM_NIBBLE)*i)))->~G__THCAL_HLXcLcLET_SUM_NIBBLE();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::ET_SUM_NIBBLE*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::ET_SUM_NIBBLE*) (soff))->~G__THCAL_HLXcLcLET_SUM_NIBBLE();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_181_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::ET_SUM_NIBBLE* dest = (HCAL_HLX::ET_SUM_NIBBLE*) G__getstructoffset();
   *dest = *(HCAL_HLX::ET_SUM_NIBBLE*) libp->para[0].ref;
   const HCAL_HLX::ET_SUM_NIBBLE& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::OCCUPANCY_NIBBLE */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_182_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::OCCUPANCY_NIBBLE *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::OCCUPANCY_NIBBLE[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::OCCUPANCY_NIBBLE[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::OCCUPANCY_NIBBLE;
     } else {
       p = new((void*) gvp) HCAL_HLX::OCCUPANCY_NIBBLE;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_182_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::OCCUPANCY_NIBBLE* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::OCCUPANCY_NIBBLE(*(HCAL_HLX::OCCUPANCY_NIBBLE*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::OCCUPANCY_NIBBLE G__THCAL_HLXcLcLOCCUPANCY_NIBBLE;
static int G__LumiRawDataStructuresLinkDef_182_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::OCCUPANCY_NIBBLE*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::OCCUPANCY_NIBBLE*) (soff+(sizeof(HCAL_HLX::OCCUPANCY_NIBBLE)*i)))->~G__THCAL_HLXcLcLOCCUPANCY_NIBBLE();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::OCCUPANCY_NIBBLE*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::OCCUPANCY_NIBBLE*) (soff))->~G__THCAL_HLXcLcLOCCUPANCY_NIBBLE();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_182_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::OCCUPANCY_NIBBLE* dest = (HCAL_HLX::OCCUPANCY_NIBBLE*) G__getstructoffset();
   *dest = *(HCAL_HLX::OCCUPANCY_NIBBLE*) libp->para[0].ref;
   const HCAL_HLX::OCCUPANCY_NIBBLE& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LHC_NIBBLE */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_183_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_NIBBLE *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_NIBBLE[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_NIBBLE[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_NIBBLE;
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_NIBBLE;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_183_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LHC_NIBBLE* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LHC_NIBBLE(*(HCAL_HLX::LHC_NIBBLE*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LHC_NIBBLE G__THCAL_HLXcLcLLHC_NIBBLE;
static int G__LumiRawDataStructuresLinkDef_183_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LHC_NIBBLE*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LHC_NIBBLE*) (soff+(sizeof(HCAL_HLX::LHC_NIBBLE)*i)))->~G__THCAL_HLXcLcLLHC_NIBBLE();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LHC_NIBBLE*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LHC_NIBBLE*) (soff))->~G__THCAL_HLXcLcLLHC_NIBBLE();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_183_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_NIBBLE* dest = (HCAL_HLX::LHC_NIBBLE*) G__getstructoffset();
   *dest = *(HCAL_HLX::LHC_NIBBLE*) libp->para[0].ref;
   const HCAL_HLX::LHC_NIBBLE& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LUMI_SECTION_HEADER */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_184_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_SECTION_HEADER *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_SECTION_HEADER[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_SECTION_HEADER[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_SECTION_HEADER;
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_SECTION_HEADER;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_184_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LUMI_SECTION_HEADER* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LUMI_SECTION_HEADER(*(HCAL_HLX::LUMI_SECTION_HEADER*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LUMI_SECTION_HEADER G__THCAL_HLXcLcLLUMI_SECTION_HEADER;
static int G__LumiRawDataStructuresLinkDef_184_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LUMI_SECTION_HEADER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LUMI_SECTION_HEADER*) (soff+(sizeof(HCAL_HLX::LUMI_SECTION_HEADER)*i)))->~G__THCAL_HLXcLcLLUMI_SECTION_HEADER();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LUMI_SECTION_HEADER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LUMI_SECTION_HEADER*) (soff))->~G__THCAL_HLXcLcLLUMI_SECTION_HEADER();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_184_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_SECTION_HEADER* dest = (HCAL_HLX::LUMI_SECTION_HEADER*) G__getstructoffset();
   *dest = *(HCAL_HLX::LUMI_SECTION_HEADER*) libp->para[0].ref;
   const HCAL_HLX::LUMI_SECTION_HEADER& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LUMI_SECTION_SUB_HEADER */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_185_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_SECTION_SUB_HEADER *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_SECTION_SUB_HEADER[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_SECTION_SUB_HEADER[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_SECTION_SUB_HEADER;
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_SECTION_SUB_HEADER;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_185_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LUMI_SECTION_SUB_HEADER* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LUMI_SECTION_SUB_HEADER(*(HCAL_HLX::LUMI_SECTION_SUB_HEADER*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LUMI_SECTION_SUB_HEADER G__THCAL_HLXcLcLLUMI_SECTION_SUB_HEADER;
static int G__LumiRawDataStructuresLinkDef_185_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LUMI_SECTION_SUB_HEADER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LUMI_SECTION_SUB_HEADER*) (soff+(sizeof(HCAL_HLX::LUMI_SECTION_SUB_HEADER)*i)))->~G__THCAL_HLXcLcLLUMI_SECTION_SUB_HEADER();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LUMI_SECTION_SUB_HEADER*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LUMI_SECTION_SUB_HEADER*) (soff))->~G__THCAL_HLXcLcLLUMI_SECTION_SUB_HEADER();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_185_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_SECTION_SUB_HEADER* dest = (HCAL_HLX::LUMI_SECTION_SUB_HEADER*) G__getstructoffset();
   *dest = *(HCAL_HLX::LUMI_SECTION_SUB_HEADER*) libp->para[0].ref;
   const HCAL_HLX::LUMI_SECTION_SUB_HEADER& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::ET_SUM_SECTION */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_186_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::ET_SUM_SECTION *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::ET_SUM_SECTION[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::ET_SUM_SECTION[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::ET_SUM_SECTION;
     } else {
       p = new((void*) gvp) HCAL_HLX::ET_SUM_SECTION;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_186_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::ET_SUM_SECTION* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::ET_SUM_SECTION(*(HCAL_HLX::ET_SUM_SECTION*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::ET_SUM_SECTION G__THCAL_HLXcLcLET_SUM_SECTION;
static int G__LumiRawDataStructuresLinkDef_186_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::ET_SUM_SECTION*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::ET_SUM_SECTION*) (soff+(sizeof(HCAL_HLX::ET_SUM_SECTION)*i)))->~G__THCAL_HLXcLcLET_SUM_SECTION();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::ET_SUM_SECTION*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::ET_SUM_SECTION*) (soff))->~G__THCAL_HLXcLcLET_SUM_SECTION();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_186_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::ET_SUM_SECTION* dest = (HCAL_HLX::ET_SUM_SECTION*) G__getstructoffset();
   *dest = *(HCAL_HLX::ET_SUM_SECTION*) libp->para[0].ref;
   const HCAL_HLX::ET_SUM_SECTION& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::OCCUPANCY_SECTION */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_187_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::OCCUPANCY_SECTION *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::OCCUPANCY_SECTION[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::OCCUPANCY_SECTION[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::OCCUPANCY_SECTION;
     } else {
       p = new((void*) gvp) HCAL_HLX::OCCUPANCY_SECTION;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_187_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::OCCUPANCY_SECTION* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::OCCUPANCY_SECTION(*(HCAL_HLX::OCCUPANCY_SECTION*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::OCCUPANCY_SECTION G__THCAL_HLXcLcLOCCUPANCY_SECTION;
static int G__LumiRawDataStructuresLinkDef_187_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::OCCUPANCY_SECTION*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::OCCUPANCY_SECTION*) (soff+(sizeof(HCAL_HLX::OCCUPANCY_SECTION)*i)))->~G__THCAL_HLXcLcLOCCUPANCY_SECTION();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::OCCUPANCY_SECTION*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::OCCUPANCY_SECTION*) (soff))->~G__THCAL_HLXcLcLOCCUPANCY_SECTION();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_187_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::OCCUPANCY_SECTION* dest = (HCAL_HLX::OCCUPANCY_SECTION*) G__getstructoffset();
   *dest = *(HCAL_HLX::OCCUPANCY_SECTION*) libp->para[0].ref;
   const HCAL_HLX::OCCUPANCY_SECTION& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LHC_SECTION */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_188_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_SECTION *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_SECTION[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_SECTION[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_SECTION;
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_SECTION;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_188_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LHC_SECTION* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LHC_SECTION(*(HCAL_HLX::LHC_SECTION*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LHC_SECTION G__THCAL_HLXcLcLLHC_SECTION;
static int G__LumiRawDataStructuresLinkDef_188_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LHC_SECTION*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LHC_SECTION*) (soff+(sizeof(HCAL_HLX::LHC_SECTION)*i)))->~G__THCAL_HLXcLcLLHC_SECTION();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LHC_SECTION*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LHC_SECTION*) (soff))->~G__THCAL_HLXcLcLLHC_SECTION();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_188_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_SECTION* dest = (HCAL_HLX::LHC_SECTION*) G__getstructoffset();
   *dest = *(HCAL_HLX::LHC_SECTION*) libp->para[0].ref;
   const HCAL_HLX::LHC_SECTION& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LUMI_SECTION */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_189_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_SECTION *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_SECTION[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_SECTION[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LUMI_SECTION;
     } else {
       p = new((void*) gvp) HCAL_HLX::LUMI_SECTION;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_189_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LUMI_SECTION* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LUMI_SECTION(*(HCAL_HLX::LUMI_SECTION*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LUMI_SECTION G__THCAL_HLXcLcLLUMI_SECTION;
static int G__LumiRawDataStructuresLinkDef_189_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LUMI_SECTION*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LUMI_SECTION*) (soff+(sizeof(HCAL_HLX::LUMI_SECTION)*i)))->~G__THCAL_HLXcLcLLUMI_SECTION();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LUMI_SECTION*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LUMI_SECTION*) (soff))->~G__THCAL_HLXcLcLLUMI_SECTION();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_189_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LUMI_SECTION* dest = (HCAL_HLX::LUMI_SECTION*) G__getstructoffset();
   *dest = *(HCAL_HLX::LUMI_SECTION*) libp->para[0].ref;
   const HCAL_HLX::LUMI_SECTION& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::DIP_STRUCT_BASE */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_190_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::DIP_STRUCT_BASE *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::DIP_STRUCT_BASE[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::DIP_STRUCT_BASE[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::DIP_STRUCT_BASE;
     } else {
       p = new((void*) gvp) HCAL_HLX::DIP_STRUCT_BASE;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_190_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::DIP_STRUCT_BASE* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::DIP_STRUCT_BASE(*(HCAL_HLX::DIP_STRUCT_BASE*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::DIP_STRUCT_BASE G__THCAL_HLXcLcLDIP_STRUCT_BASE;
static int G__LumiRawDataStructuresLinkDef_190_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::DIP_STRUCT_BASE*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::DIP_STRUCT_BASE*) (soff+(sizeof(HCAL_HLX::DIP_STRUCT_BASE)*i)))->~G__THCAL_HLXcLcLDIP_STRUCT_BASE();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::DIP_STRUCT_BASE*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::DIP_STRUCT_BASE*) (soff))->~G__THCAL_HLXcLcLDIP_STRUCT_BASE();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_190_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::DIP_STRUCT_BASE* dest = (HCAL_HLX::DIP_STRUCT_BASE*) G__getstructoffset();
   *dest = *(HCAL_HLX::DIP_STRUCT_BASE*) libp->para[0].ref;
   const HCAL_HLX::DIP_STRUCT_BASE& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::VDM_SCAN_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_191_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::VDM_SCAN_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::VDM_SCAN_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::VDM_SCAN_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::VDM_SCAN_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::VDM_SCAN_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_191_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::VDM_SCAN_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::VDM_SCAN_DATA(*(HCAL_HLX::VDM_SCAN_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::VDM_SCAN_DATA G__THCAL_HLXcLcLVDM_SCAN_DATA;
static int G__LumiRawDataStructuresLinkDef_191_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::VDM_SCAN_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::VDM_SCAN_DATA*) (soff+(sizeof(HCAL_HLX::VDM_SCAN_DATA)*i)))->~G__THCAL_HLXcLcLVDM_SCAN_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::VDM_SCAN_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::VDM_SCAN_DATA*) (soff))->~G__THCAL_HLXcLcLVDM_SCAN_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_191_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::VDM_SCAN_DATA* dest = (HCAL_HLX::VDM_SCAN_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::VDM_SCAN_DATA*) libp->para[0].ref;
   const HCAL_HLX::VDM_SCAN_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::BRAN_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_192_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRAN_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRAN_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::BRAN_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRAN_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::BRAN_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_192_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::BRAN_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::BRAN_DATA(*(HCAL_HLX::BRAN_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::BRAN_DATA G__THCAL_HLXcLcLBRAN_DATA;
static int G__LumiRawDataStructuresLinkDef_192_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::BRAN_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::BRAN_DATA*) (soff+(sizeof(HCAL_HLX::BRAN_DATA)*i)))->~G__THCAL_HLXcLcLBRAN_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::BRAN_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::BRAN_DATA*) (soff))->~G__THCAL_HLXcLcLBRAN_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_192_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRAN_DATA* dest = (HCAL_HLX::BRAN_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::BRAN_DATA*) libp->para[0].ref;
   const HCAL_HLX::BRAN_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::BRAN_BX_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_193_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRAN_BX_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRAN_BX_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::BRAN_BX_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRAN_BX_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::BRAN_BX_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_193_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::BRAN_BX_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::BRAN_BX_DATA(*(HCAL_HLX::BRAN_BX_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::BRAN_BX_DATA G__THCAL_HLXcLcLBRAN_BX_DATA;
static int G__LumiRawDataStructuresLinkDef_193_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::BRAN_BX_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::BRAN_BX_DATA*) (soff+(sizeof(HCAL_HLX::BRAN_BX_DATA)*i)))->~G__THCAL_HLXcLcLBRAN_BX_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::BRAN_BX_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::BRAN_BX_DATA*) (soff))->~G__THCAL_HLXcLcLBRAN_BX_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_193_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRAN_BX_DATA* dest = (HCAL_HLX::BRAN_BX_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::BRAN_BX_DATA*) libp->para[0].ref;
   const HCAL_HLX::BRAN_BX_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LHC_BEAM_CONFIG */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_194_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_CONFIG *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_CONFIG[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_CONFIG[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_CONFIG;
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_CONFIG;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_194_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LHC_BEAM_CONFIG* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LHC_BEAM_CONFIG(*(HCAL_HLX::LHC_BEAM_CONFIG*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LHC_BEAM_CONFIG G__THCAL_HLXcLcLLHC_BEAM_CONFIG;
static int G__LumiRawDataStructuresLinkDef_194_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LHC_BEAM_CONFIG*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LHC_BEAM_CONFIG*) (soff+(sizeof(HCAL_HLX::LHC_BEAM_CONFIG)*i)))->~G__THCAL_HLXcLcLLHC_BEAM_CONFIG();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LHC_BEAM_CONFIG*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LHC_BEAM_CONFIG*) (soff))->~G__THCAL_HLXcLcLLHC_BEAM_CONFIG();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_194_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_CONFIG* dest = (HCAL_HLX::LHC_BEAM_CONFIG*) G__getstructoffset();
   *dest = *(HCAL_HLX::LHC_BEAM_CONFIG*) libp->para[0].ref;
   const HCAL_HLX::LHC_BEAM_CONFIG& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LHC_FILL_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_195_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_FILL_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_FILL_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_FILL_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_FILL_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_FILL_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_195_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LHC_FILL_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LHC_FILL_DATA(*(HCAL_HLX::LHC_FILL_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LHC_FILL_DATA G__THCAL_HLXcLcLLHC_FILL_DATA;
static int G__LumiRawDataStructuresLinkDef_195_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LHC_FILL_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LHC_FILL_DATA*) (soff+(sizeof(HCAL_HLX::LHC_FILL_DATA)*i)))->~G__THCAL_HLXcLcLLHC_FILL_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LHC_FILL_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LHC_FILL_DATA*) (soff))->~G__THCAL_HLXcLcLLHC_FILL_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_195_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_FILL_DATA* dest = (HCAL_HLX::LHC_FILL_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::LHC_FILL_DATA*) libp->para[0].ref;
   const HCAL_HLX::LHC_FILL_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::CMS_LUMI_DIP_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_196_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::CMS_LUMI_DIP_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::CMS_LUMI_DIP_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::CMS_LUMI_DIP_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::CMS_LUMI_DIP_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::CMS_LUMI_DIP_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_196_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::CMS_LUMI_DIP_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::CMS_LUMI_DIP_DATA(*(HCAL_HLX::CMS_LUMI_DIP_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::CMS_LUMI_DIP_DATA G__THCAL_HLXcLcLCMS_LUMI_DIP_DATA;
static int G__LumiRawDataStructuresLinkDef_196_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::CMS_LUMI_DIP_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::CMS_LUMI_DIP_DATA*) (soff+(sizeof(HCAL_HLX::CMS_LUMI_DIP_DATA)*i)))->~G__THCAL_HLXcLcLCMS_LUMI_DIP_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::CMS_LUMI_DIP_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::CMS_LUMI_DIP_DATA*) (soff))->~G__THCAL_HLXcLcLCMS_LUMI_DIP_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_196_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::CMS_LUMI_DIP_DATA* dest = (HCAL_HLX::CMS_LUMI_DIP_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::CMS_LUMI_DIP_DATA*) libp->para[0].ref;
   const HCAL_HLX::CMS_LUMI_DIP_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::TRIGGER_LUMI_SEGMENT */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_199_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::TRIGGER_LUMI_SEGMENT *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::TRIGGER_LUMI_SEGMENT[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::TRIGGER_LUMI_SEGMENT[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::TRIGGER_LUMI_SEGMENT;
     } else {
       p = new((void*) gvp) HCAL_HLX::TRIGGER_LUMI_SEGMENT;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_199_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::TRIGGER_LUMI_SEGMENT* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::TRIGGER_LUMI_SEGMENT(*(HCAL_HLX::TRIGGER_LUMI_SEGMENT*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::TRIGGER_LUMI_SEGMENT G__THCAL_HLXcLcLTRIGGER_LUMI_SEGMENT;
static int G__LumiRawDataStructuresLinkDef_199_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::TRIGGER_LUMI_SEGMENT*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::TRIGGER_LUMI_SEGMENT*) (soff+(sizeof(HCAL_HLX::TRIGGER_LUMI_SEGMENT)*i)))->~G__THCAL_HLXcLcLTRIGGER_LUMI_SEGMENT();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::TRIGGER_LUMI_SEGMENT*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::TRIGGER_LUMI_SEGMENT*) (soff))->~G__THCAL_HLXcLcLTRIGGER_LUMI_SEGMENT();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_199_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::TRIGGER_LUMI_SEGMENT* dest = (HCAL_HLX::TRIGGER_LUMI_SEGMENT*) G__getstructoffset();
   *dest = *(HCAL_HLX::TRIGGER_LUMI_SEGMENT*) libp->para[0].ref;
   const HCAL_HLX::TRIGGER_LUMI_SEGMENT& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LHC_BEAM_MODE_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_200_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_MODE_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_MODE_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_MODE_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_MODE_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_MODE_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_200_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LHC_BEAM_MODE_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LHC_BEAM_MODE_DATA(*(HCAL_HLX::LHC_BEAM_MODE_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LHC_BEAM_MODE_DATA G__THCAL_HLXcLcLLHC_BEAM_MODE_DATA;
static int G__LumiRawDataStructuresLinkDef_200_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LHC_BEAM_MODE_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LHC_BEAM_MODE_DATA*) (soff+(sizeof(HCAL_HLX::LHC_BEAM_MODE_DATA)*i)))->~G__THCAL_HLXcLcLLHC_BEAM_MODE_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LHC_BEAM_MODE_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LHC_BEAM_MODE_DATA*) (soff))->~G__THCAL_HLXcLcLLHC_BEAM_MODE_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_200_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_MODE_DATA* dest = (HCAL_HLX::LHC_BEAM_MODE_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::LHC_BEAM_MODE_DATA*) libp->para[0].ref;
   const HCAL_HLX::LHC_BEAM_MODE_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LHC_BEAM_ENERGY_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_201_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_ENERGY_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_ENERGY_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_ENERGY_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_ENERGY_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_ENERGY_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_201_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LHC_BEAM_ENERGY_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LHC_BEAM_ENERGY_DATA(*(HCAL_HLX::LHC_BEAM_ENERGY_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LHC_BEAM_ENERGY_DATA G__THCAL_HLXcLcLLHC_BEAM_ENERGY_DATA;
static int G__LumiRawDataStructuresLinkDef_201_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LHC_BEAM_ENERGY_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LHC_BEAM_ENERGY_DATA*) (soff+(sizeof(HCAL_HLX::LHC_BEAM_ENERGY_DATA)*i)))->~G__THCAL_HLXcLcLLHC_BEAM_ENERGY_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LHC_BEAM_ENERGY_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LHC_BEAM_ENERGY_DATA*) (soff))->~G__THCAL_HLXcLcLLHC_BEAM_ENERGY_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_201_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_ENERGY_DATA* dest = (HCAL_HLX::LHC_BEAM_ENERGY_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::LHC_BEAM_ENERGY_DATA*) libp->para[0].ref;
   const HCAL_HLX::LHC_BEAM_ENERGY_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LHC_BEAM_INTENSITY_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_202_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_INTENSITY_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_INTENSITY_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_INTENSITY_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_INTENSITY_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_INTENSITY_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_202_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LHC_BEAM_INTENSITY_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LHC_BEAM_INTENSITY_DATA(*(HCAL_HLX::LHC_BEAM_INTENSITY_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LHC_BEAM_INTENSITY_DATA G__THCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA;
static int G__LumiRawDataStructuresLinkDef_202_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LHC_BEAM_INTENSITY_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LHC_BEAM_INTENSITY_DATA*) (soff+(sizeof(HCAL_HLX::LHC_BEAM_INTENSITY_DATA)*i)))->~G__THCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LHC_BEAM_INTENSITY_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LHC_BEAM_INTENSITY_DATA*) (soff))->~G__THCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_202_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_INTENSITY_DATA* dest = (HCAL_HLX::LHC_BEAM_INTENSITY_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::LHC_BEAM_INTENSITY_DATA*) libp->para[0].ref;
   const HCAL_HLX::LHC_BEAM_INTENSITY_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_203_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_203_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA(*(HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA G__THCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA;
static int G__LumiRawDataStructuresLinkDef_203_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*) (soff+(sizeof(HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA)*i)))->~G__THCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*) (soff))->~G__THCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_203_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA* dest = (HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*) libp->para[0].ref;
   const HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::BEAM_INFO */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_206_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BEAM_INFO *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BEAM_INFO[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::BEAM_INFO[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BEAM_INFO;
     } else {
       p = new((void*) gvp) HCAL_HLX::BEAM_INFO;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_206_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::BEAM_INFO* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::BEAM_INFO(*(HCAL_HLX::BEAM_INFO*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::BEAM_INFO G__THCAL_HLXcLcLBEAM_INFO;
static int G__LumiRawDataStructuresLinkDef_206_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::BEAM_INFO*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::BEAM_INFO*) (soff+(sizeof(HCAL_HLX::BEAM_INFO)*i)))->~G__THCAL_HLXcLcLBEAM_INFO();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::BEAM_INFO*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::BEAM_INFO*) (soff))->~G__THCAL_HLXcLcLBEAM_INFO();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_206_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BEAM_INFO* dest = (HCAL_HLX::BEAM_INFO*) G__getstructoffset();
   *dest = *(HCAL_HLX::BEAM_INFO*) libp->para[0].ref;
   const HCAL_HLX::BEAM_INFO& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::BRANA_INFO */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_207_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRANA_INFO *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRANA_INFO[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::BRANA_INFO[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRANA_INFO;
     } else {
       p = new((void*) gvp) HCAL_HLX::BRANA_INFO;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_207_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::BRANA_INFO* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::BRANA_INFO(*(HCAL_HLX::BRANA_INFO*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::BRANA_INFO G__THCAL_HLXcLcLBRANA_INFO;
static int G__LumiRawDataStructuresLinkDef_207_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::BRANA_INFO*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::BRANA_INFO*) (soff+(sizeof(HCAL_HLX::BRANA_INFO)*i)))->~G__THCAL_HLXcLcLBRANA_INFO();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::BRANA_INFO*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::BRANA_INFO*) (soff))->~G__THCAL_HLXcLcLBRANA_INFO();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_207_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRANA_INFO* dest = (HCAL_HLX::BRANA_INFO*) G__getstructoffset();
   *dest = *(HCAL_HLX::BRANA_INFO*) libp->para[0].ref;
   const HCAL_HLX::BRANA_INFO& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::BRANP_INFO */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_208_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRANP_INFO *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRANP_INFO[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::BRANP_INFO[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRANP_INFO;
     } else {
       p = new((void*) gvp) HCAL_HLX::BRANP_INFO;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_208_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::BRANP_INFO* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::BRANP_INFO(*(HCAL_HLX::BRANP_INFO*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::BRANP_INFO G__THCAL_HLXcLcLBRANP_INFO;
static int G__LumiRawDataStructuresLinkDef_208_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::BRANP_INFO*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::BRANP_INFO*) (soff+(sizeof(HCAL_HLX::BRANP_INFO)*i)))->~G__THCAL_HLXcLcLBRANP_INFO();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::BRANP_INFO*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::BRANP_INFO*) (soff))->~G__THCAL_HLXcLcLBRANP_INFO();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_208_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRANP_INFO* dest = (HCAL_HLX::BRANP_INFO*) G__getstructoffset();
   *dest = *(HCAL_HLX::BRANP_INFO*) libp->para[0].ref;
   const HCAL_HLX::BRANP_INFO& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::BRAN_INFO */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_209_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRAN_INFO *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRAN_INFO[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::BRAN_INFO[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::BRAN_INFO;
     } else {
       p = new((void*) gvp) HCAL_HLX::BRAN_INFO;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_209_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::BRAN_INFO* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::BRAN_INFO(*(HCAL_HLX::BRAN_INFO*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::BRAN_INFO G__THCAL_HLXcLcLBRAN_INFO;
static int G__LumiRawDataStructuresLinkDef_209_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::BRAN_INFO*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::BRAN_INFO*) (soff+(sizeof(HCAL_HLX::BRAN_INFO)*i)))->~G__THCAL_HLXcLcLBRAN_INFO();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::BRAN_INFO*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::BRAN_INFO*) (soff))->~G__THCAL_HLXcLcLBRAN_INFO();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_209_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::BRAN_INFO* dest = (HCAL_HLX::BRAN_INFO*) G__getstructoffset();
   *dest = *(HCAL_HLX::BRAN_INFO*) libp->para[0].ref;
   const HCAL_HLX::BRAN_INFO& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* HCAL_HLX::DIP_COMBINED_DATA */
// automatic default constructor
static int G__LumiRawDataStructuresLinkDef_210_0_1(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::DIP_COMBINED_DATA *p;
   char* gvp = (char*) G__getgvp();
   int n = G__getaryconstruct();
   if (n) {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::DIP_COMBINED_DATA[n];
     } else {
       p = new((void*) gvp) HCAL_HLX::DIP_COMBINED_DATA[n];
     }
   } else {
     if ((gvp == (char*)G__PVOID) || (gvp == 0)) {
       p = new HCAL_HLX::DIP_COMBINED_DATA;
     } else {
       p = new((void*) gvp) HCAL_HLX::DIP_COMBINED_DATA;
     }
   }
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic copy constructor
static int G__LumiRawDataStructuresLinkDef_210_0_2(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)

{
   HCAL_HLX::DIP_COMBINED_DATA* p;
   void* tmp = (void*) G__int(libp->para[0]);
   p = new HCAL_HLX::DIP_COMBINED_DATA(*(HCAL_HLX::DIP_COMBINED_DATA*) tmp);
   result7->obj.i = (long) p;
   result7->ref = (long) p;
   G__set_tagnum(result7,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA));
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic destructor
typedef HCAL_HLX::DIP_COMBINED_DATA G__THCAL_HLXcLcLDIP_COMBINED_DATA;
static int G__LumiRawDataStructuresLinkDef_210_0_3(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   char* gvp = (char*) G__getgvp();
   long soff = G__getstructoffset();
   int n = G__getaryconstruct();
   //
   //has_a_delete: 0
   //has_own_delete1arg: 0
   //has_own_delete2arg: 0
   //
   if (!soff) {
     return(1);
   }
   if (n) {
     if (gvp == (char*)G__PVOID) {
       delete[] (HCAL_HLX::DIP_COMBINED_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       for (int i = n - 1; i >= 0; --i) {
         ((HCAL_HLX::DIP_COMBINED_DATA*) (soff+(sizeof(HCAL_HLX::DIP_COMBINED_DATA)*i)))->~G__THCAL_HLXcLcLDIP_COMBINED_DATA();
       }
       G__setgvp((long)gvp);
     }
   } else {
     if (gvp == (char*)G__PVOID) {
       delete (HCAL_HLX::DIP_COMBINED_DATA*) soff;
     } else {
       G__setgvp((long) G__PVOID);
       ((HCAL_HLX::DIP_COMBINED_DATA*) (soff))->~G__THCAL_HLXcLcLDIP_COMBINED_DATA();
       G__setgvp((long)gvp);
     }
   }
   G__setnull(result7);
   return(1 || funcname || hash || result7 || libp) ;
}

// automatic assignment operator
static int G__LumiRawDataStructuresLinkDef_210_0_4(G__value* result7, G__CONST char* funcname, struct G__param* libp, int hash)
{
   HCAL_HLX::DIP_COMBINED_DATA* dest = (HCAL_HLX::DIP_COMBINED_DATA*) G__getstructoffset();
   *dest = *(HCAL_HLX::DIP_COMBINED_DATA*) libp->para[0].ref;
   const HCAL_HLX::DIP_COMBINED_DATA& obj = *dest;
   result7->ref = (long) (&obj);
   result7->obj.i = (long) (&obj);
   return(1 || funcname || hash || result7 || libp) ;
}


/* Setting up global function */

/*********************************************************
* Member function Stub
*********************************************************/

/* HCAL_HLX */

/* HCAL_HLX::DAQ_HEART_BEAT */

/* HCAL_HLX::RUN_SUMMARY */

/* HCAL_HLX::RUN_QUALITY */

/* HCAL_HLX::RCMS_CONFIG */

/* HCAL_HLX::LUMI_SUMMARY */

/* HCAL_HLX::LUMI_DETAIL */

/* HCAL_HLX::LEVEL1_PATH */

/* HCAL_HLX::LEVEL1_TRIGGER */

/* HCAL_HLX::HLT_PATH */

/* HCAL_HLX::HLTRIGGER */

/* HCAL_HLX::LUMI_RAW_HEADER */

/* HCAL_HLX::LUMI_NIBBLE_HEADER */

/* HCAL_HLX::ET_SUM_NIBBLE */

/* HCAL_HLX::OCCUPANCY_NIBBLE */

/* HCAL_HLX::LHC_NIBBLE */

/* HCAL_HLX::LUMI_SECTION_HEADER */

/* HCAL_HLX::LUMI_SECTION_SUB_HEADER */

/* HCAL_HLX::ET_SUM_SECTION */

/* HCAL_HLX::OCCUPANCY_SECTION */

/* HCAL_HLX::LHC_SECTION */

/* HCAL_HLX::LUMI_SECTION */

/* HCAL_HLX::DIP_STRUCT_BASE */

/* HCAL_HLX::VDM_SCAN_DATA */

/* HCAL_HLX::BRAN_DATA */

/* HCAL_HLX::BRAN_BX_DATA */

/* HCAL_HLX::LHC_BEAM_CONFIG */

/* HCAL_HLX::LHC_FILL_DATA */

/* HCAL_HLX::CMS_LUMI_DIP_DATA */

/* HCAL_HLX::TRIGGER_LUMI_SEGMENT */

/* HCAL_HLX::LHC_BEAM_MODE_DATA */

/* HCAL_HLX::LHC_BEAM_ENERGY_DATA */

/* HCAL_HLX::LHC_BEAM_INTENSITY_DATA */

/* HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA */

/* HCAL_HLX::BEAM_INFO */

/* HCAL_HLX::BRANA_INFO */

/* HCAL_HLX::BRANP_INFO */

/* HCAL_HLX::BRAN_INFO */

/* HCAL_HLX::DIP_COMBINED_DATA */

/*********************************************************
* Global function Stub
*********************************************************/

/*********************************************************
* Get size of pointer to member function
*********************************************************/
class G__Sizep2memfuncLumiRawDataStructuresLinkDef {
 public:
  G__Sizep2memfuncLumiRawDataStructuresLinkDef(): p(&G__Sizep2memfuncLumiRawDataStructuresLinkDef::sizep2memfunc) {}
    size_t sizep2memfunc() { return(sizeof(p)); }
  private:
    size_t (G__Sizep2memfuncLumiRawDataStructuresLinkDef::*p)();
};

size_t G__get_sizep2memfuncLumiRawDataStructuresLinkDef()
{
  G__Sizep2memfuncLumiRawDataStructuresLinkDef a;
  G__setsizep2memfunc((int)a.sizep2memfunc());
  return((size_t)a.sizep2memfunc());
}


/*********************************************************
* virtual base class offset calculation interface
*********************************************************/

   /* Setting up class inheritance */

/*********************************************************
* Inheritance information setup/
*********************************************************/
extern "C" void G__cpp_setup_inheritanceLumiRawDataStructuresLinkDef() {

   /* Setting up class inheritance */
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA))) {
     HCAL_HLX::VDM_SCAN_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::VDM_SCAN_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA))) {
     HCAL_HLX::BRAN_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::BRAN_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA))) {
     HCAL_HLX::BRAN_BX_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::BRAN_BX_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG))) {
     HCAL_HLX::LHC_BEAM_CONFIG *G__Lderived;
     G__Lderived=(HCAL_HLX::LHC_BEAM_CONFIG*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA))) {
     HCAL_HLX::LHC_FILL_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::LHC_FILL_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA))) {
     HCAL_HLX::CMS_LUMI_DIP_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::CMS_LUMI_DIP_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT))) {
     HCAL_HLX::TRIGGER_LUMI_SEGMENT *G__Lderived;
     G__Lderived=(HCAL_HLX::TRIGGER_LUMI_SEGMENT*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA))) {
     HCAL_HLX::LHC_BEAM_MODE_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::LHC_BEAM_MODE_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA))) {
     HCAL_HLX::LHC_BEAM_ENERGY_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::LHC_BEAM_ENERGY_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA))) {
     HCAL_HLX::LHC_BEAM_INTENSITY_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA))) {
     HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
   if(0==G__getnumbaseclass(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA))) {
     HCAL_HLX::DIP_COMBINED_DATA *G__Lderived;
     G__Lderived=(HCAL_HLX::DIP_COMBINED_DATA*)0x1000;
     {
       HCAL_HLX::DIP_STRUCT_BASE *G__Lpbase=(HCAL_HLX::DIP_STRUCT_BASE*)G__Lderived;
       G__inheritance_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA),G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),(long)G__Lpbase-(long)G__Lderived,1,1);
     }
   }
}

/*********************************************************
* typedef information setup/
*********************************************************/
extern "C" void G__cpp_setup_typetableLumiRawDataStructuresLinkDef() {

   /* Setting up typedef entry */
   G__search_typename2("vector<ROOT::TSchemaHelper>",117,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_vectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgR),0,-1);
   G__setnewtype(-1,NULL,0);
   G__search_typename2("reverse_iterator<const_iterator>",117,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgRcLcLiteratorgR),0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_vectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgR));
   G__setnewtype(-1,NULL,0);
   G__search_typename2("reverse_iterator<iterator>",117,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgRcLcLiteratorgR),0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_vectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgR));
   G__setnewtype(-1,NULL,0);
   G__search_typename2("vector<TVirtualArray*>",117,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_vectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgR),0,-1);
   G__setnewtype(-1,NULL,0);
   G__search_typename2("reverse_iterator<const_iterator>",117,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgRcLcLiteratorgR),0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_vectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgR));
   G__setnewtype(-1,NULL,0);
   G__search_typename2("reverse_iterator<iterator>",117,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgRcLcLiteratorgR),0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_vectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgR));
   G__setnewtype(-1,NULL,0);
}

/*********************************************************
* Data Member information setup/
*********************************************************/

   /* Setting up class,struct,union tag member variable */

   /* HCAL_HLX */
static void G__setup_memvarHCAL_HLX(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLX));
   {
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::DAQ_HEART_BEAT */
static void G__setup_memvarHCAL_HLXcLcLDAQ_HEART_BEAT(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT));
   { HCAL_HLX::DAQ_HEART_BEAT *p; p=(HCAL_HLX::DAQ_HEART_BEAT*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->runNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"runNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->sectionNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"sectionNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->bCMSLive)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"bCMSLive=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->timestamp)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->timestamp_micros)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp_micros=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::RUN_SUMMARY */
static void G__setup_memvarHCAL_HLXcLcLRUN_SUMMARY(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY));
   { HCAL_HLX::RUN_SUMMARY *p; p=(HCAL_HLX::RUN_SUMMARY*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->runSequenceName)-(long)(p)),99,0,0,-1,-1,-1,1,"runSequenceName[128]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->HLTConfigId)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"HLTConfigId=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->timestamp)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->timestamp_micros)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp_micros=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->startOrbitNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"startOrbitNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->endOrbitnumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"endOrbitnumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->runNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"runNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->fillNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"fillNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->numberCMSLumiSections)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"numberCMSLumiSections=",0,"number of lumi sections from the trigger");
   G__memvar_setup((void*)((long)(&p->numberLumiDAQLumiSections)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"numberLumiDAQLumiSections=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::RUN_QUALITY */
static void G__setup_memvarHCAL_HLXcLcLRUN_QUALITY(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY));
   { HCAL_HLX::RUN_QUALITY *p; p=(HCAL_HLX::RUN_QUALITY*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->runNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"runNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->sectionNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"sectionNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->HLX)-(long)(p)),105,0,0,-1,-1,-1,1,"HLX=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->HFLumi)-(long)(p)),105,0,0,-1,-1,-1,1,"HFLumi=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->ECAL)-(long)(p)),105,0,0,-1,-1,-1,1,"ECAL=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->HCAL)-(long)(p)),105,0,0,-1,-1,-1,1,"HCAL=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->Tracker)-(long)(p)),105,0,0,-1,-1,-1,1,"Tracker=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->RPC)-(long)(p)),105,0,0,-1,-1,-1,1,"RPC=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DT)-(long)(p)),105,0,0,-1,-1,-1,1,"DT=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->CSC)-(long)(p)),105,0,0,-1,-1,-1,1,"CSC=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::RCMS_CONFIG */
static void G__setup_memvarHCAL_HLXcLcLRCMS_CONFIG(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG));
   { HCAL_HLX::RCMS_CONFIG *p; p=(HCAL_HLX::RCMS_CONFIG*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->runNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"runNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->CMSSW_Tag)-(long)(p)),99,0,0,-1,-1,-1,1,"CMSSW_Tag[32]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->TriDAS_Tag)-(long)(p)),99,0,0,-1,-1,-1,1,"TriDAS_Tag[32]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->FirmwareVersion)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"FirmwareVersion=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->ExpectedFirmwareVersion)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"ExpectedFirmwareVersion=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->AddressTablePath)-(long)(p)),99,0,0,-1,-1,-1,1,"AddressTablePath[256]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->CfgDBTag)-(long)(p)),99,0,0,-1,-1,-1,1,"CfgDBTag[64]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->CfgDBAccessor)-(long)(p)),99,0,0,-1,-1,-1,1,"CfgDBAccessor[64]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->UseConfigDB)-(long)(p)),103,0,0,-1,-1,-1,1,"UseConfigDB=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DestIPHigh)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DestIPHigh=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DestIPLow)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DestIPLow=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SrcIPBaseHigh)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SrcIPBaseHigh=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SrcIPBaseLow)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SrcIPBaseLow=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DestMacAddrHigh)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DestMacAddrHigh=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DestMacAddrMed)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DestMacAddrMed=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DestMacAddrLow)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DestMacAddrLow=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SrcMacAddrHigh)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SrcMacAddrHigh=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SrcMacAddrMed)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SrcMacAddrMed=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SrcMacAddrLow)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SrcMacAddrLow=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SrcPort)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SrcPort=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DestPort)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DestPort=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DebugData)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DebugData=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DebugReadout)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DebugReadout=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->DebugSingleCycle)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"DebugSingleCycle=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->NumOrbits)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"NumOrbits=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OrbitPeriod)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"OrbitPeriod=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->Id)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"Id=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->TTCBC0Pattern)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"TTCBC0Pattern=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->TTCSTARTPattern)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"TTCSTARTPattern=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->TTCSTOPPattern)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"TTCSTOPPattern=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->BC0Delay)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"BC0Delay=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccThresholdLowBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"OccThresholdLowBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccThresholdLowTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"OccThresholdLowTop=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccThresholdHighBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"OccThresholdHighBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccThresholdHighTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"OccThresholdHighTop=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->LHCThresholdBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"LHCThresholdBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->LHCThresholdTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"LHCThresholdTop=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->ETSumCutoffBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"ETSumCutoffBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->ETSumCutoffTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"ETSumCutoffTop=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OCCMaskBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"OCCMaskBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OCCMaskTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"OCCMaskTop=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->LHCMaskLowBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"LHCMaskLowBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->LHCMaskLowTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"LHCMaskLowTop=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->LHCMaskHighBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"LHCMaskHighBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->LHCMaskHighTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"LHCMaskHighTop=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SumETMaskLowBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SumETMaskLowBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SumETMaskLowTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SumETMaskLowTop=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SumETMaskHighBottom)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SumETMaskHighBottom=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->SumETMaskHighTop)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"SumETMaskHighTop=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LUMI_SUMMARY */
static void G__setup_memvarHCAL_HLXcLcLLUMI_SUMMARY(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY));
   { HCAL_HLX::LUMI_SUMMARY *p; p=(HCAL_HLX::LUMI_SUMMARY*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->DeadTimeNormalization)-(long)(p)),102,0,0,-1,-1,-1,1,"DeadTimeNormalization=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->LHCNormalization)-(long)(p)),102,0,0,-1,-1,-1,1,"LHCNormalization=",0,"recieved from LHC ");
   G__memvar_setup((void*)((long)(&p->InstantLumi)-(long)(p)),102,0,0,-1,-1,-1,1,"InstantLumi=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->InstantLumiErr)-(long)(p)),102,0,0,-1,-1,-1,1,"InstantLumiErr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->InstantLumiQlty)-(long)(p)),115,0,0,-1,G__defined_typename("int16_t"),-1,1,"InstantLumiQlty=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->InstantETLumi)-(long)(p)),102,0,0,-1,-1,-1,1,"InstantETLumi=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->InstantETLumiErr)-(long)(p)),102,0,0,-1,-1,-1,1,"InstantETLumiErr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->InstantETLumiQlty)-(long)(p)),115,0,0,-1,G__defined_typename("int16_t"),-1,1,"InstantETLumiQlty=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->ETNormalization)-(long)(p)),102,0,0,-1,-1,-1,1,"ETNormalization=",0,"Calculated");
   G__memvar_setup((void*)((long)(&p->InstantOccLumi)-(long)(p)),102,0,0,-1,-1,-1,1,"InstantOccLumi[2]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->InstantOccLumiErr)-(long)(p)),102,0,0,-1,-1,-1,1,"InstantOccLumiErr[2]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->InstantOccLumiQlty)-(long)(p)),115,0,0,-1,G__defined_typename("int16_t"),-1,1,"InstantOccLumiQlty[2]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccNormalization)-(long)(p)),102,0,0,-1,-1,-1,1,"OccNormalization[2]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->lumiNoise)-(long)(p)),102,0,0,-1,-1,-1,1,"lumiNoise[2]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LUMI_DETAIL */
static void G__setup_memvarHCAL_HLXcLcLLUMI_DETAIL(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL));
   { HCAL_HLX::LUMI_DETAIL *p; p=(HCAL_HLX::LUMI_DETAIL*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->LHCLumi)-(long)(p)),102,0,0,-1,-1,-1,1,"LHCLumi[4096]=",0,"Sum of LHC.data over all HLX's");
   G__memvar_setup((void*)((long)(&p->ETLumi)-(long)(p)),102,0,0,-1,-1,-1,1,"ETLumi[4096]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->ETLumiErr)-(long)(p)),102,0,0,-1,-1,-1,1,"ETLumiErr[4096]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->ETLumiQlty)-(long)(p)),115,0,0,-1,G__defined_typename("int16_t"),-1,1,"ETLumiQlty[4096]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->ETBXNormalization)-(long)(p)),102,0,0,-1,-1,-1,1,"ETBXNormalization[4096]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccLumi)-(long)(p)),102,0,0,-1,-1,-1,1,"OccLumi[2][4096]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccLumiErr)-(long)(p)),102,0,0,-1,-1,-1,1,"OccLumiErr[2][4096]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccLumiQlty)-(long)(p)),115,0,0,-1,G__defined_typename("int16_t"),-1,1,"OccLumiQlty[2][4096]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->OccBXNormalization)-(long)(p)),102,0,0,-1,-1,-1,1,"OccBXNormalization[2][4096]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LEVEL1_PATH */
static void G__setup_memvarHCAL_HLXcLcLLEVEL1_PATH(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH));
   { HCAL_HLX::LEVEL1_PATH *p; p=(HCAL_HLX::LEVEL1_PATH*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->pathName)-(long)(p)),99,0,0,-1,-1,-1,1,"pathName[128]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->counts)-(long)(p)),107,0,0,-1,G__defined_typename("uint64_t"),-1,1,"counts=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->prescale)-(long)(p)),107,0,0,-1,G__defined_typename("uint64_t"),-1,1,"prescale=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LEVEL1_TRIGGER */
static void G__setup_memvarHCAL_HLXcLcLLEVEL1_TRIGGER(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER));
   { HCAL_HLX::LEVEL1_TRIGGER *p; p=(HCAL_HLX::LEVEL1_TRIGGER*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->runNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"runNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->sectionNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"sectionNumber=",0,"Lumi section number recorded by the daq.");
   G__memvar_setup((void*)((long)(&p->timestamp)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->timestamp_micros)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp_micros=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->deadtimecount)-(long)(p)),107,0,0,-1,G__defined_typename("uint64_t"),-1,1,"deadtimecount=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->GTLumiInfoFormat)-(long)(p)),99,0,0,-1,-1,-1,1,"GTLumiInfoFormat[32]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->GTAlgo)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH),-1,-1,1,"GTAlgo[128]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->GTTech)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH),-1,-1,1,"GTTech[64]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::HLT_PATH */
static void G__setup_memvarHCAL_HLXcLcLHLT_PATH(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH));
   { HCAL_HLX::HLT_PATH *p; p=(HCAL_HLX::HLT_PATH*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->PathName)-(long)(p)),99,0,0,-1,-1,-1,1,"PathName[128]=",0,"This is the name of trigger path");
   G__memvar_setup((void*)((long)(&p->L1Pass)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"L1Pass=",0,"Number of times the path was entered");
   G__memvar_setup((void*)((long)(&p->PSPass)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"PSPass=",0,"Number after prescaling");
   G__memvar_setup((void*)((long)(&p->PAccept)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"PAccept=",0,"Number of accepts by the trigger path");
   G__memvar_setup((void*)((long)(&p->PExcept)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"PExcept=",0,"Number of exceptional event encountered");
   G__memvar_setup((void*)((long)(&p->PReject)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"PReject=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->PrescalerModule)-(long)(p)),99,0,0,-1,-1,-1,1,"PrescalerModule[64]=",0,"Name of the prescale module in the path");
   G__memvar_setup((void*)((long)(&p->PSIndex)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"PSIndex=",0,"Index into the set of pre defined prescales");
   G__memvar_setup((void*)((long)(&p->Prescale)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"Prescale=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->HLTConfigId)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"HLTConfigId=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::HLTRIGGER */
static void G__setup_memvarHCAL_HLXcLcLHLTRIGGER(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER));
   { HCAL_HLX::HLTRIGGER *p; p=(HCAL_HLX::HLTRIGGER*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->runNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"runNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->sectionNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"sectionNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->numPaths)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"numPaths=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->HLTPaths)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH),-1,-1,1,"HLTPaths[256]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LUMI_RAW_HEADER */
static void G__setup_memvarHCAL_HLXcLcLLUMI_RAW_HEADER(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER));
   { HCAL_HLX::LUMI_RAW_HEADER *p; p=(HCAL_HLX::LUMI_RAW_HEADER*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->marker)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"marker=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->hlxID)-(long)(p)),98,0,0,-1,G__defined_typename("uint8_t"),-1,1,"hlxID=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->packetID)-(long)(p)),98,0,0,-1,G__defined_typename("uint8_t"),-1,1,"packetID=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->startOrbit)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"startOrbit=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->numOrbits)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"numOrbits=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->startBunch)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"startBunch=",0,"Starting bunch in this packet");
   G__memvar_setup((void*)((long)(&p->numBunches)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"numBunches=",0,"Total number of bunches in histogram");
   G__memvar_setup((void*)((long)(&p->histogramSet)-(long)(p)),98,0,0,-1,G__defined_typename("uint8_t"),-1,1,"histogramSet=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->histogramSequence)-(long)(p)),98,0,0,-1,G__defined_typename("uint8_t"),-1,1,"histogramSequence=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->allA)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"allA=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->allF)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"allF=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LUMI_NIBBLE_HEADER */
static void G__setup_memvarHCAL_HLXcLcLLUMI_NIBBLE_HEADER(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER));
   { HCAL_HLX::LUMI_NIBBLE_HEADER *p; p=(HCAL_HLX::LUMI_NIBBLE_HEADER*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->startOrbit)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"startOrbit=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->numOrbits)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"numOrbits=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->numBunches)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"numBunches=",0,"Number of bunches histogrammed");
   G__memvar_setup((void*)((long)(&p->bCMSLive)-(long)(p)),103,0,0,-1,-1,-1,1,"bCMSLive=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->bOC0)-(long)(p)),103,0,0,-1,-1,-1,1,"bOC0=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::ET_SUM_NIBBLE */
static void G__setup_memvarHCAL_HLXcLcLET_SUM_NIBBLE(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE));
   { HCAL_HLX::ET_SUM_NIBBLE *p; p=(HCAL_HLX::ET_SUM_NIBBLE*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->hdr)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER),-1,-1,1,"hdr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->data)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"data[4096]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::OCCUPANCY_NIBBLE */
static void G__setup_memvarHCAL_HLXcLcLOCCUPANCY_NIBBLE(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE));
   { HCAL_HLX::OCCUPANCY_NIBBLE *p; p=(HCAL_HLX::OCCUPANCY_NIBBLE*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->hdr)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER),-1,-1,1,"hdr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->data)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"data[6][4096]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LHC_NIBBLE */
static void G__setup_memvarHCAL_HLXcLcLLHC_NIBBLE(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE));
   { HCAL_HLX::LHC_NIBBLE *p; p=(HCAL_HLX::LHC_NIBBLE*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->hdr)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER),-1,-1,1,"hdr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->data)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"data[4096]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LUMI_SECTION_HEADER */
static void G__setup_memvarHCAL_HLXcLcLLUMI_SECTION_HEADER(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER));
   { HCAL_HLX::LUMI_SECTION_HEADER *p; p=(HCAL_HLX::LUMI_SECTION_HEADER*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->timestamp)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->timestamp_micros)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp_micros=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->runNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"runNumber=",0,"Run number");
   G__memvar_setup((void*)((long)(&p->sectionNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"sectionNumber=",0,"Section number");
   G__memvar_setup((void*)((long)(&p->startOrbit)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"startOrbit=",0,"Start orbit of lumi section");
   G__memvar_setup((void*)((long)(&p->numOrbits)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"numOrbits=",0,"Total number of orbits recorded in lumi section");
   G__memvar_setup((void*)((long)(&p->numBunches)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"numBunches=",0,"Total number of bunches (from start of orbit)");
   G__memvar_setup((void*)((long)(&p->numHLXs)-(long)(p)),114,0,0,-1,G__defined_typename("uint16_t"),-1,1,"numHLXs=",0,"Number of HLXs in lumi section");
   G__memvar_setup((void*)((long)(&p->bCMSLive)-(long)(p)),103,0,0,-1,-1,-1,1,"bCMSLive=",0,"Is CMS taking data?");
   G__memvar_setup((void*)((long)(&p->bOC0)-(long)(p)),103,0,0,-1,-1,-1,1,"bOC0=",0,"Was section initialised by an OC0?");
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LUMI_SECTION_SUB_HEADER */
static void G__setup_memvarHCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER));
   { HCAL_HLX::LUMI_SECTION_SUB_HEADER *p; p=(HCAL_HLX::LUMI_SECTION_SUB_HEADER*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->numNibbles)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"numNibbles=",0,"Number of nibbles in this histogram");
   G__memvar_setup((void*)((long)(&p->bIsComplete)-(long)(p)),103,0,0,-1,-1,-1,1,"bIsComplete=",0,"Is this histogram complete (i.e. no missing nibbles)");
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::ET_SUM_SECTION */
static void G__setup_memvarHCAL_HLXcLcLET_SUM_SECTION(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION));
   { HCAL_HLX::ET_SUM_SECTION *p; p=(HCAL_HLX::ET_SUM_SECTION*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->hdr)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER),-1,-1,1,"hdr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->data)-(long)(p)),102,0,0,-1,-1,-1,1,"data[4096]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::OCCUPANCY_SECTION */
static void G__setup_memvarHCAL_HLXcLcLOCCUPANCY_SECTION(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION));
   { HCAL_HLX::OCCUPANCY_SECTION *p; p=(HCAL_HLX::OCCUPANCY_SECTION*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->hdr)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER),-1,-1,1,"hdr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->data)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"data[6][4096]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LHC_SECTION */
static void G__setup_memvarHCAL_HLXcLcLLHC_SECTION(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION));
   { HCAL_HLX::LHC_SECTION *p; p=(HCAL_HLX::LHC_SECTION*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->hdr)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER),-1,-1,1,"hdr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->data)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"data[4096]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LUMI_SECTION */
static void G__setup_memvarHCAL_HLXcLcLLUMI_SECTION(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION));
   { HCAL_HLX::LUMI_SECTION *p; p=(HCAL_HLX::LUMI_SECTION*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->hdr)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER),-1,-1,1,"hdr=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->lumiSummary)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY),-1,-1,1,"lumiSummary=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->lumiDetail)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL),-1,-1,1,"lumiDetail=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->etSum)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION),-1,-1,1,"etSum[36]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->occupancy)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION),-1,-1,1,"occupancy[36]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->lhc)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION),-1,-1,1,"lhc[36]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::DIP_STRUCT_BASE */
static void G__setup_memvarHCAL_HLXcLcLDIP_STRUCT_BASE(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE));
   { HCAL_HLX::DIP_STRUCT_BASE *p; p=(HCAL_HLX::DIP_STRUCT_BASE*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->MessageQuality)-(long)(p)),105,0,0,-1,-1,-1,1,"MessageQuality=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->timestamp)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->timestamp_micros)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"timestamp_micros=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->runNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"runNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->sectionNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"sectionNumber=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::VDM_SCAN_DATA */
static void G__setup_memvarHCAL_HLXcLcLVDM_SCAN_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA));
   { HCAL_HLX::VDM_SCAN_DATA *p; p=(HCAL_HLX::VDM_SCAN_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->VdmMode)-(long)(p)),103,0,0,-1,-1,-1,1,"VdmMode=",0,"True when a scan at one of the IPs is imminent, false otherwise");
   G__memvar_setup((void*)((long)(&p->IP)-(long)(p)),105,0,0,-1,-1,-1,1,"IP=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->RecordDataFlag)-(long)(p)),103,0,0,-1,-1,-1,1,"RecordDataFlag=",0,"True while data for one of the scan points at one of the IPs is being taken, false otherwise   ");
   G__memvar_setup((void*)((long)(&p->BeamSeparation)-(long)(p)),100,0,0,-1,-1,-1,1,"BeamSeparation=",0,"separation in sigma for the scan point  ");
   G__memvar_setup((void*)((long)(&p->isXaxis)-(long)(p)),103,0,0,-1,-1,-1,1,"isXaxis=",0,"true if scanning xaxis, otherwise yaxis is being scanned ");
   G__memvar_setup((void*)((long)(&p->Beam)-(long)(p)),105,0,0,-1,-1,-1,1,"Beam=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->StepProgress)-(long)(p)),100,0,0,-1,-1,-1,1,"StepProgress=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::BRAN_DATA */
static void G__setup_memvarHCAL_HLXcLcLBRAN_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA));
   { HCAL_HLX::BRAN_DATA *p; p=(HCAL_HLX::BRAN_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->MeanCrossingAngle)-(long)(p)),100,0,0,-1,-1,-1,1,"MeanCrossingAngle=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->AcqMode)-(long)(p)),105,0,0,-1,-1,-1,1,"AcqMode=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->MeanLuminosity)-(long)(p)),100,0,0,-1,-1,-1,1,"MeanLuminosity=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::BRAN_BX_DATA */
static void G__setup_memvarHCAL_HLXcLcLBRAN_BX_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA));
   { HCAL_HLX::BRAN_BX_DATA *p; p=(HCAL_HLX::BRAN_BX_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->bunchByBunchLuminosity)-(long)(p)),100,0,0,-1,-1,-1,1,"bunchByBunchLuminosity[3564]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->AcqMode)-(long)(p)),105,0,0,-1,-1,-1,1,"AcqMode=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LHC_BEAM_CONFIG */
static void G__setup_memvarHCAL_HLXcLcLLHC_BEAM_CONFIG(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG));
   { HCAL_HLX::LHC_BEAM_CONFIG *p; p=(HCAL_HLX::LHC_BEAM_CONFIG*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->beamConfig)-(long)(p)),105,0,0,-1,-1,-1,1,"beamConfig[3564]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LHC_FILL_DATA */
static void G__setup_memvarHCAL_HLXcLcLLHC_FILL_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA));
   { HCAL_HLX::LHC_FILL_DATA *p; p=(HCAL_HLX::LHC_FILL_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->FillNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"FillNumber=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::CMS_LUMI_DIP_DATA */
static void G__setup_memvarHCAL_HLXcLcLCMS_LUMI_DIP_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA));
   { HCAL_HLX::CMS_LUMI_DIP_DATA *p; p=(HCAL_HLX::CMS_LUMI_DIP_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->numHLXs)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"numHLXs=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->startOrbit)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"startOrbit=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->numOrbits)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"numOrbits=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->numBunches)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"numBunches=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->instantLumi)-(long)(p)),102,0,0,-1,-1,-1,1,"instantLumi=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->instantLumiErr)-(long)(p)),102,0,0,-1,-1,-1,1,"instantLumiErr=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::TRIGGER_LUMI_SEGMENT */
static void G__setup_memvarHCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT));
   { HCAL_HLX::TRIGGER_LUMI_SEGMENT *p; p=(HCAL_HLX::TRIGGER_LUMI_SEGMENT*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->state)-(long)(p)),99,0,0,-1,-1,-1,1,"state[64]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->deadtime)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"deadtime=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->deadtimeBeamActive)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"deadtimeBeamActive=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->lumiSegmentNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"lumiSegmentNumber=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LHC_BEAM_MODE_DATA */
static void G__setup_memvarHCAL_HLXcLcLLHC_BEAM_MODE_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA));
   { HCAL_HLX::LHC_BEAM_MODE_DATA *p; p=(HCAL_HLX::LHC_BEAM_MODE_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->beamMode)-(long)(p)),99,0,0,-1,-1,-1,1,"beamMode[64]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LHC_BEAM_ENERGY_DATA */
static void G__setup_memvarHCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA));
   { HCAL_HLX::LHC_BEAM_ENERGY_DATA *p; p=(HCAL_HLX::LHC_BEAM_ENERGY_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->singleBeamEnergy)-(long)(p)),102,0,0,-1,-1,-1,1,"singleBeamEnergy=",0,"GeV");
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LHC_BEAM_INTENSITY_DATA */
static void G__setup_memvarHCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA));
   { HCAL_HLX::LHC_BEAM_INTENSITY_DATA *p; p=(HCAL_HLX::LHC_BEAM_INTENSITY_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->beamIntensity)-(long)(p)),100,0,0,-1,-1,-1,1,"beamIntensity=",0,"total num protons in beam summed over all bxs");
   G__memvar_setup((void*)((long)(&p->primitiveLifetime)-(long)(p)),100,0,0,-1,-1,-1,1,"primitiveLifetime=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->acqTimeStamp)-(long)(p)),107,0,0,-1,G__defined_typename("uint64_t"),-1,1,"acqTimeStamp=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA */
static void G__setup_memvarHCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA));
   { HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA *p; p=(HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->bestLifetime)-(long)(p)),100,0,0,-1,-1,-1,1,"bestLifetime=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->averageBeamIntensity)-(long)(p)),100,0,0,-1,-1,-1,1,"averageBeamIntensity=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->averageBunchIntensities)-(long)(p)),102,0,0,-1,-1,-1,1,"averageBunchIntensities[3564]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::BEAM_INFO */
static void G__setup_memvarHCAL_HLXcLcLBEAM_INFO(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO));
   { HCAL_HLX::BEAM_INFO *p; p=(HCAL_HLX::BEAM_INFO*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->totalIntensity)-(long)(p)),100,0,0,-1,-1,-1,1,"totalIntensity=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->primitiveLifetime)-(long)(p)),100,0,0,-1,-1,-1,1,"primitiveLifetime=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->bestLifeTime)-(long)(p)),100,0,0,-1,-1,-1,1,"bestLifeTime=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->averageBeamIntensity)-(long)(p)),100,0,0,-1,-1,-1,1,"averageBeamIntensity=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->orbitFrequency)-(long)(p)),102,0,0,-1,-1,-1,1,"orbitFrequency=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->averageBunchIntensities)-(long)(p)),102,0,0,-1,-1,-1,1,"averageBunchIntensities[3564]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->beamConfig)-(long)(p)),105,0,0,-1,-1,-1,1,"beamConfig[3564]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::BRANA_INFO */
static void G__setup_memvarHCAL_HLXcLcLBRANA_INFO(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO));
   { HCAL_HLX::BRANA_INFO *p; p=(HCAL_HLX::BRANA_INFO*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->meanCrossingAngle)-(long)(p)),100,0,0,-1,-1,-1,1,"meanCrossingAngle=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->acqMode)-(long)(p)),105,0,0,-1,-1,-1,1,"acqMode=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->meanLuminosity)-(long)(p)),100,0,0,-1,-1,-1,1,"meanLuminosity=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->bunchByBunchLuminosity)-(long)(p)),100,0,0,-1,-1,-1,1,"bunchByBunchLuminosity[3564]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::BRANP_INFO */
static void G__setup_memvarHCAL_HLXcLcLBRANP_INFO(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO));
   { HCAL_HLX::BRANP_INFO *p; p=(HCAL_HLX::BRANP_INFO*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->meanCrossingAngle)-(long)(p)),100,0,0,-1,-1,-1,1,"meanCrossingAngle=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->acqMode)-(long)(p)),105,0,0,-1,-1,-1,1,"acqMode=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->counterAcquisition)-(long)(p)),105,0,0,-1,-1,-1,1,"counterAcquisition=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->meanLuminosity)-(long)(p)),100,0,0,-1,-1,-1,1,"meanLuminosity=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->meanCrossingAngleError)-(long)(p)),100,0,0,-1,-1,-1,1,"meanCrossingAngleError=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->meanLuminosityError)-(long)(p)),100,0,0,-1,-1,-1,1,"meanLuminosityError=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->bunchByBunchLuminosity)-(long)(p)),100,0,0,-1,-1,-1,1,"bunchByBunchLuminosity[3564]=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::BRAN_INFO */
static void G__setup_memvarHCAL_HLXcLcLBRAN_INFO(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO));
   { HCAL_HLX::BRAN_INFO *p; p=(HCAL_HLX::BRAN_INFO*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->branA)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO),-1,-1,1,"branA=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->branP)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO),-1,-1,1,"branP=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}


   /* HCAL_HLX::DIP_COMBINED_DATA */
static void G__setup_memvarHCAL_HLXcLcLDIP_COMBINED_DATA(void) {
   G__tag_memvar_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA));
   { HCAL_HLX::DIP_COMBINED_DATA *p; p=(HCAL_HLX::DIP_COMBINED_DATA*)0x1000; if (p) { }
   G__memvar_setup((void*)((long)(&p->beamMode)-(long)(p)),99,0,0,-1,-1,-1,1,"beamMode[128]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->Energy)-(long)(p)),102,0,0,-1,-1,-1,1,"Energy=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->FillNumber)-(long)(p)),104,0,0,-1,G__defined_typename("uint32_t"),-1,1,"FillNumber=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->Beam)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO),-1,-1,1,"Beam[2]=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->BRAN4L1)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO),-1,-1,1,"BRAN4L1=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->BRAN4R1)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO),-1,-1,1,"BRAN4R1=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->BRAN4L5)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO),-1,-1,1,"BRAN4L5=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->BRAN4R5)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO),-1,-1,1,"BRAN4R5=",0,(char*)NULL);
   G__memvar_setup((void*)((long)(&p->VdMScan)-(long)(p)),117,0,0,G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA),-1,-1,1,"VdMScan=",0,(char*)NULL);
   }
   G__tag_memvar_reset();
}

extern "C" void G__cpp_setup_memvarLumiRawDataStructuresLinkDef() {
}
/***********************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
***********************************************************/

/*********************************************************
* Member function information setup for each class
*********************************************************/
static void G__setup_memfuncHCAL_HLX(void) {
   /* HCAL_HLX */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLX));
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLDAQ_HEART_BEAT(void) {
   /* HCAL_HLX::DAQ_HEART_BEAT */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT));
   // automatic default constructor
   G__memfunc_setup("DAQ_HEART_BEAT", 1060, G__LumiRawDataStructuresLinkDef_169_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("DAQ_HEART_BEAT", 1060, G__LumiRawDataStructuresLinkDef_169_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::DAQ_HEART_BEAT' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~DAQ_HEART_BEAT", 1186, G__LumiRawDataStructuresLinkDef_169_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_169_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::DAQ_HEART_BEAT' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLRUN_SUMMARY(void) {
   /* HCAL_HLX::RUN_SUMMARY */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY));
   // automatic default constructor
   G__memfunc_setup("RUN_SUMMARY", 898, G__LumiRawDataStructuresLinkDef_170_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("RUN_SUMMARY", 898, G__LumiRawDataStructuresLinkDef_170_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::RUN_SUMMARY' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~RUN_SUMMARY", 1024, G__LumiRawDataStructuresLinkDef_170_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_170_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::RUN_SUMMARY' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLRUN_QUALITY(void) {
   /* HCAL_HLX::RUN_QUALITY */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY));
   // automatic default constructor
   G__memfunc_setup("RUN_QUALITY", 893, G__LumiRawDataStructuresLinkDef_171_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("RUN_QUALITY", 893, G__LumiRawDataStructuresLinkDef_171_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::RUN_QUALITY' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~RUN_QUALITY", 1019, G__LumiRawDataStructuresLinkDef_171_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_171_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::RUN_QUALITY' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLRCMS_CONFIG(void) {
   /* HCAL_HLX::RCMS_CONFIG */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG));
   // automatic default constructor
   G__memfunc_setup("RCMS_CONFIG", 842, G__LumiRawDataStructuresLinkDef_172_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("RCMS_CONFIG", 842, G__LumiRawDataStructuresLinkDef_172_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::RCMS_CONFIG' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~RCMS_CONFIG", 968, G__LumiRawDataStructuresLinkDef_172_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_172_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::RCMS_CONFIG' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLUMI_SUMMARY(void) {
   /* HCAL_HLX::LUMI_SUMMARY */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY));
   // automatic default constructor
   G__memfunc_setup("LUMI_SUMMARY", 964, G__LumiRawDataStructuresLinkDef_173_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LUMI_SUMMARY", 964, G__LumiRawDataStructuresLinkDef_173_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_SUMMARY' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LUMI_SUMMARY", 1090, G__LumiRawDataStructuresLinkDef_173_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_173_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_SUMMARY' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLUMI_DETAIL(void) {
   /* HCAL_HLX::LUMI_DETAIL */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL));
   // automatic default constructor
   G__memfunc_setup("LUMI_DETAIL", 841, G__LumiRawDataStructuresLinkDef_174_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LUMI_DETAIL", 841, G__LumiRawDataStructuresLinkDef_174_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_DETAIL' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LUMI_DETAIL", 967, G__LumiRawDataStructuresLinkDef_174_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_174_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_DETAIL' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLEVEL1_PATH(void) {
   /* HCAL_HLX::LEVEL1_PATH */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH));
   // automatic default constructor
   G__memfunc_setup("LEVEL1_PATH", 821, G__LumiRawDataStructuresLinkDef_175_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LEVEL1_PATH", 821, G__LumiRawDataStructuresLinkDef_175_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LEVEL1_PATH' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LEVEL1_PATH", 947, G__LumiRawDataStructuresLinkDef_175_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_175_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LEVEL1_PATH' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLEVEL1_TRIGGER(void) {
   /* HCAL_HLX::LEVEL1_TRIGGER */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER));
   // automatic default constructor
   G__memfunc_setup("LEVEL1_TRIGGER", 1052, G__LumiRawDataStructuresLinkDef_176_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LEVEL1_TRIGGER", 1052, G__LumiRawDataStructuresLinkDef_176_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LEVEL1_TRIGGER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LEVEL1_TRIGGER", 1178, G__LumiRawDataStructuresLinkDef_176_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_176_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LEVEL1_TRIGGER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLHLT_PATH(void) {
   /* HCAL_HLX::HLT_PATH */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH));
   // automatic default constructor
   G__memfunc_setup("HLT_PATH", 628, G__LumiRawDataStructuresLinkDef_177_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("HLT_PATH", 628, G__LumiRawDataStructuresLinkDef_177_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::HLT_PATH' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~HLT_PATH", 754, G__LumiRawDataStructuresLinkDef_177_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_177_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::HLT_PATH' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLHLTRIGGER(void) {
   /* HCAL_HLX::HLTRIGGER */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER));
   // automatic default constructor
   G__memfunc_setup("HLTRIGGER", 680, G__LumiRawDataStructuresLinkDef_178_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("HLTRIGGER", 680, G__LumiRawDataStructuresLinkDef_178_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::HLTRIGGER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~HLTRIGGER", 806, G__LumiRawDataStructuresLinkDef_178_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_178_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::HLTRIGGER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLUMI_RAW_HEADER(void) {
   /* HCAL_HLX::LUMI_RAW_HEADER */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER));
   // automatic default constructor
   G__memfunc_setup("LUMI_RAW_HEADER", 1160, G__LumiRawDataStructuresLinkDef_179_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LUMI_RAW_HEADER", 1160, G__LumiRawDataStructuresLinkDef_179_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_RAW_HEADER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LUMI_RAW_HEADER", 1286, G__LumiRawDataStructuresLinkDef_179_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_179_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_RAW_HEADER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLUMI_NIBBLE_HEADER(void) {
   /* HCAL_HLX::LUMI_NIBBLE_HEADER */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER));
   // automatic default constructor
   G__memfunc_setup("LUMI_NIBBLE_HEADER", 1354, G__LumiRawDataStructuresLinkDef_180_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LUMI_NIBBLE_HEADER", 1354, G__LumiRawDataStructuresLinkDef_180_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_NIBBLE_HEADER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LUMI_NIBBLE_HEADER", 1480, G__LumiRawDataStructuresLinkDef_180_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_180_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_NIBBLE_HEADER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLET_SUM_NIBBLE(void) {
   /* HCAL_HLX::ET_SUM_NIBBLE */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE));
   // automatic default constructor
   G__memfunc_setup("ET_SUM_NIBBLE", 1016, G__LumiRawDataStructuresLinkDef_181_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("ET_SUM_NIBBLE", 1016, G__LumiRawDataStructuresLinkDef_181_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::ET_SUM_NIBBLE' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~ET_SUM_NIBBLE", 1142, G__LumiRawDataStructuresLinkDef_181_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_181_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::ET_SUM_NIBBLE' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLOCCUPANCY_NIBBLE(void) {
   /* HCAL_HLX::OCCUPANCY_NIBBLE */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE));
   // automatic default constructor
   G__memfunc_setup("OCCUPANCY_NIBBLE", 1200, G__LumiRawDataStructuresLinkDef_182_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("OCCUPANCY_NIBBLE", 1200, G__LumiRawDataStructuresLinkDef_182_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::OCCUPANCY_NIBBLE' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~OCCUPANCY_NIBBLE", 1326, G__LumiRawDataStructuresLinkDef_182_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_182_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::OCCUPANCY_NIBBLE' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLHC_NIBBLE(void) {
   /* HCAL_HLX::LHC_NIBBLE */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE));
   // automatic default constructor
   G__memfunc_setup("LHC_NIBBLE", 738, G__LumiRawDataStructuresLinkDef_183_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LHC_NIBBLE", 738, G__LumiRawDataStructuresLinkDef_183_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_NIBBLE' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LHC_NIBBLE", 864, G__LumiRawDataStructuresLinkDef_183_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_183_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_NIBBLE' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLUMI_SECTION_HEADER(void) {
   /* HCAL_HLX::LUMI_SECTION_HEADER */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER));
   // automatic default constructor
   G__memfunc_setup("LUMI_SECTION_HEADER", 1459, G__LumiRawDataStructuresLinkDef_184_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LUMI_SECTION_HEADER", 1459, G__LumiRawDataStructuresLinkDef_184_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_SECTION_HEADER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LUMI_SECTION_HEADER", 1585, G__LumiRawDataStructuresLinkDef_184_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_184_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_SECTION_HEADER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLUMI_SECTION_SUB_HEADER(void) {
   /* HCAL_HLX::LUMI_SECTION_SUB_HEADER */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER));
   // automatic default constructor
   G__memfunc_setup("LUMI_SECTION_SUB_HEADER", 1788, G__LumiRawDataStructuresLinkDef_185_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LUMI_SECTION_SUB_HEADER", 1788, G__LumiRawDataStructuresLinkDef_185_0_2, (int) ('i'), 
G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_SECTION_SUB_HEADER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LUMI_SECTION_SUB_HEADER", 1914, G__LumiRawDataStructuresLinkDef_185_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_185_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_SECTION_SUB_HEADER' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLET_SUM_SECTION(void) {
   /* HCAL_HLX::ET_SUM_SECTION */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION));
   // automatic default constructor
   G__memfunc_setup("ET_SUM_SECTION", 1121, G__LumiRawDataStructuresLinkDef_186_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("ET_SUM_SECTION", 1121, G__LumiRawDataStructuresLinkDef_186_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::ET_SUM_SECTION' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~ET_SUM_SECTION", 1247, G__LumiRawDataStructuresLinkDef_186_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_186_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::ET_SUM_SECTION' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLOCCUPANCY_SECTION(void) {
   /* HCAL_HLX::OCCUPANCY_SECTION */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION));
   // automatic default constructor
   G__memfunc_setup("OCCUPANCY_SECTION", 1305, G__LumiRawDataStructuresLinkDef_187_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("OCCUPANCY_SECTION", 1305, G__LumiRawDataStructuresLinkDef_187_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::OCCUPANCY_SECTION' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~OCCUPANCY_SECTION", 1431, G__LumiRawDataStructuresLinkDef_187_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_187_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::OCCUPANCY_SECTION' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLHC_SECTION(void) {
   /* HCAL_HLX::LHC_SECTION */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION));
   // automatic default constructor
   G__memfunc_setup("LHC_SECTION", 843, G__LumiRawDataStructuresLinkDef_188_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LHC_SECTION", 843, G__LumiRawDataStructuresLinkDef_188_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_SECTION' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LHC_SECTION", 969, G__LumiRawDataStructuresLinkDef_188_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_188_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_SECTION' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLUMI_SECTION(void) {
   /* HCAL_HLX::LUMI_SECTION */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION));
   // automatic default constructor
   G__memfunc_setup("LUMI_SECTION", 939, G__LumiRawDataStructuresLinkDef_189_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LUMI_SECTION", 939, G__LumiRawDataStructuresLinkDef_189_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_SECTION' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LUMI_SECTION", 1065, G__LumiRawDataStructuresLinkDef_189_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_189_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LUMI_SECTION' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLDIP_STRUCT_BASE(void) {
   /* HCAL_HLX::DIP_STRUCT_BASE */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE));
   // automatic default constructor
   G__memfunc_setup("DIP_STRUCT_BASE", 1179, G__LumiRawDataStructuresLinkDef_190_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("DIP_STRUCT_BASE", 1179, G__LumiRawDataStructuresLinkDef_190_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::DIP_STRUCT_BASE' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~DIP_STRUCT_BASE", 1305, G__LumiRawDataStructuresLinkDef_190_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_190_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::DIP_STRUCT_BASE' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLVDM_SCAN_DATA(void) {
   /* HCAL_HLX::VDM_SCAN_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA));
   // automatic default constructor
   G__memfunc_setup("VDM_SCAN_DATA", 996, G__LumiRawDataStructuresLinkDef_191_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("VDM_SCAN_DATA", 996, G__LumiRawDataStructuresLinkDef_191_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::VDM_SCAN_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~VDM_SCAN_DATA", 1122, G__LumiRawDataStructuresLinkDef_191_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_191_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::VDM_SCAN_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLBRAN_DATA(void) {
   /* HCAL_HLX::BRAN_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA));
   // automatic default constructor
   G__memfunc_setup("BRAN_DATA", 668, G__LumiRawDataStructuresLinkDef_192_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("BRAN_DATA", 668, G__LumiRawDataStructuresLinkDef_192_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::BRAN_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~BRAN_DATA", 794, G__LumiRawDataStructuresLinkDef_192_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_192_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::BRAN_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLBRAN_BX_DATA(void) {
   /* HCAL_HLX::BRAN_BX_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA));
   // automatic default constructor
   G__memfunc_setup("BRAN_BX_DATA", 917, G__LumiRawDataStructuresLinkDef_193_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("BRAN_BX_DATA", 917, G__LumiRawDataStructuresLinkDef_193_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::BRAN_BX_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~BRAN_BX_DATA", 1043, G__LumiRawDataStructuresLinkDef_193_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_193_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::BRAN_BX_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_CONFIG(void) {
   /* HCAL_HLX::LHC_BEAM_CONFIG */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG));
   // automatic default constructor
   G__memfunc_setup("LHC_BEAM_CONFIG", 1120, G__LumiRawDataStructuresLinkDef_194_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LHC_BEAM_CONFIG", 1120, G__LumiRawDataStructuresLinkDef_194_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_CONFIG' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LHC_BEAM_CONFIG", 1246, G__LumiRawDataStructuresLinkDef_194_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_194_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_CONFIG' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLHC_FILL_DATA(void) {
   /* HCAL_HLX::LHC_FILL_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA));
   // automatic default constructor
   G__memfunc_setup("LHC_FILL_DATA", 982, G__LumiRawDataStructuresLinkDef_195_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LHC_FILL_DATA", 982, G__LumiRawDataStructuresLinkDef_195_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_FILL_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LHC_FILL_DATA", 1108, G__LumiRawDataStructuresLinkDef_195_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_195_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_FILL_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLCMS_LUMI_DIP_DATA(void) {
   /* HCAL_HLX::CMS_LUMI_DIP_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA));
   // automatic default constructor
   G__memfunc_setup("CMS_LUMI_DIP_DATA", 1326, G__LumiRawDataStructuresLinkDef_196_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("CMS_LUMI_DIP_DATA", 1326, G__LumiRawDataStructuresLinkDef_196_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::CMS_LUMI_DIP_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~CMS_LUMI_DIP_DATA", 1452, G__LumiRawDataStructuresLinkDef_196_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_196_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::CMS_LUMI_DIP_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLTRIGGER_LUMI_SEGMENT(void) {
   /* HCAL_HLX::TRIGGER_LUMI_SEGMENT */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT));
   // automatic default constructor
   G__memfunc_setup("TRIGGER_LUMI_SEGMENT", 1564, G__LumiRawDataStructuresLinkDef_199_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("TRIGGER_LUMI_SEGMENT", 1564, G__LumiRawDataStructuresLinkDef_199_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::TRIGGER_LUMI_SEGMENT' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~TRIGGER_LUMI_SEGMENT", 1690, G__LumiRawDataStructuresLinkDef_199_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_199_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::TRIGGER_LUMI_SEGMENT' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_MODE_DATA(void) {
   /* HCAL_HLX::LHC_BEAM_MODE_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA));
   // automatic default constructor
   G__memfunc_setup("LHC_BEAM_MODE_DATA", 1352, G__LumiRawDataStructuresLinkDef_200_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LHC_BEAM_MODE_DATA", 1352, G__LumiRawDataStructuresLinkDef_200_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_MODE_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LHC_BEAM_MODE_DATA", 1478, G__LumiRawDataStructuresLinkDef_200_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_200_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_MODE_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_ENERGY_DATA(void) {
   /* HCAL_HLX::LHC_BEAM_ENERGY_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA));
   // automatic default constructor
   G__memfunc_setup("LHC_BEAM_ENERGY_DATA", 1517, G__LumiRawDataStructuresLinkDef_201_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LHC_BEAM_ENERGY_DATA", 1517, G__LumiRawDataStructuresLinkDef_201_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_ENERGY_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LHC_BEAM_ENERGY_DATA", 1643, G__LumiRawDataStructuresLinkDef_201_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_201_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_ENERGY_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA(void) {
   /* HCAL_HLX::LHC_BEAM_INTENSITY_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA));
   // automatic default constructor
   G__memfunc_setup("LHC_BEAM_INTENSITY_DATA", 1770, G__LumiRawDataStructuresLinkDef_202_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LHC_BEAM_INTENSITY_DATA", 1770, G__LumiRawDataStructuresLinkDef_202_0_2, (int) ('i'), 
G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_INTENSITY_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LHC_BEAM_INTENSITY_DATA", 1896, G__LumiRawDataStructuresLinkDef_202_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_202_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_INTENSITY_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA(void) {
   /* HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA));
   // automatic default constructor
   G__memfunc_setup("LHC_BEAM_FBCT_INTENSITY_DATA", 2152, G__LumiRawDataStructuresLinkDef_203_0_1, (int) ('i'), 
G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("LHC_BEAM_FBCT_INTENSITY_DATA", 2152, G__LumiRawDataStructuresLinkDef_203_0_2, (int) ('i'), 
G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~LHC_BEAM_FBCT_INTENSITY_DATA", 2278, G__LumiRawDataStructuresLinkDef_203_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_203_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLBEAM_INFO(void) {
   /* HCAL_HLX::BEAM_INFO */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO));
   // automatic default constructor
   G__memfunc_setup("BEAM_INFO", 672, G__LumiRawDataStructuresLinkDef_206_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("BEAM_INFO", 672, G__LumiRawDataStructuresLinkDef_206_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::BEAM_INFO' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~BEAM_INFO", 798, G__LumiRawDataStructuresLinkDef_206_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_206_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::BEAM_INFO' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLBRANA_INFO(void) {
   /* HCAL_HLX::BRANA_INFO */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO));
   // automatic default constructor
   G__memfunc_setup("BRANA_INFO", 751, G__LumiRawDataStructuresLinkDef_207_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("BRANA_INFO", 751, G__LumiRawDataStructuresLinkDef_207_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::BRANA_INFO' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~BRANA_INFO", 877, G__LumiRawDataStructuresLinkDef_207_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_207_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::BRANA_INFO' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLBRANP_INFO(void) {
   /* HCAL_HLX::BRANP_INFO */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO));
   // automatic default constructor
   G__memfunc_setup("BRANP_INFO", 766, G__LumiRawDataStructuresLinkDef_208_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("BRANP_INFO", 766, G__LumiRawDataStructuresLinkDef_208_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::BRANP_INFO' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~BRANP_INFO", 892, G__LumiRawDataStructuresLinkDef_208_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_208_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::BRANP_INFO' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLBRAN_INFO(void) {
   /* HCAL_HLX::BRAN_INFO */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO));
   // automatic default constructor
   G__memfunc_setup("BRAN_INFO", 686, G__LumiRawDataStructuresLinkDef_209_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("BRAN_INFO", 686, G__LumiRawDataStructuresLinkDef_209_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::BRAN_INFO' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~BRAN_INFO", 812, G__LumiRawDataStructuresLinkDef_209_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_209_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::BRAN_INFO' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}

static void G__setup_memfuncHCAL_HLXcLcLDIP_COMBINED_DATA(void) {
   /* HCAL_HLX::DIP_COMBINED_DATA */
   G__tag_memfunc_setup(G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA));
   // automatic default constructor
   G__memfunc_setup("DIP_COMBINED_DATA", 1270, G__LumiRawDataStructuresLinkDef_210_0_1, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA), -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic copy constructor
   G__memfunc_setup("DIP_COMBINED_DATA", 1270, G__LumiRawDataStructuresLinkDef_210_0_2, (int) ('i'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA), -1, 0, 1, 1, 1, 0, "u 'HCAL_HLX::DIP_COMBINED_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   // automatic destructor
   G__memfunc_setup("~DIP_COMBINED_DATA", 1396, G__LumiRawDataStructuresLinkDef_210_0_3, (int) ('y'), -1, -1, 0, 0, 1, 1, 0, "", (char*) NULL, (void*) NULL, 0);
   // automatic assignment operator
   G__memfunc_setup("operator=", 937, G__LumiRawDataStructuresLinkDef_210_0_4, (int) ('u'), G__get_linked_tagnum(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA), -1, 1, 1, 1, 1, 0, "u 'HCAL_HLX::DIP_COMBINED_DATA' - 11 - -", (char*) NULL, (void*) NULL, 0);
   G__tag_memfunc_reset();
}


/*********************************************************
* Member function information setup
*********************************************************/
extern "C" void G__cpp_setup_memfuncLumiRawDataStructuresLinkDef() {
}

/*********************************************************
* Global variable information setup for each class
*********************************************************/
static void G__cpp_setup_global0() {

   /* Setting up global variables */
   G__resetplocal();

}

static void G__cpp_setup_global1() {

   G__resetglobalenv();
}
extern "C" void G__cpp_setup_globalLumiRawDataStructuresLinkDef() {
  G__cpp_setup_global0();
  G__cpp_setup_global1();
}

/*********************************************************
* Global function information setup for each class
*********************************************************/
static void G__cpp_setup_func0() {
   G__lastifuncposition();

}

static void G__cpp_setup_func1() {
}

static void G__cpp_setup_func2() {
}

static void G__cpp_setup_func3() {
}

static void G__cpp_setup_func4() {
}

static void G__cpp_setup_func5() {
}

static void G__cpp_setup_func6() {
}

static void G__cpp_setup_func7() {
}

static void G__cpp_setup_func8() {
}

static void G__cpp_setup_func9() {
}

static void G__cpp_setup_func10() {
}

static void G__cpp_setup_func11() {
}

static void G__cpp_setup_func12() {

   G__resetifuncposition();
}

extern "C" void G__cpp_setup_funcLumiRawDataStructuresLinkDef() {
  G__cpp_setup_func0();
  G__cpp_setup_func1();
  G__cpp_setup_func2();
  G__cpp_setup_func3();
  G__cpp_setup_func4();
  G__cpp_setup_func5();
  G__cpp_setup_func6();
  G__cpp_setup_func7();
  G__cpp_setup_func8();
  G__cpp_setup_func9();
  G__cpp_setup_func10();
  G__cpp_setup_func11();
  G__cpp_setup_func12();
}

/*********************************************************
* Class,struct,union,enum tag information setup
*********************************************************/
/* Setup class/struct taginfo */
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_vectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgR = { "vector<ROOT::TSchemaHelper,allocator<ROOT::TSchemaHelper> >" , 99 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgRcLcLiteratorgR = { "reverse_iterator<vector<ROOT::TSchemaHelper,allocator<ROOT::TSchemaHelper> >::iterator>" , 99 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_vectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgR = { "vector<TVirtualArray*,allocator<TVirtualArray*> >" , 99 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgRcLcLiteratorgR = { "reverse_iterator<vector<TVirtualArray*,allocator<TVirtualArray*> >::iterator>" , 99 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLX = { "HCAL_HLX" , 110 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT = { "HCAL_HLX::DAQ_HEART_BEAT" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY = { "HCAL_HLX::RUN_SUMMARY" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY = { "HCAL_HLX::RUN_QUALITY" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG = { "HCAL_HLX::RCMS_CONFIG" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY = { "HCAL_HLX::LUMI_SUMMARY" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL = { "HCAL_HLX::LUMI_DETAIL" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH = { "HCAL_HLX::LEVEL1_PATH" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER = { "HCAL_HLX::LEVEL1_TRIGGER" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH = { "HCAL_HLX::HLT_PATH" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER = { "HCAL_HLX::HLTRIGGER" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER = { "HCAL_HLX::LUMI_RAW_HEADER" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER = { "HCAL_HLX::LUMI_NIBBLE_HEADER" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE = { "HCAL_HLX::ET_SUM_NIBBLE" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE = { "HCAL_HLX::OCCUPANCY_NIBBLE" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE = { "HCAL_HLX::LHC_NIBBLE" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER = { "HCAL_HLX::LUMI_SECTION_HEADER" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER = { "HCAL_HLX::LUMI_SECTION_SUB_HEADER" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION = { "HCAL_HLX::ET_SUM_SECTION" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION = { "HCAL_HLX::OCCUPANCY_SECTION" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION = { "HCAL_HLX::LHC_SECTION" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION = { "HCAL_HLX::LUMI_SECTION" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE = { "HCAL_HLX::DIP_STRUCT_BASE" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA = { "HCAL_HLX::VDM_SCAN_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA = { "HCAL_HLX::BRAN_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA = { "HCAL_HLX::BRAN_BX_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG = { "HCAL_HLX::LHC_BEAM_CONFIG" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA = { "HCAL_HLX::LHC_FILL_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA = { "HCAL_HLX::CMS_LUMI_DIP_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT = { "HCAL_HLX::TRIGGER_LUMI_SEGMENT" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA = { "HCAL_HLX::LHC_BEAM_MODE_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA = { "HCAL_HLX::LHC_BEAM_ENERGY_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA = { "HCAL_HLX::LHC_BEAM_INTENSITY_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA = { "HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO = { "HCAL_HLX::BEAM_INFO" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO = { "HCAL_HLX::BRANA_INFO" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO = { "HCAL_HLX::BRANP_INFO" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO = { "HCAL_HLX::BRAN_INFO" , 115 , -1 };
G__linked_taginfo G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA = { "HCAL_HLX::DIP_COMBINED_DATA" , 115 , -1 };

/* Reset class/struct taginfo */
extern "C" void G__cpp_reset_tagtableLumiRawDataStructuresLinkDef() {
  G__LumiRawDataStructuresLinkDefLN_vectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgR.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgRcLcLiteratorgR.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_vectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgR.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgRcLcLiteratorgR.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLX.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO.tagnum = -1 ;
  G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA.tagnum = -1 ;
}


extern "C" void G__cpp_setup_tagtableLumiRawDataStructuresLinkDef() {

   /* Setting up class,struct,union tag entry */
   G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_vectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgR);
   G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlEROOTcLcLTSchemaHelpercOallocatorlEROOTcLcLTSchemaHelpergRsPgRcLcLiteratorgR);
   G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_vectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgR);
   G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_reverse_iteratorlEvectorlETVirtualArraymUcOallocatorlETVirtualArraymUgRsPgRcLcLiteratorgR);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLX),0,-1,0,(char*)NULL,G__setup_memvarHCAL_HLX,G__setup_memfuncHCAL_HLX);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDAQ_HEART_BEAT),sizeof(HCAL_HLX::DAQ_HEART_BEAT),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLDAQ_HEART_BEAT,G__setup_memfuncHCAL_HLXcLcLDAQ_HEART_BEAT);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_SUMMARY),sizeof(HCAL_HLX::RUN_SUMMARY),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLRUN_SUMMARY,G__setup_memfuncHCAL_HLXcLcLRUN_SUMMARY);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRUN_QUALITY),sizeof(HCAL_HLX::RUN_QUALITY),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLRUN_QUALITY,G__setup_memfuncHCAL_HLXcLcLRUN_QUALITY);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLRCMS_CONFIG),sizeof(HCAL_HLX::RCMS_CONFIG),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLRCMS_CONFIG,G__setup_memfuncHCAL_HLXcLcLRCMS_CONFIG);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SUMMARY),sizeof(HCAL_HLX::LUMI_SUMMARY),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLUMI_SUMMARY,G__setup_memfuncHCAL_HLXcLcLLUMI_SUMMARY);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_DETAIL),sizeof(HCAL_HLX::LUMI_DETAIL),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLUMI_DETAIL,G__setup_memfuncHCAL_HLXcLcLLUMI_DETAIL);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_PATH),sizeof(HCAL_HLX::LEVEL1_PATH),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLEVEL1_PATH,G__setup_memfuncHCAL_HLXcLcLLEVEL1_PATH);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLEVEL1_TRIGGER),sizeof(HCAL_HLX::LEVEL1_TRIGGER),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLEVEL1_TRIGGER,G__setup_memfuncHCAL_HLXcLcLLEVEL1_TRIGGER);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLT_PATH),sizeof(HCAL_HLX::HLT_PATH),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLHLT_PATH,G__setup_memfuncHCAL_HLXcLcLHLT_PATH);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLHLTRIGGER),sizeof(HCAL_HLX::HLTRIGGER),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLHLTRIGGER,G__setup_memfuncHCAL_HLXcLcLHLTRIGGER);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_RAW_HEADER),sizeof(HCAL_HLX::LUMI_RAW_HEADER),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLUMI_RAW_HEADER,G__setup_memfuncHCAL_HLXcLcLLUMI_RAW_HEADER);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_NIBBLE_HEADER),sizeof(HCAL_HLX::LUMI_NIBBLE_HEADER),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLUMI_NIBBLE_HEADER,G__setup_memfuncHCAL_HLXcLcLLUMI_NIBBLE_HEADER);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_NIBBLE),sizeof(HCAL_HLX::ET_SUM_NIBBLE),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLET_SUM_NIBBLE,G__setup_memfuncHCAL_HLXcLcLET_SUM_NIBBLE);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_NIBBLE),sizeof(HCAL_HLX::OCCUPANCY_NIBBLE),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLOCCUPANCY_NIBBLE,G__setup_memfuncHCAL_HLXcLcLOCCUPANCY_NIBBLE);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_NIBBLE),sizeof(HCAL_HLX::LHC_NIBBLE),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLHC_NIBBLE,G__setup_memfuncHCAL_HLXcLcLLHC_NIBBLE);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_HEADER),sizeof(HCAL_HLX::LUMI_SECTION_HEADER),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLUMI_SECTION_HEADER,G__setup_memfuncHCAL_HLXcLcLLUMI_SECTION_HEADER);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION_SUB_HEADER),sizeof(HCAL_HLX::LUMI_SECTION_SUB_HEADER),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLUMI_SECTION_SUB_HEADER,G__setup_memfuncHCAL_HLXcLcLLUMI_SECTION_SUB_HEADER);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLET_SUM_SECTION),sizeof(HCAL_HLX::ET_SUM_SECTION),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLET_SUM_SECTION,G__setup_memfuncHCAL_HLXcLcLET_SUM_SECTION);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLOCCUPANCY_SECTION),sizeof(HCAL_HLX::OCCUPANCY_SECTION),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLOCCUPANCY_SECTION,G__setup_memfuncHCAL_HLXcLcLOCCUPANCY_SECTION);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_SECTION),sizeof(HCAL_HLX::LHC_SECTION),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLHC_SECTION,G__setup_memfuncHCAL_HLXcLcLLHC_SECTION);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLUMI_SECTION),sizeof(HCAL_HLX::LUMI_SECTION),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLUMI_SECTION,G__setup_memfuncHCAL_HLXcLcLLUMI_SECTION);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_STRUCT_BASE),sizeof(HCAL_HLX::DIP_STRUCT_BASE),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLDIP_STRUCT_BASE,G__setup_memfuncHCAL_HLXcLcLDIP_STRUCT_BASE);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLVDM_SCAN_DATA),sizeof(HCAL_HLX::VDM_SCAN_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLVDM_SCAN_DATA,G__setup_memfuncHCAL_HLXcLcLVDM_SCAN_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_DATA),sizeof(HCAL_HLX::BRAN_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLBRAN_DATA,G__setup_memfuncHCAL_HLXcLcLBRAN_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_BX_DATA),sizeof(HCAL_HLX::BRAN_BX_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLBRAN_BX_DATA,G__setup_memfuncHCAL_HLXcLcLBRAN_BX_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_CONFIG),sizeof(HCAL_HLX::LHC_BEAM_CONFIG),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLHC_BEAM_CONFIG,G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_CONFIG);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_FILL_DATA),sizeof(HCAL_HLX::LHC_FILL_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLHC_FILL_DATA,G__setup_memfuncHCAL_HLXcLcLLHC_FILL_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLCMS_LUMI_DIP_DATA),sizeof(HCAL_HLX::CMS_LUMI_DIP_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLCMS_LUMI_DIP_DATA,G__setup_memfuncHCAL_HLXcLcLCMS_LUMI_DIP_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLTRIGGER_LUMI_SEGMENT),sizeof(HCAL_HLX::TRIGGER_LUMI_SEGMENT),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLTRIGGER_LUMI_SEGMENT,G__setup_memfuncHCAL_HLXcLcLTRIGGER_LUMI_SEGMENT);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_MODE_DATA),sizeof(HCAL_HLX::LHC_BEAM_MODE_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLHC_BEAM_MODE_DATA,G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_MODE_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_ENERGY_DATA),sizeof(HCAL_HLX::LHC_BEAM_ENERGY_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLHC_BEAM_ENERGY_DATA,G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_ENERGY_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA),sizeof(HCAL_HLX::LHC_BEAM_INTENSITY_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA,G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_INTENSITY_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA),sizeof(HCAL_HLX::LHC_BEAM_FBCT_INTENSITY_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA,G__setup_memfuncHCAL_HLXcLcLLHC_BEAM_FBCT_INTENSITY_DATA);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBEAM_INFO),sizeof(HCAL_HLX::BEAM_INFO),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLBEAM_INFO,G__setup_memfuncHCAL_HLXcLcLBEAM_INFO);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANA_INFO),sizeof(HCAL_HLX::BRANA_INFO),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLBRANA_INFO,G__setup_memfuncHCAL_HLXcLcLBRANA_INFO);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRANP_INFO),sizeof(HCAL_HLX::BRANP_INFO),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLBRANP_INFO,G__setup_memfuncHCAL_HLXcLcLBRANP_INFO);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLBRAN_INFO),sizeof(HCAL_HLX::BRAN_INFO),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLBRAN_INFO,G__setup_memfuncHCAL_HLXcLcLBRAN_INFO);
   G__tagtable_setup(G__get_linked_tagnum_fwd(&G__LumiRawDataStructuresLinkDefLN_HCAL_HLXcLcLDIP_COMBINED_DATA),sizeof(HCAL_HLX::DIP_COMBINED_DATA),-1,262144,(char*)NULL,G__setup_memvarHCAL_HLXcLcLDIP_COMBINED_DATA,G__setup_memfuncHCAL_HLXcLcLDIP_COMBINED_DATA);
}
extern "C" void G__cpp_setupLumiRawDataStructuresLinkDef(void) {
  G__check_setup_version(30051515,"G__cpp_setupLumiRawDataStructuresLinkDef()");
  G__set_cpp_environmentLumiRawDataStructuresLinkDef();
  G__cpp_setup_tagtableLumiRawDataStructuresLinkDef();

  G__cpp_setup_inheritanceLumiRawDataStructuresLinkDef();

  G__cpp_setup_typetableLumiRawDataStructuresLinkDef();

  G__cpp_setup_memvarLumiRawDataStructuresLinkDef();

  G__cpp_setup_memfuncLumiRawDataStructuresLinkDef();
  G__cpp_setup_globalLumiRawDataStructuresLinkDef();
  G__cpp_setup_funcLumiRawDataStructuresLinkDef();

   if(0==G__getsizep2memfunc()) G__get_sizep2memfuncLumiRawDataStructuresLinkDef();
  return;
}
class G__cpp_setup_initLumiRawDataStructuresLinkDef {
  public:
    G__cpp_setup_initLumiRawDataStructuresLinkDef() { G__add_setup_func("LumiRawDataStructuresLinkDef",(G__incsetup)(&G__cpp_setupLumiRawDataStructuresLinkDef)); G__call_setup_funcs(); }
   ~G__cpp_setup_initLumiRawDataStructuresLinkDef() { G__remove_setup_func("LumiRawDataStructuresLinkDef"); }
};
G__cpp_setup_initLumiRawDataStructuresLinkDef G__cpp_setup_initializerLumiRawDataStructuresLinkDef;

